/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export let FinancialChart = /*@__PURE__*/ (() => {
    class FinancialChart extends XYChart {
        constructor() {
            super();
            this.ad5 = null;
            this.ag3 = null;
            this.ag1 = null;
            this.agy = null;
            this.ag0 = null;
            this.ag2 = null;
            this.agz = null;
            this.adb = null;
            this.ahl = null;
            this.ahm = null;
            this.ahi = null;
            this.ahn = null;
            this.aho = null;
            this.ahj = null;
            this.ahk = null;
            this.aet = null;
            this.af3 = 40;
            this.adz = null;
            this.adx = null;
            this.ad1 = null;
            this.ad6 = null;
            this.ahw = null;
            this.aep = null;
            this.aff = false;
            this.afe = false;
            this.afm = false;
            this.ae1 = false;
            this.ag9 = 10;
            this.aga = NaN;
            this.agc = NaN;
            this.agb = NaN;
            this.agd = 0;
            this.adh = 0;
            this.adk = 0;
            this.af5 = 3;
            this.af8 = NaN;
            this.af6 = NaN;
            this.af7 = NaN;
            this.af9 = NaN;
            this.adm = 0;
            this.aew = true;
            this.add = 0;
            this.aex = false;
            this.adr = null;
            this.adt = null;
            this.afo = null;
            this.aez = true;
            this.aey = false;
            this.ae0 = false;
            this.aeq = null;
            this.ado = 1;
            this.acf = null;
            this.acg = null;
            this.ach = null;
            this.aci = null;
            this.ack = null;
            this.acj = null;
            this.ace = null;
            this.acd = null;
            this.af4 = 1;
            this.af2 = 1;
            this.af1 = 2;
            this.af0 = 1;
            this.ad3 = null;
            this.ag5 = -2147483648;
            this.afz = 2;
            this.ag8 = 3;
            this.ag6 = 10;
            this.ag4 = 30;
            this.ag7 = 9;
            this.ac8 = null;
            this.ac9 = null;
            this.ac4 = null;
            this.applyCustomIndicators = null;
            this.alq = null;
            this.age = 1;
            this.aev = false;
            this.adv = null;
            this.afw = dateMinValue();
            this.afv = dateMaxValue();
            this.aft = null;
            this.q9();
            this.aft = new ObservableCollection$1(Base.$, 0);
            if (this.xAxisBreaks != null) {
                let a = this.xAxisBreaks;
                a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.alf());
            }
            this.ak0();
        }
        sf(a, b, c) {
            super.sf(a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.adc = new FinancialChartToolbar(this, this.aht);
                    break;
                case "Toolbar":
                    let d = b;
                    if (d != null) {
                        d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.akn));
                        d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.akq));
                        d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.akr));
                        d.l(null);
                    }
                    if (this.adc != null) {
                        this.adc.ac = this.adj;
                        this.adc.ai = this.dj;
                        this.adc.y = this.ade;
                        this.adc.al = this.afc;
                        if (this.ag0 != null) {
                            this.adc.l(this.ag0);
                        }
                        let e = this.adc;
                        e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.akn));
                        ;
                        let f = this.adc;
                        f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.akq));
                        let g = this.adc;
                        g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.akr));
                    }
                    break;
                case "ChartType":
                    if (this.adc != null) {
                        this.adc.y = this.ade;
                    }
                    break;
                case "VolumeType":
                    if (this.adc != null) {
                        this.adc.ac = this.adj;
                    }
                    break;
                case "TrendLineType":
                    if (this.adc != null) {
                        this.adc.ai = this.dj;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.adc == null) {
                        break;
                    }
                    this.adc.al = this.afc;
                    this.setGridRows();
                    break;
            }
        }
        akr(a, b) {
            this.adj = this.adc.ac;
        }
        akq(a, b) {
            this.dj = this.adc.ai;
        }
        akn(a, b) {
            this.ade = this.adc.y;
        }
        ak0() {
            this.ad5 = new IndicatorPane();
            this.adw = TypeRegistrar.create("FinancialLegend");
        }
        provideGrid(a) {
            this.ag3 = a;
            this.all();
            this.setGridRows();
            if (this.adc != null) {
                this.adc.bg(a);
            }
        }
        onDocumentClick(a) {
            if (this.adc != null) {
                this.adc.bl(a);
            }
        }
        getContext() {
            let a = this.adc.v();
            let b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.ju;
            b.toolbarContainer = this.ag0;
            b.legendContainer = this.agz;
            b.indicatorsContainer = this.agy;
            b.volumeContainer = this.ag1;
            b.zoomContainer = this.ag2;
            return b;
        }
        provideContainer(a) {
            let b = a;
            if (b != null) {
                let c = "financialChartMainGrid";
                let d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.adc == null) {
                    this.adc = new FinancialChartToolbar(this, this.aht);
                }
                this.adc.w.isIndicatorMenuVisible = this.ae3 && this.ae4;
                this.ag0 = b.getSubRenderer(d);
                this.adc.l(this.ag0);
                let e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                let f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.agz = b.getSubRenderer(f);
                let g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.agy = b.getSubRenderer(g);
                let h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.ag1 = b.getSubRenderer(h);
                let i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.ag2 = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.ag0 = null;
                if (this.adc != null) {
                    this.adc.l(null);
                }
                if (this.aeu != null) {
                    this.aeu.provideContainer(null);
                    this.aeu = null;
                }
                if (this.adw != null) {
                    this.adw.provideContainer(null);
                }
            }
            super.provideContainer(a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.provideContainer(this.ag1);
                }
                if (this.ad5 != null) {
                    this.ad5.h(this.agy);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.provideContainer(this.ag2);
                    if (a != null) {
                        this.aj7();
                    }
                    else {
                        this.aeu = null;
                    }
                }
                if (this.adw != null) {
                    this.adw.provideContainer(this.agz);
                }
                this.setGridRows();
            }
        }
        alb(a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.provideContainer(c);
            }
            this.setGridRows();
        }
        alp(a, b) {
            this.alb(a, b, this.ag2);
            if (b == null) {
                return;
            }
            this.aj7();
        }
        aj7() {
            if (this.ag2 == null) {
                return;
            }
            if (this.aeu != null) {
                this.aeu.provideContainer(null);
            }
            this.aeu = TypeRegistrar.create("ZoomSlider");
            this.aeu.provideContainer(this.ag2);
            let a = this.aeu;
            a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
                if (this.dataChart != null) {
                    this.dataChart.tp = new Rect(0, this.aeu.windowRect.left, this.dataChart.s9.top, this.aeu.windowRect.width, this.dataChart.s9.height);
                }
            });
            this.aj8();
        }
        aln(a, b) {
            this.alb(a, b, this.ag1);
        }
        setGridRows() {
            if (this.ag3 == null) {
                return;
            }
            let a = new Array(6);
            a[0] = (this.afc ? this.agk : 0) + "px";
            a[1] = this.ae8 ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.aeu != null) {
                if (a[5] == "0px") {
                    this.aeu.hide();
                }
                else {
                    this.aeu.show();
                }
            }
            this.ag3.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
            this.ag3.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
            if (this.ju == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.ad5 != null) {
                this.ad5.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.aeu != null) {
                this.aeu.notifySizeChanged();
            }
        }
        rr() {
            super.rr();
            this.vr = 1;
            this.aa6 = 0;
            this.xo = 0;
            this.ab0 = null;
            this.abt = AxisDefaults.g;
            this.w8 = AxisDefaults.e;
            this.w7 = AxisDefaults.f;
            this.abu = AxisDefaults.j;
            this.abq = null;
            this.alr = AxisDefaults.h;
            this.agx = AxisDefaults.b;
            this.fj = true;
            this.fc = true;
            this.fd = false;
            this.a7 = 0;
            this.hw = Defaults.j;
            this.t1 = Defaults.ae;
            this.tw = Defaults.af;
            this.tx = Defaults.ag;
            this.ih = NaN;
            this.h8 = 40;
            this.fs = true;
            this.fy = false;
            if (this.dataChart != null) {
                let a = this.dataChart.cu.j.e();
                this.acn = a.d;
                this.aco = a.e;
                this.acm = a.d;
                this.alr = this.dataChart.xu;
            }
            let b = new BrushCollection();
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            let c = new BrushCollection();
            for (let d of fromEnum(b)) {
                c.add(BrushUtil.m(d, 0.3));
            }
            this.acp = c;
            this.acq = b;
        }
        ak7() {
            if (this.ad5 != null) {
                this.ad5.b = null;
                this.ad5.b = this.indicatorCharts;
            }
            this.setGridRows();
        }
        ak8() {
            this.setGridRows();
        }
        alh() {
            this.ak7();
        }
        aj6() {
            if (this.aeu == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            let a = this.ju.rootWrapper.width();
            let b = this.dataChart.to.left + this.dataChart.to.width;
            let c = this.dataChart.to.left;
            let d = a - b;
            this.aeu.startInset = c - this.aeu.trackStartInset;
            this.aeu.endInset = d - this.aeu.trackEndInset;
            if (this.aeu.endInset < 0) {
                let e = this.aeu.endInset;
                this.aeu.endInset = 0;
                this.dataChart.g1 += (e * -1);
            }
            if (this.aeu.startInset < 0) {
                let f = this.aeu.startInset;
                this.aeu.startInset = 0;
                this.dataChart.gw += (f * -1);
            }
            this.zoomSliderChart.gw = c;
            this.zoomSliderChart.g1 = d;
            this.zoomSliderChart.gj = this.aeu.barExtent;
        }
        akx() {
            this.aj6();
        }
        ro(a) {
            super.ro(a);
            if (a != null) {
                a.gi = 0;
            }
        }
        als(a) {
            return a.s2();
        }
        alv() {
            return this.agz == null ? null : this.alu(this.agz.rootWrapper);
        }
        alt(a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.alu(a.d.rootWrapper);
        }
        alu(a) {
            if (a == null) {
                return null;
            }
            let b = a.getOffset();
            return new Rect(0, b.left, b.top, a.width(), a.height());
        }
        agf() {
            if (this.ag3 == null) {
                return NaN;
            }
            let a = this.ag3.getOffset();
            return this.ag3.width() + (a == null ? 0 : a.left);
        }
        rz(source_, a, b) {
            super.rz(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mg(source_, a, b);
            }
        }
        r0(source_, a, b) {
            super.r0(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mh(source_, a, b);
            }
        }
        ry(source_) {
            super.ry(source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.l9(source_);
            }
        }
        r2(source_, a, b, c) {
            super.r2(source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mi(source_, a, b, c);
            }
        }
        ru(a, b) {
            super.ru(a, b);
            if (this.ae9(a)) {
                a.toolTip = null;
            }
        }
        get adc() {
            return this.adb;
        }
        set adc(a) {
            let b = this.adc;
            if (a != b) {
                this.adb = a;
                this.sd("Toolbar", b, this.adc);
            }
        }
        get ahs() {
            return this.ahl;
        }
        set ahs(a) {
            let b = this.ahs;
            if (a != b) {
                this.ahl = a;
                this.sd("RangeSelectorTemplate", b, this.ahs);
            }
        }
        get aht() {
            return this.ahm;
        }
        set aht(a) {
            let b = this.aht;
            if (a != b) {
                this.ahm = a;
                this.sd("ToolbarTemplate", b, this.aht);
            }
        }
        get ahp() {
            return this.ahi;
        }
        set ahp(a) {
            let b = this.ahp;
            if (a != b) {
                this.ahi = a;
                this.sd("ChartTypePickerTemplate", b, this.ahp);
            }
        }
        get ahu() {
            return this.ahn;
        }
        set ahu(a) {
            let b = this.ahu;
            if (a != b) {
                this.ahn = a;
                this.sd("TrendLineTypePickerTemplate", b, this.ahu);
            }
        }
        get ahv() {
            return this.aho;
        }
        set ahv(a) {
            let b = this.ahv;
            if (a != b) {
                this.aho = a;
                this.sd("VolumeTypePickerTemplate", b, this.ahv);
            }
        }
        get ahq() {
            return this.ahj;
        }
        set ahq(a) {
            let b = this.ahq;
            if (a != b) {
                this.ahj = a;
                this.sd("IndicatorMenuTemplate", b, this.ahq);
            }
        }
        get ahr() {
            return this.ahk;
        }
        set ahr(a) {
            let b = this.ahr;
            if (a != b) {
                this.ahk = a;
                this.sd("OverlayPickerTemplate", b, this.ahr);
            }
        }
        get aeu() {
            return this.aet;
        }
        set aeu(a) {
            let b = this.aeu;
            if (a != b) {
                this.aet = a;
                this.sd("ZoomSlider", b, this.aeu);
            }
        }
        get_h8() {
            return super.get_h8();
        }
        set_h8(a) {
            super.set_h8(a);
        }
        get_fs() {
            return super.get_fs();
        }
        set_fs(a) {
            super.set_fs(a);
        }
        get agk() {
            return this.af3;
        }
        set agk(a) {
            let b = this.agk;
            if (a != b) {
                this.af3 = a;
                this.sd("ToolbarHeight", b, this.agk);
            }
        }
        vg() {
            return this.xAxis;
        }
        vh() {
            return this.yAxis;
        }
        onAttachedToUI() {
            super.onAttachedToUI();
            if (this.aeu != null) {
                this.aeu.onAttachedToUI();
            }
        }
        onDetachedFromUI() {
            super.onDetachedFromUI();
            if (this.aeu != null) {
                this.aeu.onDetachedFromUI();
            }
        }
        ba(a) {
            return 20;
        }
        get_gf() {
            return ((() => {
                let $ret = new List$1(DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        }
        get gf() {
            return this.get_gf();
        }
        get_ge() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleFinancialPriceSeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get ge() {
            return this.get_ge();
        }
        acy(a) {
            return this.acz(a);
        }
        aec(a) {
            return this.aed(a);
        }
        acx(a) {
            let b = this.acy(0);
            b.name = a;
            return b;
        }
        q5() {
            this.xAxis = this.acx("xAxis");
            this.yAxis = this.aec(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.aec(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.acx("volumeXAxis");
            this.afq = new List$1(NumericYAxis.$, 0);
            this.afs = new List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.aec(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.acx("indicatorXAxis_0");
            this.afq.add(this.indicatorAxis);
            this.afs.add(this.indicatorXAxis);
            if (this.xAxis.ay == null) {
                this.xAxis.ay = new AxisLabelSettings();
            }
            if (this.yAxis.ay == null) {
                this.yAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeXAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorAxis.ay == null) {
                this.indicatorAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.ay == null) {
                this.indicatorXAxis.ay = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.aec(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.acx("zoomSliderXAxis");
            if (this.zoomSliderAxis.ay == null) {
                this.zoomSliderAxis.ay = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.ay == null) {
                this.zoomSliderXAxis.ay = new AxisLabelSettings();
            }
        }
        q1(a, b) {
            let c = typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.qh = this.cn(a, b);
            }
        }
        cm(a) {
            if (a != null) {
                return 1;
            }
            return super.cm(a);
        }
        sv(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.lg = true;
                this.yAxis.l7 = 10;
            }
        }
        sy() {
            this.yAxis.lg = this.afj;
            this.yAxis.l7 = this.ahh;
        }
        adg(a) {
            let b;
            if (this.ade == 0) {
                if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.ade;
            }
            b = this.adf(b);
            return b;
        }
        adf(a) {
            if ((a == 1 || a == 2)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        adp(a) {
            if ((a == 2 || a == 3)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        adi(a) {
            if (a == 2) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ah4(a) {
            let b = a.getMemberPathFor(14);
            if (stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        }
        acz(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        aed(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        aej() {
            return this.cx(1);
        }
        aek() {
            return this.cx(0);
        }
        aei() {
            return this.cx(2);
        }
        ael() {
            return this.cx(20);
        }
        get ae2() {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        }
        get ad0() {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        }
        get ae5() {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        }
        get ady() {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get ae3() {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        }
        get ad2() {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get ae4() {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        }
        get ad7() {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        }
        cw(a, b) {
            let c = this.ah4(a);
            switch (this.adg(a)) {
                case 3:
                    let d = this.aej();
                    this.ad0.setValueMemberPath(d, c);
                    this.ad0.setXAxis(d, this.xAxis);
                    this.ad0.setYAxis(d, this.yAxis);
                    this.ad0.setCategoryMode(d, 1);
                    return d;
                case 4:
                    let e = this.aek();
                    this.ad0.setValueMemberPath(e, c);
                    this.ad0.setXAxis(e, this.xAxis);
                    this.ad0.setYAxis(e, this.yAxis);
                    this.ad0.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    let f = this.ael();
                    this.ady.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.ady.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.ady.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.ady.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.ady.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.ady.setXAxis(f, this.xAxis);
                    this.ady.setYAxis(f, this.yAxis);
                    this.ady.setDisplayType(f, this.ade == 1 ? 1 : 0);
                    this.ady.setCategoryMode(f, 1);
                    return f;
            }
        }
        sx() {
            super.sx();
            this.akv(this.xAxis);
            this.alj(false);
            if (this.adj != 0 && this.volumeChart != null) {
                this.ak2();
            }
            this.akv(this.volumeXAxis);
            this.akv(this.indicatorXAxis);
            this.alg();
            this.ali();
            if (this.adq != 0) {
                this.ak3();
                this.akv(this.zoomSliderXAxis);
            }
        }
        aas(a, b) {
            super.aas(a, b);
            a(this.volumeXAxis);
            if (this.afs != null) {
                for (let c of fromEnum(this.afs)) {
                    a(c);
                }
            }
            let d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        }
        aax(a, b) {
            super.aax(a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.afq != null) {
                    for (let c of fromEnum(this.afq)) {
                        a(c);
                    }
                }
                a(this.zoomSliderAxis);
            }
        }
        akz(a) {
            let b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
            if (b != null) {
                a(b);
            }
        }
        aav(a) {
            super.aav(a);
            this.aam(this.volumeXAxis, a);
            this.aam(this.indicatorXAxis, a);
            this.aam(this.zoomSliderXAxis, a);
        }
        aa0(a) {
            super.aa0(a);
            this.aam(this.volumeAxis, a);
            this.aam(this.indicatorAxis, a);
            this.aam(this.zoomSliderAxis, a);
        }
        aay(a) {
            super.aay(a);
            this.aal(this.volumeAxis, a);
            this.aal(this.indicatorAxis, a);
            this.aal(this.zoomSliderAxis, a);
        }
        aat(a) {
            super.aat(a);
            this.aal(this.volumeXAxis, a);
            this.aal(this.indicatorXAxis, a);
            this.aal(this.zoomSliderXAxis, a);
        }
        rn(a) {
            super.rn(a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.uk = a.un = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = this.aiz();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.ci = 2;
        }
        aiz() {
            if (this.ahw == null) {
                FinancialChart.ahg++;
                this.ahw = FinancialChart.ahg.toString();
            }
            return this.ahw;
        }
        akh(a, b) {
            this.aj3();
            this.akx();
        }
        aj3() {
            if (this.yAxis.b7()) {
                return;
            }
            let a = this.yAxis.av.bd;
            if (this.adj != 0) {
                a = Math.max(a, this.volumeAxis.av.bd);
            }
            for (let b of fromEnum(this.afq)) {
                a = Math.max(a, b.av.bd);
            }
            this.aj4(a);
        }
        aj4(a) {
            if (this.yAxis.b7()) {
                return;
            }
            this.yAxis.er = this.volumeAxis.er = a;
            for (let b of fromEnum(this.afq)) {
                b.er = a;
            }
            this.zoomSliderAxis.er = this.yAxis.er;
        }
        aj9(a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                let c = this.indicatorCharts._inner[b];
                for (let d = 0; d < c.series.count; d++) {
                    let e = c.series._inner[d];
                    if (!(this.ae7(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        }
        akc(a) {
            if (this.volumeChart == null) {
                return;
            }
            for (let b = 0; b < this.volumeChart.series.count; b++) {
                let c = this.volumeChart.series._inner[b];
                if (c.dc) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        }
        aka(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (!this.ae9(c)) {
                    continue;
                }
                a(c, b);
            }
        }
        akb(a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.ae9(d)) {
                    continue;
                }
                let e = this.aha(d, c);
                a(d, e);
            }
            if (b) {
                this.akd(a);
            }
        }
        akd(a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
                let c = this.zoomSliderChart.series._inner[b];
                if (c.dc) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        }
        aha(a, b) {
            if (a.cb != this.dataChart) {
                return b;
            }
            let c = this.bb == null || this.bb.dataSeries == null ? 0 : this.bb.dataSeries.count;
            let d = this.adu == null ? 0 : this.adu.count;
            return b - (c * d);
        }
        rd(a) {
            super.rd(a);
            this.akc(a);
            this.aj9(a);
            this.akd(a);
        }
        get volumeChart() {
            return this.aep;
        }
        set volumeChart(a) {
            let b = this.volumeChart;
            if (a != b) {
                this.aep = a;
                this.sd("VolumeChart", b, this.volumeChart);
            }
        }
        ak2() {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            let a = new List$1(Series.$, 0);
            let b = -1;
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.ae9(d) || d.dc) {
                    continue;
                }
                b++;
                let e;
                let f = this.adj;
                f = this.adi(f);
                switch (f) {
                    case 2:
                        e = this.aek();
                        break;
                    case 3:
                        e = this.aei();
                        break;
                    default:
                    case 1:
                        e = this.aej();
                        break;
                }
                this.ad0.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.ad0.setXAxis(e, this.volumeXAxis);
                this.ad0.setYAxis(e, this.volumeAxis);
                this.ad0.setValueMemberPath(e, this.bb != null && this.bb.dataSeries != null && this.bb.dataSeries.count > b ? this.bb.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.title = d.title + " Volume";
                e.o7 = ArrayExtension.getModulus$1(Brush.$, this.acr, b);
                e.pc = ArrayExtension.getModulus$1(Brush.$, this.acs, b);
                e.g1 = this.agl;
                a.add(e);
            }
            let g = this.gb("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.volumeChart.series.add(i);
                this.rs(i, h);
            }
        }
        ae6(a) {
            if (!this.ae2) {
                return false;
            }
            return this.ad0.matchesType(a);
        }
        afa(a) {
            if (!this.ae5) {
                return false;
            }
            return this.ady.matchesType(a);
        }
        ae7(a) {
            if (!this.ae3) {
                return false;
            }
            return this.ad2.matchesType(a);
        }
        ae9(a) {
            if (!this.ae4) {
                return false;
            }
            return this.ad7.matchesType(a);
        }
        ak1() {
            if (this.dataChart == null) {
                return;
            }
            let a = 0;
            let b = this.ads == null ? 0 : this.ads.count;
            let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let d = b + c;
            for (let e = 0; e < d; e++) {
                let f = new List$1(Series.$, 0);
                let g = this.indicatorCharts._inner[e];
                let h = e >= b;
                let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ads._inner[e]);
                let j = -1;
                for (let k = 0; k < this.dataChart.series.count; k++) {
                    let l = this.dataChart.series._inner[k];
                    if (this.ae9(l) || l.dc) {
                        continue;
                    }
                    j++;
                    let m;
                    if (h) {
                        let n = this.aem("Custom");
                        this.ad2.handleCustomIndicatorEvent(n, runOn(this, this.akf));
                        m = n;
                    }
                    else {
                        m = this.aeo(this.ads._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.ad2.setXAxis(m, this.afs._inner[e]);
                    this.ad2.setYAxis(m, this.afq._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.ad2.setOpenMemberPath(m, this.bb.dataSeries._inner[j].getMemberPathFor(11));
                    this.ad2.setHighMemberPath(m, this.bb.dataSeries._inner[j].getMemberPathFor(12));
                    this.ad2.setLowMemberPath(m, this.bb.dataSeries._inner[j].getMemberPathFor(13));
                    this.ad2.setCloseMemberPath(m, this.bb.dataSeries._inner[j].getMemberPathFor(14));
                    this.ad2.setVolumeMemberPath(m, this.bb.dataSeries._inner[j].getMemberPathFor(15));
                    m.title = l.title + " " + i;
                    m.o7 = ArrayExtension.getModulus$1(Brush.$, this.acl, e);
                    m.g1 = this.agh;
                    if (this.ae7(m)) {
                        this.ad2.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.acm, e));
                        this.ad2.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ad4, e));
                    }
                    if (this.ahc != -2147483648 && this.ae7(m)) {
                        this.ad2.setPeriodOverride(m, this.ahc);
                    }
                    if (this.ae7(m)) {
                        this.ad2.setSmoothingPeriod(m, this.ahf);
                    }
                    if (this.ae7(m)) {
                        this.ad2.setSignalPeriod(m, this.ahe);
                    }
                    if (this.ae7(m)) {
                        this.ad2.setShortPeriod(m, this.ahd);
                        this.ad2.setLongPeriod(m, this.ahb);
                    }
                    this.rs(m, e);
                    f.add(m);
                }
                let o = this.gb(i, false);
                for (let p = 0; p < f.count; p++) {
                    let q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (let r = 0; r < o.count; r++) {
                        let s = o._inner[r];
                        g.series.add(s);
                        this.rs(s, r);
                    }
                }
            }
        }
        aem(indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        }
        aeo(a) {
            return this.aem(EnumUtil.getName(FinancialIndicatorType_$type, a));
        }
        alj(a) {
            if (this.adc == null) {
                return;
            }
            let b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.adc.as = b.actualMinimumValue;
            this.adc.ar = b.actualMaximumValue;
            if (a) {
                this.adc.au = b.visibleMinimum;
                this.adc.at = b.visibleMaximum;
            }
            this.adc.bn();
        }
        jv() {
            let a = ((() => {
                let $ret = new FinancialChartVisualData();
                $ret.mainChart = super.jv();
                $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.vw();
                $ret.toolbar = this.adc == null ? null : this.adc.aj();
                $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.vw();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new List$1(Base.$, 0);
                for (let b of fromEnum(this.indicatorCharts)) {
                    a.indicatorCharts.add1(b.vw());
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.als(this.dataChart).x;
                a.mainChartTop = this.als(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.als(this.volumeChart).x;
                a.volumeChartTop = this.als(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.als(this.zoomSliderChart).x;
                a.zoomChartTop = this.als(this.zoomSliderChart).y;
            }
            if (this.adc != null) {
                let c = this.alt(this.adc);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new List$1(Number_$type, 0);
                a.indicatorChartTops = new List$1(Number_$type, 0);
                for (let d of fromEnum(this.indicatorCharts)) {
                    a.indicatorChartLefts.add(this.als(d).x);
                    a.indicatorChartTops.add(this.als(d).y);
                }
            }
            let e = this.alv();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.adw == null ? null : this.adw.exportVisualData();
            return a;
        }
        ah1() {
            let a = this.jv();
            a.scaleByViewport();
            return a.serialize();
        }
        aen(overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        }
        ali() {
            if (this.dataChart == null) {
                return;
            }
            let a = new List$1(Series.$, 0);
            for (let b of fromEnum(this.dataChart.series)) {
                if (this.ae9(b)) {
                    a.add(b);
                }
            }
            for (let c of fromEnum(a)) {
                this.dataChart.series.remove(c);
            }
            if (this.adu == null) {
                return;
            }
            let d = new List$1(Series.$, 0);
            let e = -1;
            for (let f = 0; f < this.dataChart.series.count; f++) {
                let g = this.dataChart.series._inner[f];
                if (this.ae9(g) || g.dc) {
                    continue;
                }
                e++;
                for (let h = 0; h < this.adu.count; h++) {
                    let i = this.adu._inner[h];
                    let j;
                    switch (i) {
                        case 1:
                            j = this.aen(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.aen(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.ad7.setXAxis(j, this.xAxis);
                    this.ad7.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    let k = e * this.adu.count + h;
                    j.o7 = ArrayExtension.getModulus$1(Brush.$, this.acp, k);
                    j.pc = ArrayExtension.getModulus$1(Brush.$, this.acq, k);
                    j.g1 = this.agj;
                    j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                    let l = g;
                    if (l == null) {
                        continue;
                    }
                    let m = this.bb.dataSeries._inner[e];
                    this.ad7.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.ad7.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.ad7.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.ad7.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.ad7.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            let n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (let o = 0; o < n.length; o++) {
                n[o].index = -1;
            }
            d.o(n);
            for (let p = 0; p < d.count; p++) {
                let q = d._inner[p];
                this.dataChart.series.add(q);
                this.rs(q, p);
            }
        }
        alg() {
            if (this.aff) {
                return;
            }
            this.aff = true;
            if (this.indicatorCharts != null) {
                let a = this.indicatorCharts;
                this.indicatorCharts = null;
                for (let b of fromEnum(a)) {
                    this.akw(b);
                }
            }
            if ((this.ads == null || this.ads.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.afq != null) {
                    this.afq.clear();
                }
                if (this.afs != null) {
                    this.afs.clear();
                }
                this.ak7();
                this.alh();
                this.aff = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.afq.clear();
            this.afs.clear();
            let c = this.ads == null ? 0 : this.ads.count;
            let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let e = c + d;
            for (let f = 0; f < e; f++) {
                let g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.aku(g);
                let h = f >= c;
                if (h) {
                    g.kg = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.kg = this.ah3(this.ads._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    let i;
                    let j;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.cd) {
                            j = this.acy(0);
                        }
                        else {
                            j = this.acy(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.afq.add(i);
                    this.afs.add(j);
                    if (this.e9) {
                        this.aap(i);
                    }
                    if (this.e9) {
                        this.aan(j);
                    }
                }
            }
            this.ak1();
            this.ak7();
            if (this.adc != null) {
                this.adc.ae = this.ads;
            }
            this.aj5();
            this.alh();
            this.aff = false;
        }
        rk() {
            super.rk();
            this.aan(this.xAxis);
            this.aan(this.volumeXAxis);
            if (this.afs != null) {
                for (let a of fromEnum(this.afs)) {
                    this.aan(a);
                }
            }
            this.aap(this.yAxis);
            this.aap(this.volumeAxis);
            if (this.afq != null) {
                for (let b of fromEnum(this.afq)) {
                    this.aap(b);
                }
            }
            this.aan(this.zoomSliderXAxis);
            this.aap(this.zoomSliderAxis);
        }
        get_fx() {
            return !this.afd;
        }
        get afl() {
            return (this.externalObject._dynamicContent);
        }
        alo(a, b) {
            this.ala(a, b);
            this.aj5();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.ak3();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.ak8();
            this.alp(a, b);
        }
        ak3() {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            let a = new List$1(Series.$, 0);
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (this.ae9(c) || c.dc) {
                    continue;
                }
                let d;
                let e = this.adq;
                e = this.adp(e);
                let f = this.aha(c, b);
                if (e == 1) {
                    switch (this.adg(this.bb != null && this.bb.dataSeries != null && this.bb.dataSeries.count > f ? this.bb.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.ael();
                        this.ady.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.ael();
                        this.ady.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.aek();
                        break;
                    case 6:
                        d = this.aei();
                        break;
                    default:
                    case 4:
                        d = this.aej();
                        break;
                }
                let g = this.bb != null && this.bb.dataSeries != null && this.bb.dataSeries.count > f ? this.bb.dataSeries._inner[f] : null;
                if (d.dh && !d.dq) {
                    this.ad0.setCategoryMode(d, 1);
                    this.ad0.setXAxis(d, this.zoomSliderXAxis);
                    this.ad0.setYAxis(d, this.zoomSliderAxis);
                    this.ad0.setValueMemberPath(d, g == null ? null : this.ah4(g));
                }
                else if (d.dq) {
                    this.ady.setCategoryMode(d, 1);
                    this.ady.setXAxis(d, this.zoomSliderXAxis);
                    this.ady.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.ady.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.ady.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.ady.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.ady.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.ady.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.title = c.title;
                d.g1 = this.io;
                a.add(d);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.rs(i, h);
            }
        }
        r7(a, b, c) {
            super.r7(a, b, c);
            if (a == null || !b) {
                return;
            }
            let d = true;
            let e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                for (let f of fromEnum(this.indicatorCharts)) {
                    a(f);
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        }
        akf(a, b) {
            let c = b;
            let d = a;
            let e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.cb);
            }
            e -= this.ads == null ? 0 : this.ads.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        }
        alc(a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.e9) {
                this.aan(c);
            }
        }
        get afk() {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        }
        akg(a, b) {
            this.alg();
        }
        afb(a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= timeSpanFromDays(365);
                case 2: return b >= timeSpanFromDays(180);
                case 1: return b >= timeSpanFromDays(90);
                case 0: return b >= timeSpanFromDays(30);
            }
            return false;
        }
        ak6() {
            let a = this.ada != null ? this.ada : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            let b = new FinancialChartRangeSelectorOptionCollection(0);
            let c = this.xAxis;
            let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            for (let e of fromEnum(a)) {
                if (this.afb(e, d)) {
                    b.add(e);
                }
            }
            this.ac9 = b;
            if (this.adc != null) {
                this.adc.u = this.ac9;
            }
        }
        akk(a, b) {
            this.ak6();
        }
        akp(a, b) {
            this.adu = this.adc.ag;
        }
        ako(a, b) {
            this.ads = this.adc.ae;
        }
        aki(a, b) {
            this.alg();
        }
        akj(a, b) {
            this.ali();
        }
        akt(a, b) {
            let c = a;
            if (c.bf == null) {
                return;
            }
            if (this.afd) {
                this.ak5(c.bf);
            }
        }
        akw(a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.akh));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.er = this.volumeAxis.er = this.indicatorAxis.er = 0;
                this.xAxis.ay.visibility = this.acb;
            }
        }
        aku(a) {
            let b = a != this.zoomSliderChart;
            if (b) {
                if (this.dataChart != null) {
                    a.tp = new Rect(0, this.dataChart.s9.x, a.tp.y, this.dataChart.s9.width, a.tp.height);
                }
                let c = ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, c);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.akh));
            this.rm(a);
        }
        aj5() {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.aal(this.xAxis, (a) => a.visibility = 1);
            }
            for (let a = 0; a < this.afs.count; a++) {
                let b = this.afs._inner[a];
                let c = a < this.afs.count - 1 || this.volumeChart != null;
                this.aal(b, (d) => d.visibility = c ? 1 : 0);
            }
        }
        ala(a, b) {
            if (a != null) {
                this.akw(a);
            }
            if (b != null) {
                this.aku(b);
            }
        }
        alm(a, b) {
            this.ala(a, b);
            this.aj5();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.ak2();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.aln(a, b);
        }
        akl(a, b) {
            this.alk();
        }
        alk() {
            if (this.adc == null || +(this.adc.au) == +(dateMaxValue()) || +(this.adc.at) == +(dateMinValue()) || this.dataChart == null) {
                return;
            }
            let a = this.xAxis;
            let b = a.getWindowRectForSelection(this.adc.au, this.adc.at);
            if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
                return;
            }
            this.afe = true;
            this.dataChart.tp = new Rect(0, b.left, this.dataChart.tp.top, b.width, this.dataChart.tp.height);
            if (this.aeu != null) {
                this.aeu.windowRect = this.dataChart.s9;
            }
            if (this.afd) {
                this.ak5(this.dataChart);
            }
            this.afe = false;
        }
        aks(a, b) {
            this.ak6();
            this.alj(!this.afe);
        }
        ake(a, b) {
            if (!this.afe) {
                if (this.afd) {
                    this.ak5(a);
                }
                let c = false;
                let d = this.si(() => this.alj(true), c);
                c = d.p1;
                if (this.aeu != null) {
                    this.aeu.windowRect = this.dataChart.s9;
                }
            }
        }
        ale(a, b, c, d) {
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.afe = true;
                a.tp = new Rect(0, d, a.s9.top, c, a.s9.height);
                this.afe = false;
            }
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(0, g, g, this.yAxis.cg, a.td);
            for (let i of fromEnum(a.series)) {
                h.b = i.ge();
                let j = i.aq(a.s9);
                let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                let l = b.ei(j.c, h);
                let m = b.ei(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
            let n = a.s9.width;
            if (c != -1) {
                n = c;
            }
            let o = a.s9.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
                return;
            }
            this.afe = true;
            let p = new Rect(0, o, e, n, f - e);
            a.tp = p;
            this.afe = false;
        }
        ald(a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.ale(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.ale(this.volumeChart, this.volumeAxis, this.dataChart.s9.width, this.dataChart.s9.left);
                }
            }
            else if (a == this.volumeChart) {
                this.ale(this.volumeChart, this.volumeAxis, -1, -1);
                this.ale(this.dataChart, this.yAxis, this.volumeChart.s9.width, this.volumeChart.s9.left);
            }
        }
        ak5(a) {
            this.sh(() => this.ald(a));
        }
        akm(a, b) {
            if (this.afd) {
                this.ak5(a);
            }
        }
        all() {
            if (!this.afl) {
                return;
            }
            this.aj8();
            if (this.adq == 0) {
                this.zoomSliderChart = null;
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((() => {
                    let $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
            }
            else {
                this.ak3();
            }
        }
        aj8() {
            let container_ = this.ag2.rootWrapper.getNativeElement();
            let containerParent_ = container_.parentElement;
            if (this.aeu != null && containerParent_ != null && !this.afm) {
                this.afm = true;
                if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    let z_ = this.aeu;
                    let f_ = this.externalObject;
                    let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                    let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        }
        alf() {
            if (this.adl != 1) {
                return;
            }
            this.aar((a) => {
                let b;
                b = a.breaks;
                b.clear();
                if (this.xAxisBreaks == null) {
                    return;
                }
                for (let c of fromEnum(this.xAxisBreaks)) {
                    b.add(c);
                }
            });
        }
        s2(a, b, c) {
            super.s2(a, b, c);
            if (this.bb.dataSeries.count > 0) {
                if (this.adl == 1 && stringIsNullOrEmpty(this.k7)) {
                    this.b1.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (stringIsNullOrEmpty(this.k9)) {
                    this.b1.setYMemberPath(a, this.ah4(c));
                }
                if (stringIsNullOrEmpty(this.k3)) {
                    this.b1.setLabelMemberPath(a, this.ah4(c));
                }
                if (stringIsNullOrEmpty(this.k0)) {
                    this.b1.setContentMemberPath(a, this.ah4(c));
                }
            }
        }
        ah3(a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        }
        aan(a) {
            super.aan(a);
            let b = a;
            this.akv(b);
            if (a.bf != null) {
                for (let c of fromEnum(a.bf.series)) {
                    if (this.ae6(c)) {
                        this.ad0.setXAxis(c, b);
                    }
                    else if (this.afa(c)) {
                        this.ady.setXAxis(c, b);
                    }
                    else if (this.ae7(c)) {
                        this.ad2.setXAxis(c, b);
                    }
                    else if (this.ae9(c)) {
                        this.ad7.setXAxis(c, b);
                    }
                }
            }
            this.akz((d) => {
                d.zoomMaximumCategoryRange = this.agm;
                d.zoomMaximumItemSpan = this.agn;
                d.zoomToCategoryRange = this.ago;
                d.zoomToCategoryStart = this.agp;
                d.zoomToItemSpan = this.agq;
            });
            let d = a == this.zoomSliderXAxis;
            if (d) {
                a.jv = this.alr;
                a.eq = this.agx;
                this.aal(a, (e) => e.visibility = 1);
            }
            let e = a;
            e.minimumValue = this.afy;
            e.maximumValue = this.afx;
            a.b0 = this.afg;
        }
        aap(a) {
            super.aap(a);
            if (a.bf != null && a == this.yAxis) {
                for (let b of fromEnum(a.bf.series)) {
                    if (this.ae6(b)) {
                        this.ad0.setYAxis(b, this.yAxis);
                    }
                    else if (this.afa(b)) {
                        this.ady.setYAxis(b, this.yAxis);
                    }
                    else if (this.ae7(b)) {
                        this.ad2.setYAxis(b, this.yAxis);
                    }
                    else if (this.ae9(b)) {
                        this.ad7.setYAxis(b, this.yAxis);
                    }
                }
            }
            a.k8 = this.afh;
            a.l3 = this.agv;
            a.l2 = this.agu;
            if (a == this.yAxis) {
                a.lz = this.agt;
            }
            let c = a == this.zoomSliderAxis;
            if (c) {
                this.aal(a, (d) => d.visibility = 1);
            }
            a.b0 = this.afi;
        }
        akv(a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.fz = XYChart.ya(a, this.bb.dataSeries);
            if (this.bb.dataSeries.count > 0) {
                let b = this.bb.dataSeries._inner[0].getMemberPathFor(17);
                a.hx(b);
            }
        }
        rs(a, b) {
            super.rs(a, b);
            if (a == null) {
                return;
            }
            let c = this.zoomSliderChart == a.cb;
            let d = this.dataChart != null && this.dataChart.series.contains(a);
            if ((d || c) && a.d4) {
                a.mq(this.acn != null ? ArrayExtension.getModulus$1(Brush.$, this.acn, b) : null, this.aco != null ? ArrayExtension.getModulus$1(Brush.$, this.aco, b) : null);
            }
            let e = this.ae7(a);
            if (this.ae9(a)) {
                a.o7 = this.acp != null ? ArrayExtension.getModulus$1(Brush.$, this.acp, b) : null;
                a.pc = this.acq != null ? ArrayExtension.getModulus$1(Brush.$, this.acq, b) : null;
                a.g1 = this.agj;
            }
            else if (e) {
                a.o7 = this.acl != null ? ArrayExtension.getModulus$1(Brush.$, this.acl, b) : null;
                a.g1 = this.agh;
            }
            else if (!a.dc && (d || c)) {
                a.o7 = this.aa != null ? ArrayExtension.getModulus$1(Brush.$, this.aa, b) : null;
                a.pc = this.ae != null ? ArrayExtension.getModulus$1(Brush.$, this.ae, b) : null;
            }
            let f = this.volumeChart != null && this.volumeChart == a.cb;
            if (f) {
                a.g1 = this.agl;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.ae8 ? this.adw : null;
        }
        sd(a, b, c) {
            super.sd(a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.lg = this.afj;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.lg = this.afj;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.lg = this.afj;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.l7 = this.ahh;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.l7 = this.ahh;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.l7 = this.ahh;
                    }
                    break;
                case "VolumeType":
                    let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.adj == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((() => {
                            let $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.ak2();
                    }
                    break;
                case "VolumeChart":
                    this.alm(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (typeCast(XamDataChart.$, b) !== null) {
                        let e = b;
                        e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.akh));
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ake));
                        e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.akm));
                    }
                    if (this.dataChart != null) {
                        let f = this.dataChart;
                        f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.akh));
                        let g = this.dataChart;
                        g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ake));
                        let h = this.dataChart;
                        h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.akm));
                    }
                    this.all();
                    break;
                case "XAxisMode":
                    this.xAxis = this.acy(this.adl);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.acy(this.adl);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.acy(this.adl);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.acy(this.adl);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.aal(this.zoomSliderXAxis, (i) => i.visibility = 1);
                    this.aj5();
                    if (this.adl == 1) {
                        this.alf();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.aec(this.adn);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.aec(this.adn);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.aec(this.adn);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    let i = typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.akl));
                        i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ako));
                        i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.akp));
                    }
                    if (this.adc != null) {
                        this.adc.ae = this.ads;
                        this.adc.ag = this.adu;
                        this.adc.u = this.ac9;
                        this.alj(true);
                        let j = this.adc;
                        j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.akl));
                        let k = this.adc;
                        k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ako));
                        let l = this.adc;
                        l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.akp));
                    }
                    break;
                case "XAxis":
                    let m = typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.aks));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.e9) {
                        this.aan(this.xAxis);
                        this.ra();
                    }
                    this.alj(false);
                    this.alk();
                    this.ak6();
                    let o = this.xAxis;
                    o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.aks));
                    break;
                case "XAxisZoomMaximumCategoryRange":
                    this.akz((p) => p.zoomMaximumCategoryRange = this.agm);
                    break;
                case "XAxisZoomMaximumItemSpan":
                    this.akz((p) => p.zoomMaximumItemSpan = this.agn);
                    break;
                case "XAxisZoomToCategoryRange":
                    this.akz((p) => p.zoomToCategoryRange = this.ago);
                    break;
                case "XAxisZoomToCategoryStart":
                    this.akz((p) => p.zoomToCategoryStart = this.agp);
                    break;
                case "XAxisZoomToItemSpan":
                    this.akz((p) => p.zoomToItemSpan = this.agq);
                    break;
                case "ChartType":
                    this.sx();
                    break;
                case "VolumeXAxis":
                    this.alc(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.alc(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.alg();
                    break;
                case "YAxis":
                    let p = typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.e9) {
                        this.aap(this.yAxis);
                        this.aap(this.yAxis);
                    }
                    let q = this.yAxis;
                    q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.akt));
                    break;
                case "VolumeAxis":
                    let r = typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.ak2();
                    }
                    if (this.e9) {
                        this.aap(this.volumeAxis);
                    }
                    let s = this.volumeAxis;
                    s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.akt));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (let t = 0; t < this.indicatorCharts.count; t++) {
                            let u = this.indicatorCharts._inner[t];
                            let v = new List$1(Axis.$, 0);
                            for (let w of fromEnum(u.axes)) {
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                            for (let x of fromEnum(v)) {
                                u.axes.remove(x);
                            }
                            let y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.adn == 1) {
                                y = this.aec(this.adn);
                            }
                            else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.e9) {
                                this.aap(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.un = this.fy && this.fx;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.un = this.fy && this.fx;
                    }
                    if (this.afd) {
                        this.ald(this.dataChart);
                    }
                    else {
                        this.volumeChart.vu = 1;
                    }
                    break;
                case "IndicatorTypes":
                    let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.aki));
                    }
                    let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.aki));
                    }
                    this.alg();
                    break;
                case "OverlayTypes":
                    let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.akj));
                    }
                    let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.akj));
                    }
                    this.ali();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.aaw((ad) => ad.k8 = this.afh);
                    break;
                case "YAxisMinimumValue":
                    this.aax((ad) => ad.l3 = this.agv, false);
                    break;
                case "YAxisMaximumValue":
                    this.aax((ad) => ad.l2 = this.agu, false);
                    break;
                case "YAxisInterval":
                    this.aax((ad) => ad.lz = this.agt, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.all();
                    break;
                case "ZoomSliderChart":
                    if (!this.afk) {
                        return;
                    }
                    this.alo(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.akb((ad, ae) => {
                        if (ad.d4) {
                            ad.mq(this.acn != null ? ArrayExtension.getModulus$1(Brush.$, this.acn, ae) : null, this.aco != null ? ArrayExtension.getModulus$1(Brush.$, this.aco, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.aka((ad, ae) => ad.o7 = this.acp != null ? ArrayExtension.getModulus$1(Brush.$, this.acp, ae) : null);
                    break;
                case "OverlayOutlines":
                    this.aka((ad, ae) => ad.pc = this.acq != null ? ArrayExtension.getModulus$1(Brush.$, this.acq, ae) : null);
                    break;
                case "OverlayThickness":
                    this.aka((ad, ae) => ad.g1 = this.agj);
                    break;
                case "OverlayMultiplier":
                    this.aka((ad, ae) => this.ad7.setMultiplier(ad, this.agi));
                    break;
                case "VolumeBrushes":
                    this.akc((ad, ae) => ad.o7 = ArrayExtension.getModulus$1(Brush.$, this.acr, ae));
                    break;
                case "VolumeOutlines":
                    this.akc((ad, ae) => ad.pc = ArrayExtension.getModulus$1(Brush.$, this.acs, ae));
                    break;
                case "VolumeThickness":
                    this.akc((ad, ae) => ad.g1 = this.agl);
                    break;
                case "IndicatorNegativeBrushes":
                    this.aj9((ad, ae) => this.ad2.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.acm, ae)));
                    break;
                case "IndicatorBrushes":
                    this.aj9((ad, ae) => ad.o7 = ArrayExtension.getModulus$1(Brush.$, this.acl, ae));
                    break;
                case "IndicatorThickness":
                    this.aj9((ad, ae) => ad.g1 = this.agh);
                    break;
                case "IndicatorDisplayTypes":
                    this.aj9((ad, ae) => this.ad2.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ad4, ae)));
                    break;
                case "IndicatorPeriod":
                    this.aj9((ad, ae) => {
                        if (this.ahc == -2147483648) {
                            return;
                        }
                        this.ad2.setPeriodOverride(ad, this.ahc);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.aj9((ad, ae) => this.ad2.setMultiplier(ad, this.agg));
                    break;
                case "IndicatorSmoothingPeriod":
                    this.aj9((ad, ae) => this.ad2.setSmoothingPeriod(ad, this.ahf));
                    break;
                case "IndicatorShortPeriod":
                    this.aj9((ad, ae) => this.ad2.setShortPeriod(ad, this.ahd));
                    break;
                case "IndicatorLongPeriod":
                    this.aj9((ad, ae) => this.ad2.setLongPeriod(ad, this.ahb));
                    break;
                case "IndicatorSignalPeriod":
                    this.aj9((ad, ae) => this.ad2.setSignalPeriod(ad, this.ahe));
                    break;
                case "RangeSelectorOptions":
                    let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.akk));
                    }
                    if (this.ada != null) {
                        let ae = this.ada;
                        ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.akk));
                    }
                    this.ak6();
                    break;
                case "CustomIndicatorNames":
                    let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                    if (af != null) {
                        af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.akg));
                    }
                    if (this.customIndicatorNames != null) {
                        let ag = this.customIndicatorNames;
                        ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.akg));
                    }
                    this.alg();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.akb((ah, ai) => ah.o7 = this.aa != null ? ArrayExtension.getModulus$1(Brush.$, this.aa, ai) : null, true);
                    break;
                case "Outlines":
                    this.akb((ah, ai) => ah.pc = this.ae != null ? ArrayExtension.getModulus$1(Brush.$, this.ae, ai) : null, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.acb == 0 && this.zoomSliderXAxis != null) {
                        this.aal(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                    }
                    this.aj5();
                    break;
                case "YAxisLabelVisibility":
                    if (this.acc != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.aal(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jv = this.alr;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.eq = this.agx;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    let ah = this.ae8 && this.legend == null;
                    {
                        let ai = (aj, ak) => {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah ? this.adw : null;
                            }
                        };
                        this.akb(ai, false);
                        this.aka(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    let aj = typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.ak3();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.e9) {
                            this.aap(this.zoomSliderAxis);
                        }
                        this.aal(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                    }
                    break;
                case "XAxisMinimumValue":
                    this.aar((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = this.afy;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.aar((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = this.afx;
                        }
                    });
                    break;
                case FinancialChart.ajc:
                    this.aas((ak) => ak.b0 = this.afg, a);
                    break;
                case FinancialChart.ajn:
                    this.aaw((ak) => ak.b0 = this.afi);
                    break;
            }
        }
        get_bz() {
            return 1;
        }
        get bz() {
            return this.get_bz();
        }
        get afj() {
            return this.ae1;
        }
        set afj(a) {
            let b = this.afj;
            if (a != b) {
                this.ae1 = a;
                this.sd("YAxisIsLogarithmic", b, this.afj);
            }
        }
        get ahh() {
            return this.ag9;
        }
        set ahh(a) {
            let b = this.ahh;
            if (a != b) {
                this.ag9 = a;
                this.sd("YAxisLogarithmBase", b, this.ahh);
            }
        }
        get agt() {
            return this.aga;
        }
        set agt(a) {
            let b = this.agt;
            if (a != b) {
                this.aga = a;
                this.sd("YAxisInterval", b, this.agt);
            }
        }
        get agv() {
            return this.agc;
        }
        set agv(a) {
            let b = this.agv;
            if (a != b) {
                this.agc = a;
                this.sd("YAxisMinimumValue", b, this.agv);
            }
        }
        get agu() {
            return this.agb;
        }
        set agu(a) {
            let b = this.agu;
            if (a != b) {
                this.agb = a;
                this.sd("YAxisMaximumValue", b, this.agu);
            }
        }
        get agw() {
            return this.agd;
        }
        set agw(a) {
            let b = this.agw;
            if (a != b) {
                this.agd = a;
                this.sd("YAxisMinorInterval", b, this.agw);
            }
        }
        get ags() {
            return this.yAxis.lv;
        }
        get agr() {
            return this.yAxis.lu;
        }
        get adj() {
            return this.adh;
        }
        set adj(a) {
            let b = this.adj;
            if (a != b) {
                this.adh = a;
                this.sd("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.adj));
            }
        }
        get adl() {
            return this.adk;
        }
        set adl(a) {
            let b = this.adl;
            if (a != b) {
                this.adk = a;
                this.sd("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.adl));
            }
        }
        get agm() {
            return this.af5;
        }
        set agm(a) {
            let b = this.agm;
            if (a != b) {
                this.af5 = a;
                this.sd("XAxisZoomMaximumCategoryRange", b, this.agm);
            }
        }
        get agp() {
            return this.af8;
        }
        set agp(a) {
            let b = this.agp;
            if (a != b) {
                this.af8 = a;
                this.sd("XAxisZoomToCategoryStart", b, this.agp);
            }
        }
        get agn() {
            return this.af6;
        }
        set agn(a) {
            let b = this.agn;
            if (a != b) {
                this.af6 = a;
                this.sd("XAxisZoomMaximumItemSpan", b, this.agn);
            }
        }
        get ago() {
            return this.af7;
        }
        set ago(a) {
            let b = this.ago;
            if (a != b) {
                this.af7 = a;
                this.sd("XAxisZoomToCategoryRange", b, this.ago);
            }
        }
        get agq() {
            return this.af9;
        }
        set agq(a) {
            let b = this.agq;
            if (a != b) {
                this.af9 = a;
                this.sd("XAxisZoomToItemSpan", b, this.agq);
            }
        }
        get adn() {
            return this.adm;
        }
        set adn(a) {
            let b = this.adn;
            if (a != b) {
                this.adm = a;
                this.sd("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.adn));
            }
        }
        get afc() {
            return this.aew;
        }
        set afc(a) {
            let b = this.afc;
            if (a != b) {
                this.aew = a;
                this.sd("IsToolbarVisible", b, this.afc);
            }
        }
        get ade() {
            return this.add;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.add = a;
                this.sd("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ade));
            }
        }
        get_aa6() {
            return super.get_aa6();
        }
        set_aa6(a) {
            super.set_aa6(a);
        }
        get afd() {
            return this.aex;
        }
        set afd(a) {
            let b = this.afd;
            if (a != b) {
                this.aex = a;
                this.sd("IsWindowSyncedToVisibleRange", b, this.afd);
            }
        }
        get ads() {
            return this.adr;
        }
        set ads(a) {
            let b = this.ads;
            if (a != b) {
                this.adr = a;
                this.sd("IndicatorTypes", b, this.ads);
            }
        }
        get adu() {
            return this.adt;
        }
        set adu(a) {
            let b = this.adu;
            if (a != b) {
                this.adt = a;
                this.sd("OverlayTypes", b, this.adu);
            }
        }
        get indicatorCharts() {
            return this.afo;
        }
        set indicatorCharts(a) {
            let b = this.indicatorCharts;
            if (a != b) {
                this.afo = a;
                this.sd("IndicatorCharts", b, this.indicatorCharts);
            }
        }
        get afh() {
            return this.aez;
        }
        set afh(a) {
            let b = this.afh;
            if (a != b) {
                this.aez = a;
                this.sd("YAxisAbbreviateLargeNumbers", b, this.afh);
            }
        }
        get_ih() {
            return super.get_ih();
        }
        set_ih(a) {
            super.set_ih(a);
        }
        get afg() {
            return this.aey;
        }
        set afg(a) {
            let b = this.afg;
            if (a != b) {
                this.aey = a;
                this.sd(FinancialChart.ajc, b, this.afg);
            }
        }
        get afi() {
            return this.ae0;
        }
        set afi(a) {
            let b = this.afi;
            if (a != b) {
                this.ae0 = a;
                this.sd(FinancialChart.ajn, b, this.afi);
            }
        }
        get zoomSliderChart() {
            return this.aeq;
        }
        set zoomSliderChart(a) {
            let b = this.zoomSliderChart;
            if (a != b) {
                this.aeq = a;
                this.sd("ZoomSliderChart", b, this.zoomSliderChart);
            }
        }
        get zoomSliderAxis() {
            return this.aeb;
        }
        set zoomSliderAxis(a) {
            let b = this.zoomSliderAxis;
            if (a != b) {
                this.aeb = a;
                this.sd("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        }
        get zoomSliderXAxis() {
            return this.acw;
        }
        set zoomSliderXAxis(a) {
            let b = this.zoomSliderXAxis;
            if (a != b) {
                this.acw = a;
                this.sd("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        }
        get adq() {
            return this.ado;
        }
        set adq(a) {
            let b = this.adq;
            if (a != b) {
                this.ado = a;
                this.sd("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.adq));
            }
        }
        get acn() {
            return this.acf;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.acf = a;
                this.sd("NegativeBrushes", b, this.acn);
            }
        }
        get aco() {
            return this.acg;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.acg = a;
                this.sd("NegativeOutlines", b, this.aco);
            }
        }
        get acp() {
            return this.ach;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.ach = a;
                this.sd("OverlayBrushes", b, this.acp);
            }
        }
        get acq() {
            return this.aci;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.aci = a;
                this.sd("OverlayOutlines", b, this.acq);
            }
        }
        get acs() {
            return this.ack;
        }
        set acs(a) {
            let b = this.acs;
            if (a != b) {
                this.ack = a;
                this.sd("VolumeOutlines", b, this.acs);
            }
        }
        get acr() {
            return this.acj;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.acj = a;
                this.sd("VolumeBrushes", b, this.acr);
            }
        }
        get acm() {
            return this.ace;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.ace = a;
                this.sd("IndicatorNegativeBrushes", b, this.acm);
            }
        }
        get acl() {
            return this.acd;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.acd = a;
                this.sd("IndicatorBrushes", b, this.acl);
            }
        }
        get agl() {
            return this.af4;
        }
        set agl(a) {
            let b = this.agl;
            if (a != b) {
                this.af4 = a;
                this.sd("VolumeThickness", b, this.agl);
            }
        }
        get agj() {
            return this.af2;
        }
        set agj(a) {
            let b = this.agj;
            if (a != b) {
                this.af2 = a;
                this.sd("OverlayThickness", b, this.agj);
            }
        }
        get agi() {
            return this.af1;
        }
        set agi(a) {
            let b = this.agi;
            if (a != b) {
                this.af1 = a;
                this.sd("OverlayMultiplier", b, this.agi);
            }
        }
        get agh() {
            return this.af0;
        }
        set agh(a) {
            let b = this.agh;
            if (a != b) {
                this.af0 = a;
                this.sd("IndicatorThickness", b, this.agh);
            }
        }
        get ad4() {
            return this.ad3;
        }
        set ad4(a) {
            let b = this.ad4;
            if (a != b) {
                this.ad3 = a;
                this.sd("IndicatorDisplayTypes", b, this.ad4);
            }
        }
        get ahc() {
            return this.ag5;
        }
        set ahc(a) {
            let b = this.ahc;
            if (a != b) {
                this.ag5 = a;
                this.sd("IndicatorPeriod", b, this.ahc);
            }
        }
        get agg() {
            return this.afz;
        }
        set agg(a) {
            let b = this.agg;
            if (a != b) {
                this.afz = a;
                this.sd("IndicatorMultiplier", b, this.agg);
            }
        }
        get ahf() {
            return this.ag8;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.ag8 = a;
                this.sd("IndicatorSmoothingPeriod", b, this.ahf);
            }
        }
        get ahd() {
            return this.ag6;
        }
        set ahd(a) {
            let b = this.ahd;
            if (a != b) {
                this.ag6 = a;
                this.sd("IndicatorShortPeriod", b, this.ahd);
            }
        }
        get ahb() {
            return this.ag4;
        }
        set ahb(a) {
            let b = this.ahb;
            if (a != b) {
                this.ag4 = a;
                this.sd("IndicatorLongPeriod", b, this.ahb);
            }
        }
        get ahe() {
            return this.ag7;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.ag7 = a;
                this.sd("IndicatorSignalPeriod", b, this.ahe);
            }
        }
        get ada() {
            return this.ac8;
        }
        set ada(a) {
            let b = this.ada;
            if (a != b) {
                this.ac8 = a;
                this.sd("RangeSelectorOptions", b, this.ada);
            }
        }
        get customIndicatorNames() {
            return this.ac4;
        }
        set customIndicatorNames(a) {
            let b = this.ac4;
            if (a != b) {
                this.ac4 = a;
                this.sd("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        }
        get_fy() {
            return super.get_fy();
        }
        set_fy(a) {
            super.set_fy(a);
        }
        get alr() {
            return this.alq;
        }
        set alr(a) {
            let b = this.alr;
            if (a != b) {
                this.alq = a;
                this.sd("ZoomSliderXAxisMajorStroke", b, this.alr);
            }
        }
        get agx() {
            return this.age;
        }
        set agx(a) {
            let b = this.agx;
            if (a != b) {
                this.age = a;
                this.sd("ZoomSliderXAxisMajorStrokeThickness", b, this.agx);
            }
        }
        get ae8() {
            return this.aev;
        }
        set ae8(a) {
            let b = this.ae8;
            if (a != b) {
                this.aev = a;
                this.sd("IsLegendVisible", b, this.ae8);
            }
        }
        get adw() {
            return this.adv;
        }
        set adw(a) {
            let b = this.adw;
            if (a != b) {
                this.adv = a;
                this.sd("FinancialChartLegend", b, this.adw);
            }
        }
        get xAxis() {
            return this.acv;
        }
        set xAxis(a) {
            let b = this.xAxis;
            if (a != b) {
                this.acv = a;
                this.sd("XAxis", b, this.xAxis);
            }
        }
        get yAxis() {
            return this.aea;
        }
        set yAxis(a) {
            let b = this.yAxis;
            if (a != b) {
                this.aea = a;
                this.sd("YAxis", b, this.yAxis);
            }
        }
        get volumeAxis() {
            return this.ad9;
        }
        set volumeAxis(a) {
            let b = this.volumeAxis;
            if (a != b) {
                this.ad9 = a;
                this.sd("VolumeAxis", b, this.volumeAxis);
            }
        }
        get volumeXAxis() {
            return this.acu;
        }
        set volumeXAxis(a) {
            let b = this.volumeXAxis;
            if (a != b) {
                this.acu = a;
                this.sd("VolumeXAxis", b, this.volumeXAxis);
            }
        }
        get indicatorAxis() {
            return this.ad8;
        }
        set indicatorAxis(a) {
            let b = this.indicatorAxis;
            if (a != b) {
                this.ad8 = a;
                this.sd("IndicatorAxis", b, this.indicatorAxis);
            }
        }
        get indicatorXAxis() {
            return this.act;
        }
        set indicatorXAxis(a) {
            let b = this.indicatorXAxis;
            if (a != b) {
                this.act = a;
                this.sd("IndicatorXAxis", b, this.indicatorXAxis);
            }
        }
        get afq() {
            return this.afn;
        }
        set afq(a) {
            let b = this.afq;
            if (a != b) {
                this.afn = a;
                this.sd("IndicatorAxes", b, this.afq);
            }
        }
        get afs() {
            return this.afp;
        }
        set afs(a) {
            let b = this.afs;
            if (a != b) {
                this.afp = a;
                this.sd("IndicatorXAxes", b, this.afs);
            }
        }
        get afy() {
            return this.afw;
        }
        set afy(a) {
            let b = this.afy;
            if (+a != +b) {
                this.afw = a;
                this.sd("XAxisMinimumValue", b, this.afy);
            }
        }
        get afx() {
            return this.afv;
        }
        set afx(a) {
            let b = this.afx;
            if (+a != +b) {
                this.afv = a;
                this.sd("XAxisMaximumValue", b, this.afx);
            }
        }
        get xAxisBreaks() {
            return this.aft;
        }
    }
    FinancialChart.$t = /*@__PURE__*/ markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ahg = 0;
    FinancialChart.ajc = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.ajn = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
})();
/**
 * @hidden
 */
export let FinancialChartToolbar = /*@__PURE__*/ (() => {
    class FinancialChartToolbar extends TemplatedHtmlControl {
        constructor(a, b) {
            super("financialChartToolbar", b, "");
            this.o = null;
            this.r = null;
            this.z = null;
            this.p = null;
            this.w = null;
            this.aq = dateMaxValue();
            this.ap = dateMinValue();
            this.ao = dateMaxValue();
            this.an = dateMinValue();
            this.rangeChanged = null;
            this.chartTypeChanged = null;
            this.trendLineTypeChanged = null;
            this.volumeTypeChanged = null;
            this.indicatorTypesChanged = null;
            this.overlayTypesChanged = null;
            this.x = 0;
            this.ah = 0;
            this.ab = 0;
            this.ad = null;
            this.af = null;
            this.t = null;
            this.ak = false;
            this.o = a;
            this.w = new FinancialChartToolbarViewModel();
            this.s = new FinancialChartRangeSelector(a != null ? a.ahs : null);
            this.aa = new FinancialChartTypePicker(a != null ? a.ahp : null);
            this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ahq : null);
        }
        bg(a) {
            let b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            let c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            let d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            let e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        }
        bl(a) {
            this.q.u(a);
            this.aa.u(a);
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        }
        bm(a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    let d = b;
                    if (d != null) {
                        d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        let e = this.s;
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    let f = b;
                    if (f != null) {
                        f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        let g = this.aa;
                        g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    let h = typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        let i = this.q;
                        i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, EventArgs.empty);
                    }
                    break;
            }
        }
        bh(a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        }
        bi(a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        }
        bj(a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        }
        v() {
            let a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((() => {
                let $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((() => {
                let $ret = new FinancialChartTypePickerContext();
                $ret.vm = this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((() => {
                let $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = this.s.q;
                return $ret;
            })());
            return a;
        }
        l(a) {
            super.l(a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        }
        bk() {
        }
        get au() {
            return this.aq;
        }
        set au(a) {
            let b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        }
        get at() {
            return this.ap;
        }
        set at(a) {
            let b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        }
        get as() {
            return this.ao;
        }
        set as(a) {
            let b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        }
        get ar() {
            return this.an;
        }
        set ar(a) {
            let b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        }
        bn() {
            if (this.s != null) {
                this.s.ab();
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            let b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        }
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        }
        static am(a, b) {
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            for (let c of fromEn(a)) {
                if (!b.contains(c)) {
                    return false;
                }
            }
            return true;
        }
        aj() {
            return ((() => {
                let $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = this.s == null ? null : this.s.r();
                return $ret;
            })());
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        }
    }
    FinancialChartToolbar.$t = /*@__PURE__*/ markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
})();
/**
 * @hidden
 */
export let FinancialChartRangeSelector = /*@__PURE__*/ (() => {
    class FinancialChartRangeSelector extends TemplatedHtmlControl {
        constructor(a) {
            super("financialChartRangeSelector", a, "");
            this.q = null;
            this.rangeChanged = null;
            this.p = null;
            this.p = new FinancialChartRangeSelectorView();
            this.q = new FinancialChartRangeSelectorViewModel();
            this.q.onRangeChanged = runOn(this, this.z);
            this.p.c = this.q;
        }
        get v() {
            return this.q.selectionStart;
        }
        set v(a) {
            this.q.selectionStart = a;
        }
        get u() {
            return this.q.selectionEnd;
        }
        set u(a) {
            this.q.selectionEnd = a;
        }
        get t() {
            return this.q.rangeStart;
        }
        set t(a) {
            this.q.rangeStart = a;
        }
        get s() {
            return this.q.rangeEnd;
        }
        set s(a) {
            this.q.rangeEnd = a;
        }
        ab() {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        }
        l(a) {
            super.l(a);
            this.p.f(this.d, this.q);
        }
        z() {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, EventArgs.empty);
            }
        }
        r() {
            return this.p.d(this.g);
        }
        get o() {
            return this.q.options;
        }
        set o(a) {
            let b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        }
        aa() {
            if (this.q != null) {
                this.q.ao();
            }
            if (this.p != null) {
                this.p.i(this.o);
            }
        }
    }
    FinancialChartRangeSelector.$t = /*@__PURE__*/ markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
})();
