/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-react-core";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { IOrdinalAxis_$type } from "./IOrdinalAxis";
import { TimeAxisLabellingMode_$type } from "./TimeAxisLabellingMode";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { EventArgs, runOn, delegateCombine, typeCast, enumGetBox, Date_$type, markType } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeXAxis } from "./TimeXAxis";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { truncate } from "igniteui-react-core";
import { dateMaxValue, dateMinValue, dateAdd, dateSubtract } from "igniteui-react-core";
import { timeSpanFromMilliseconds, timeSpanTotalMilliseconds } from "igniteui-react-core";
/**
 * @hidden
 */
export let OrdinalTimeXAxis = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxis extends CategoryXAxis {
        constructor() {
            super();
            this.no = dateMaxValue();
            this.nn = dateMinValue();
            this.nu = dateMaxValue();
            this.nt = dateMinValue();
            this.nq = dateMaxValue();
            this.np = dateMinValue();
            this.n4 = null;
            this.n3 = null;
            this.nj = 0;
            this.nl = null;
            this.nh = null;
            this.od = 0;
            this.ns = dateMinValue();
            this.nr = dateMaxValue();
            this.visibleRangeChanged = null;
            FastItemDateTimeColumn.o();
            this.nh = new TimeAxisLabelFormatCollection();
            let a = this.ni;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.of));
            this.mv = 0;
        }
        ek(a, b, c) {
            return this.ei(a, new ScalerParams(0, b, c, this.cg, this.j7()));
        }
        ej(a, b, c) {
            return this.ei(a, b);
        }
        ei(a, b) {
            if (!b.c.isEmpty) {
                let c = this.n1(a, NumericScaler.ac, b.c);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.n1(a, b.e, b.d);
        }
        n1(a, b, c) {
            let d = this.mu;
            let e = this.mv;
            let f = this.mu - this.mv;
            let g = f >= 1 ? (a - e) / (d - e) : f == 0 ? 0.5 : NaN;
            if (this.ch) {
                g = 1 - g;
            }
            return c.left + c.width * (g - b.left) / b.width;
        }
        hl(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = i.left;
            let m = i.width;
            let n = g.left;
            let o = g.width;
            let p = h.left;
            let q = h.width;
            let r = 0;
            let s = 1;
            let t = this.mu;
            let u = this.mv;
            let v = this.mu - this.mv;
            let w = this.mf(a);
            let x = w != null;
            for (let y = 0; y < b.count; y++) {
                let z = b.item(y);
                for (let aa = c; aa < d; aa++) {
                    f = x ? w[aa] : a.item(aa);
                    if (k) {
                        let ab = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = l + m * (ab - r) / s;
                        let ac = (ab - p) / q;
                        ac = p + q * (ac - n) / o;
                        f[z] = ac;
                    }
                    else {
                        let ad = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ad = 1 - ad;
                        }
                        ad = p + q * (ad - n) / o;
                        f[z] = ad;
                    }
                }
            }
        }
        hm(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.ei(a.item(e), d));
            }
        }
        en(a, b, c) {
            return this.el(a, new ScalerParams(0, b, this.kc, this.cg, this.j7()));
        }
        getUnscaledValue3(a, b, c, d) {
            return this.el(a, new ScalerParams(0, b, this.kc, this.cg, this.j7()));
        }
        el(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.n2(c, NumericScaler.ac, b.c);
                return c;
            }
            return this.n2(a, b.e, b.d);
        }
        n2(a, b, c) {
            let d = b.left + (a - c.left) * b.width / c.width;
            if (this.ch) {
                d = 1 - d;
            }
            return this.mv + d * (this.mu - this.mv);
        }
        em(a, b, c) {
            return this.el(a, b);
        }
        hn(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.el(a.item(e), d));
            }
        }
        hv(a, b, c, d) {
            super.hv(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.nm);
                        this.nm = null;
                    }
                    if (this.kq != null) {
                        this.nm = TimeAxisBase.mi(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeMemberPath":
                    if (this.kq != null) {
                        this.kq.deregisterColumn(this.nm);
                        this.nm = TimeAxisBase.mi(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeColumn":
                    this.c0();
                    this.od = this.oc();
                    break;
                case "MinimumValue":
                case "MaximumValue":
                    this.c0();
                    this.h6();
                    break;
                case "LabellingMode":
                    this.h6();
                    break;
            }
        }
        get actualMinimumValue() {
            return this.no;
        }
        set actualMinimumValue(a) {
            this.no = a;
        }
        get actualMaximumValue() {
            return this.nn;
        }
        set actualMaximumValue(a) {
            this.nn = a;
        }
        get visibleMinimum() {
            return this.nu;
        }
        set visibleMinimum(a) {
            this.nu = a;
        }
        get visibleMaximum() {
            return this.nt;
        }
        set visibleMaximum(a) {
            this.nt = a;
        }
        get ny() {
            return this.nq;
        }
        set ny(a) {
            this.nq = a;
        }
        get nx() {
            return this.np;
        }
        set nx(a) {
            this.np = a;
        }
        og() {
            if (this.nm == null || this.nm.count == 0 || this.nm.count < this.mv - 1) {
                this.actualMinimumValue = dateMinValue();
                this.actualMaximumValue = dateMaxValue();
                return;
            }
            let a = Math.max(0, Math.min(this.mv, this.nm.count - 1));
            let b = Math.max(0, Math.min(this.mu, this.nm.count - 1));
            let c = +(this.actualMinimumValue) != +(this.nm.item(a)) || +(this.actualMaximumValue) != +(this.nm.item(b));
            if (c) {
                let d = this.actualMinimumValue;
                let e = this.actualMaximumValue;
                this.actualMinimumValue = this.nm.item(a);
                this.actualMaximumValue = this.nm.item(b);
                this.oh();
            }
        }
        oh() {
            if (this.nm == null || this.nm.count == 0 || this.bh == null) {
                let a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
                this.visibleMinimum = this.actualMinimumValue;
                this.visibleMaximum = this.actualMaximumValue;
                this.ny = this.visibleMinimum;
                this.nx = this.visibleMaximum;
                if (a && this.visibleRangeChanged != null) {
                    this.visibleRangeChanged(this, EventArgs.empty);
                }
                return;
            }
            let b = this.j6();
            let c = new ScalerParams(1, this.bh.tp, this.bh.to, this.cg);
            c.c = this.j7();
            let d = this.el(b.left, c);
            let e = this.el(b.right, c);
            let f = truncate(Math.floor(d));
            let g = truncate(Math.ceil(e));
            let h = f >= 0 && f < this.nm.count ? this.nm.item(f) : this.actualMinimumValue;
            let i = g >= 0 && g < this.nm.count ? this.nm.item(g) : this.actualMaximumValue;
            let j = h;
            let k = i;
            if (d > f) {
                let l = f + 1;
                let m = l >= 0 && l < this.nm.count ? this.nm.item(l) : i;
                let n = dateAdd(+h, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+m - +h)) * (d - f))));
                j = n;
            }
            if (e < g) {
                let o = g - 1;
                let p = o >= 0 && o < this.nm.count ? this.nm.item(o) : h;
                let q = dateSubtract(+i, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+i - +p)) * (g - e))));
                k = q;
            }
            this.ny = j;
            this.nx = k;
            let r = +(this.visibleMinimum) != +h || +(this.visibleMaximum) != +i;
            this.visibleMinimum = h;
            this.visibleMaximum = i;
            if (r && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
        }
        h8(a) {
            let b = TimeXAxis.ol(this.actualMinimumValue, false, this.actualMinimumValue, this.nk, this.ob, this.ni, this.fj);
            if (b != this.n4 && this.c3) {
                this.ic();
            }
            this.n4 = b;
            super.h8(a);
        }
        get dateTimeMemberPath() {
            return this.n3;
        }
        set dateTimeMemberPath(a) {
            let b = this.dateTimeMemberPath;
            if (a != b) {
                this.n3 = a;
                this.h1("DateTimeMemberPath", b, this.dateTimeMemberPath);
            }
        }
        get nk() {
            return this.nj;
        }
        set nk(a) {
            let b = this.nk;
            if (a != b) {
                this.nj = a;
                this.h1("LabellingMode", enumGetBox(TimeAxisLabellingMode_$type, b), enumGetBox(TimeAxisLabellingMode_$type, this.nk));
            }
        }
        get_cj() {
            return true;
        }
        get nm() {
            return this.nl;
        }
        set nm(a) {
            if (this.nl != a) {
                let b = this.nl;
                this.nl = a;
                this.h1("DateTimeColumn", b, this.nl);
            }
        }
        ip(a, b) {
            super.ip(a, b);
            this.oh();
        }
        getWindowRectForSelection(a, b) {
            if (this.nm == null) {
                return Rect.empty;
            }
            let c = a > b;
            let d = c ? b : a;
            let e = c ? a : b;
            let f = -1;
            while (++f < this.nm.count && this.nm.item(f) < d) {
            }
            let g = this.nm.count;
            while (--g >= 0 && this.nm.item(g) > e) {
            }
            let h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.cg, this.bh.td);
            let i = this.ei(f, h);
            let j = this.ei(g + 1, h);
            return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
        }
        get ni() {
            return this.nh;
        }
        of(a, b) {
            this.h7(false);
        }
        hx(a) {
            super.hx(a);
            this.dateTimeMemberPath = a;
        }
        fy(a) {
            if (this.at != null) {
                return this.at(a);
            }
            if (this.ah != null) {
                return this.ah.i(a);
            }
            if (!(typeCast(Date_$type, a) !== null)) {
                return super.fy(a);
            }
            let b = dateMinValue();
            let c = false;
            if (this.mw != null) {
                if (typeCast(Date_$type, this.mw) !== null) {
                    b = this.mw;
                    c = true;
                }
            }
            let d = TimeXAxis.og(a, c, b, this.nk, this.ob, this.ni, this.fj);
            return d == null ? super.fy(a) : d;
        }
        gc(a) {
            let b = 0;
            if (this.categoryMode == 0) {
                b = truncate(Math.round(a));
            }
            else {
                b = truncate(Math.floor(a));
            }
            if (b < 0 || b > this.lf - 1) {
                return super.gc(a);
            }
            let c = this.nm.item(b);
            let d = this.fy(c);
            if (d == null) {
                return null;
            }
            return d.toString();
        }
        getDateTime(a) {
            let b = truncate(Math.round(a));
            if (b < 0) {
                b = 0;
            }
            if (b > this.lf - 1) {
                b = this.lf - 1;
            }
            if (this.nm == null) {
                return dateMinValue();
            }
            let c = this.nm.item(b);
            return c;
        }
        get oe() {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        }
        get ob() {
            return +(this.nx) - +(this.ny);
        }
        mh() {
            return this.nm;
        }
        io(a, b) {
            super.io(a, b);
            this.oh();
        }
        mo(a, b) {
            let c = this.categoryMode == 0 ? 0 : 0.5;
            return super.mo(a + c, b);
        }
        mn(a, b, c, d) {
            return b;
        }
        oc() {
            if (this.nm == null || this.nm.count < 2) {
                return (0);
            }
            return TimeXAxis.or((a) => this.nm.item(a), this.nm.count);
        }
        itemLabelFormat() {
            return TimeXAxis.on(this.od);
        }
        get minimumValue() {
            return this.ns;
        }
        set minimumValue(a) {
            let b = this.minimumValue;
            if (+a != +b) {
                this.ns = a;
                this.hv(this, "MinimumValue", b, this.minimumValue);
            }
        }
        get maximumValue() {
            return this.nr;
        }
        set maximumValue(a) {
            let b = this.maximumValue;
            if (+a != +b) {
                this.nr = a;
                this.hv(this, "MaximumValue", b, this.maximumValue);
            }
        }
        c2() {
            if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
                return super.c2();
            }
            if (this.cp && this.c3) {
                this.bb = this.ba();
            }
            if (this.kq == null || this.nm == null) {
                return false;
            }
            let a = this.mv;
            if (+(this.minimumValue) != +(dateMinValue())) {
                let b = -1;
                while (b++ <= this.nm.count) {
                    if (this.nm.item(b) >= this.minimumValue) {
                        break;
                    }
                }
                a = b;
            }
            let c = this.categoryMode == 0 ? this.kq.count - 1 : this.kq.count;
            if (+(this.maximumValue) != +(dateMaxValue())) {
                let d = this.kq.count;
                while (d-- > 0) {
                    if (this.nm.item(d) <= this.maximumValue) {
                        break;
                    }
                }
                c = d;
            }
            if (a != this.mv || c != this.mu) {
                let e = new AxisRangeChangedEventArgs(0, this.mv, a, this.mu, c);
                this.mv = a;
                this.mu = c;
                this.h2(e);
                this.og();
                this.ls();
                return true;
            }
            return false;
        }
        l1(a) {
            super.l1(a);
            this.c1(true);
        }
        get isVertical() {
            return this.co;
        }
        j$c(a, b) {
            return this.el.apply(this, arguments);
        }
        j$b(a, b) {
            return this.ei.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.hl.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.hm.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.hn.apply(this, arguments);
        }
        get j$a() {
            return this.cg;
        }
    }
    OrdinalTimeXAxis.$t = /*@__PURE__*/ markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type, IOrdinalAxis_$type]);
    return OrdinalTimeXAxis;
})();
