import { IgrFragmentBase } from "./igr-fragment-base";
import { LineFragment } from "./LineFragment";
/**
 * Represents one part of a StackedLineSeries.
*/
export class IgrLineFragment extends IgrFragmentBase {
    createImplementation() {
        return new LineFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows only line shapes.
    */
    get isLineOnly() {
        return this.i.d2;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.de;
    }
}
