import { IgrSplineFragmentBase } from "./igr-spline-fragment-base";
import { SplineAreaFragment } from "./SplineAreaFragment";
/**
 * Represents one part of a StackedSplineAreaSeries.
*/
export class IgrSplineAreaFragment extends IgrSplineFragmentBase {
    createImplementation() {
        return new SplineAreaFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.de;
    }
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea() {
        return this.i.dd;
    }
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline() {
        return this.i.eh;
    }
}
