import { IgrHorizontalStackedSeriesBase } from "./igr-horizontal-stacked-series-base";
import { StackedSplineSeries } from "./StackedSplineSeries";
import { ensureBool } from "igniteui-react-core";
/**
 * Represents a IgxDataChartComponent stacked spline series.
*/
export class IgrStackedSplineSeries extends IgrHorizontalStackedSeriesBase {
    createImplementation() {
        return new StackedSplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    get isSplineShapePartOfRange() {
        return this.i.ur;
    }
    set isSplineShapePartOfRange(v) {
        this.i.ur = ensureBool(v);
    }
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline() {
        return this.i.eh;
    }
}
