/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cw.s8;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.s3 = null;
        _this.s7 = null;
        _this.ua = { $type: Point_$type, x: 0, y: 0 };
        _this.s5 = null;
        _this.s4 = null;
        _this.s5 = new RadialFrame(3);
        _this.s3 = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bx = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.kx = function () {
        _super.prototype.kx.call(this);
        this.rp = null;
        this.rw = null;
    };
    AnchoredRadialSeries.prototype.hy = function (a, b) {
        var c = this.js(b);
        if (c == AnchoredRadialSeries.$$p[2]) {
            return this.hz(a, b, this.to);
        }
        return _super.prototype.hy.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.l2 = function (a) {
        _super.prototype.l2.call(this, a);
        this.s2 = a;
    };
    AnchoredRadialSeries.prototype.hl = function (a, b) {
        return this.hm(a, b, this.rp, null, this.s8);
    };
    AnchoredRadialSeries.prototype.hj = function (a, b) {
        return this.hk(a, b, this.rp, null, this.s8);
    };
    AnchoredRadialSeries.prototype.f5 = function (a, b, c, d, e) {
        if (this.s8 == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.f6(a, b, this.rp, d, e, this.s8.count, null);
    };
    AnchoredRadialSeries.prototype.gl = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.b0);
        var e = this.td(this.rp, this.b0.bv, this.b0.bu, d);
        var f = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rp.cg, d);
        f.c = this.cd.to;
        return this.gn(this.s8, a, this.rp, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.pq = function (a, b, c) {
        if (this.rw == null || this.rp == null || this.b0 == null || this.b0.bv.isEmpty || this.b0.bu.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.b0);
        var e = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rw.cg, d);
        e.c = this.getEffectiveViewport1(this.b0);
        var f = this.gl(a, b, c);
        f = this.rw.ei(f, e);
        var g = this.rx.c(a);
        if (!b && this.rp != null) {
            var h = this.hl(a, c);
            var i = this.hj(a, c);
            var j = this.td(this.rp, this.b0.bv, this.b0.bu, d);
            var k = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rp.cg, d);
            k.c = this.cd.to;
            var l = this.f5(a, h, this.rp, k, j);
            var m = this.f5(a, i, this.rp, k, j);
            if (m <= l) {
                g = this.rp.ei(i, k) + j;
            }
            else {
                g = this.rp.ei(h, k) + j;
            }
        }
        var n = this.rx.d(g, f, this.b0.bv, this.b0.bu);
        var o = this.rx.e(g, f, this.b0.bv, this.b0.bu);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "s8", {
        get: function () {
            return this.s7;
        },
        set: function (a) {
            if (this.s7 != a) {
                var b = this.s7;
                this.s7 = a;
                this.raisePropertyChanged("ValueColumn", b, this.s7);
            }
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = new DataLegendSeriesValueInfo();
        c.a = 0;
        c.l = this.gl({ $type: Point_$type, x: a, y: b }, false, false);
        c.p = this.to != null ? this.to : "Value";
        c.q = this.tk != null ? this.tk : "V:";
        c.r = this.tm != null ? this.tm : "";
        var d = new DataLegendSeriesContext();
        d.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(c);
            return $ret;
        })());
        d.b = this.av();
        return d;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "t6", {
        get: function () {
            return this.c(AnchoredRadialSeries.tv);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.tv, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.ap = function (a) {
        if (a != null && a == this.rp && this.s8 != null && this.s8.count > 0) {
            return new AxisRange(0, this.s8.count - 1);
        }
        if (a != null && a == this.rw && this.s8 != null && this.s8.count > 0) {
            return new AxisRange(this.s8.minimum, this.s8.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.l7 = function (a, b, c, d) {
        _super.prototype.l7.call(this, a, b, c, d);
        if (this.s2.cx.g$b(a, b, c, d)) {
            this.ml(false);
            this.ls();
        }
        var e = typeCast(NumericAxisBase.$, this.rw);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.s8);
                    this.s8 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.s8 = this.ch(this.to);
                    this.s2.cs.e(this.fv);
                }
                if (e != null && !e.c0()) {
                    this.s2.cs.e(this.fv);
                    this.ml(false);
                }
                break;
            case AnchoredRadialSeries.$$p[2]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.s8);
                    this.s8 = this.ch(this.to);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.c0()) {
                    this.s2.cs.e(this.fv);
                    this.ml(false);
                }
                break;
            case "TrendLineBrush":
                this.mz();
                break;
            case "TrendLineType":
                this.ls();
                break;
        }
    };
    AnchoredRadialSeries.prototype.k3 = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.s2.cs.e(this.fv);
                break;
        }
        this.s2.cx.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.rw != null && !this.rw.c0()) {
                    this.ml(true);
                }
                break;
            case 1:
                if (this.rw != null && !this.rw.c0()) {
                    this.ml(true);
                }
                break;
            case 0:
                if (this.rw != null && !this.rw.c0()) {
                    this.ml(true);
                }
                break;
            case 2:
                if (this.to != null && this.s2.cs.b > 0 && this.rw != null && !this.rw.c0()) {
                    this.ml(true);
                }
                break;
            case 3:
                if (d == this.to) {
                    if (this.rw != null && !this.rw.c0()) {
                        this.ml(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.fb = function (a, b, c) {
        var d = _super.prototype.fb.call(this, a, b, c);
        var e = c;
        if (this.ck == null || this.ck.count == 0 || this.rp == null || this.s8 == null || this.rp.le == 0 || this.rw == null || isInfinity(this.rw.lv) || isInfinity(this.rw.lu) || e.cs.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.td(this.rp, this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.rp.getCategorySize(this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0));
    };
    AnchoredRadialSeries.prototype.get_tb = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "tb", {
        get: function () {
            return this.get_tb();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_c6 = function () {
        return true;
    };
    AnchoredRadialSeries.prototype.get_ek = function () {
        return this.rw != null && this.rw.cg;
    };
    AnchoredRadialSeries.prototype.td = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.sj(), b, c, d);
                break;
        }
        if (a.cg) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.sr = function (a, b) {
        var _this = this;
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.rp;
        var g = this.rw;
        var h = g.lv;
        var i = g.lu;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.qj();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.cs.d;
        n = this.td(f, c, d, e);
        l.cx.i = this.rw.nm;
        l.cx.h = this.rw.nl;
        l.cx.j = function (p, q) { return _this.te(p, q, c, d); };
        l.cx.k = function (p, q) { return _this.tf(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.cs.b;
            $ret.d = b.cs.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.fv;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.cx.l(a.p, this.s6, this.s8, this.th, function (r) { return _this.rp.getScaledAngle(r); }, function (r) { return _this.rw.ns(r); }, q, p);
        var r = true;
        if (this.tc(b)) {
            o--;
        }
        for (var s = b.cs.c; s <= o; ++s) {
            var t = s;
            if (t * b.cs.b >= this.rp.le) {
                t -= intDivide((this.rp.le), b.cs.b);
            }
            var u = b.cs.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.ns(u[1]);
                if (b.cs.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.ns(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.tb && this.ta()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.cs.b, this.ck.count - 1);
                    var w = this.rx.d(u[0], u[1], c, d);
                    var x = this.rx.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.ct.item(k);
                        z.al = t;
                        z.ak = v;
                        z.content.item = this.ck.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.tb && this.ta()) {
                    o++;
                }
            }
        }
        b.ct.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.te = function (a, b, c, d) {
        return this.rx.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.tf = function (a, b, c, d) {
        return this.rx.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.tc = function (a) {
        var b = a;
        return !this.tb && b.cs.c == 0 && b.cs.d == this.rp.le;
    };
    AnchoredRadialSeries.prototype.s1 = function (a, b, c) {
        var d = null;
        var e = c.bv;
        var f = c.bu;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.tu = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.s9()) {
                a.add(this.ua);
                a.add(a._inner[0]);
                d.add(this.ua);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.ta = function () {
        return !this.s9();
    };
    AnchoredRadialSeries.prototype.s9 = function () {
        var a = this.b0.bv;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.k0 = function (a, b) {
        _super.prototype.k0.call(this, a, b);
        var c = b;
        if (a) {
            c.ct.clear();
        }
        c.cx.g$d();
    };
    AnchoredRadialSeries.prototype.su = function (a, b) {
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pv(b);
        var g = b;
        g.cx.g$g(a.p);
        CategoryMarkerManager.e(this, a.m, g.ct, this.ql);
        this.tr(b, a);
        g.cm();
        this.tq(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.s0 = function (a, b, c) {
        if (b < a || a < 0 || a > this.s8.count || b < 0 || b > this.s8.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cm;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.ck.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ts = function (a, b, c, d, e, f) {
        var g = this.bk != 1;
        this.r3.a1(this.r3.d, d.cm, a, b, c, d, e, f, true);
        this.r3.aa(this.ft);
        var h = this.r3.av;
        var i = null;
        var j = this.ck;
        var k = null;
        if (g && this.cd != null) {
            i = this.cd.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.cd.a7.isCrossSeriesHighlight(this)) {
                k = this.cd.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.ss(h);
        this.r3.y(this, i, f, g, h.m, this.cd.a7.totalHighlightingProgress);
    };
    AnchoredRadialSeries.prototype.tt = function (a, b, c, d, e, f) {
        var g = this.bk != 1;
        this.r3.a1(this.r3.b, d.cm, a, b, c, d, e, f, false);
        this.r3.ab(this.ft);
        var h = this.r3.aw;
        var i = null;
        var j = this.ck;
        if (g && this.cd != null) {
            i = this.cd.a7.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.st(h);
        this.r3.z(this, i, f, g, b < 0);
    };
    AnchoredRadialSeries.prototype.tr = function (a, b) {
        a.b3 = true;
        this.r3.az(this, this.se(), runOn(this, this.rm), this.sh(a), this.si(a));
        var c = this.r3.d;
        var d = c != null;
        var e = this.rp;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bv, a.bu, e.cg, f);
        var h = this.ck == null ? 0 : this.ck.count;
        var i = a;
        var j = b.f;
        var k = i.cs.c;
        var l = i.cs.d;
        var m = i.cs.b;
        var n = k * m;
        for (var o = 0; o < a.ct.count; o++) {
            var p = a.ct.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.ts(j, r, h, e, g, a.q);
            }
            this.r3.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.tq = function (a, b, c, d, e) {
        e.cy(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.mz = function () {
        _super.prototype.mz.call(this);
        if (this.index < 0) {
            return;
        }
        this.s2.cz();
    };
    AnchoredRadialSeries.prototype.h1 = function (a, b) {
        if (a == this.s2.cx.g$j) {
            return null;
        }
        return _super.prototype.h1.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.eo = function (a) {
        var b = this.b0.bv;
        b = b.copy();
        var c = this.b0.bu;
        var d = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
        if (this.rp == null || this.s8 == null || this.rw == null) {
            return false;
        }
        if (d < 0 || d > this.s8.count - 1) {
            return false;
        }
        var e = this.rp.getScaledAngle(d);
        var f = this.rw.ns(this.s8.item(d));
        if (isNaN_(f)) {
            f = (this.rw.nl + this.rw.nm) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.b8 != null) {
            this.b8.au(this.cd, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.mn = function (a, b) {
        _super.prototype.mn.call(this, a, b);
        if (!this.e1) {
            this.b0.a2(b);
            return;
        }
        this.b0.a2(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.bz);
        c.cs.e(this.fv);
        if (this.cx(this.bz)) {
            return;
        }
        if (!this.ev) {
            this.s5 = new RadialFrame(3);
            this.sr(this.s5, c);
        }
        this.ev = false;
        this.su(this.s5, c);
        this.e1 = false;
    };
    AnchoredRadialSeries.prototype.mk = function (a, b, c, d, e) {
        _super.prototype.mk.call(this, a, b, c, d, e);
        var f = this.a6.a$h.item(d);
        var g = f;
        g.cs.e(this.fv);
        f.a1(c);
        if (this.cx(g)) {
            return;
        }
        if (this.s4 == null) {
            this.s4 = new RadialFrame(3);
        }
        this.s4.u();
        this.sr(this.s4, g);
        this.su(this.s4, g);
    };
    AnchoredRadialSeries.prototype.la = function (a) {
        _super.prototype.la.call(this, a);
        this.a8.exportTrendlineData(this, a, this.s2.cx.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.tv = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberAsLegendLabel:tk:t3', [2, null], 'ValueMemberAsLegendUnit:tm:t4', [2, null], 'ValueMemberPath:to:t5', [2, null], 'TrendLineType:s6:t1', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:tg:t0', [1, 1.5], 'TrendLinePeriod:th:tz', [1, 7], 'TrendLineZIndex:ti:t2', [1, 1], 'TrendLineBrush:t7:tw', [Brush.$, null], 'TrendLineDashArray:t8:tx', [DoubleCollection.$], 'TrendLineDashCap:t9:ty', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cs = new AnchoredRadialBucketCalculator(_this);
        _this.cw = a;
        _this.cx = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cy = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cz = function () {
        this.cw.t6 = null;
        if (this.cw.t7 != null) {
            this.cw.t6 = this.cw.t7;
        }
        else {
            this.cw.t6 = this.cw.o3;
        }
    };
    AnchoredRadialSeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cw.s6 != 0 && !b) {
                var c = this.cx.g$j;
                c.ac = this.cw.tg;
                c._stroke = this.cw.t6;
                c.ai = this.cw.t8;
                c.ad = this.cw.t9;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cw.rp.fz != null) {
            a += "<span>${item." + this.cw.rp.fz + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a6.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.to + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
