/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-react-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-react-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cr.fv;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bv;
        var c = this.a.bu;
        var d = this.a.cr.rp;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cr.ck == null || this.a.cr.ck.count == 0) {
            this.b = 0;
            return;
        }
        var e = Math.floor(d.mw(c, b));
        var f = Math.ceil(d.mv(c, b));
        if (d.cg) {
            f = Math.ceil(d.mw(c, b));
            e = Math.floor(d.mv(c, b));
        }
        if (f < e) {
            f = d.le + f;
        }
        var g = this.a.cr.rw;
        var h = g != null ? g.nm : 0.75;
        var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        var j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.r3 = null;
        _this.r4 = null;
        _this.r6 = false;
        _this.r5 = false;
        _this.ru = null;
        _this.rv = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.r1 = new RadialFrame(3);
        _this.r2 = new RadialFrame(3);
        _this.rz = new RadialFrame(3);
        _this.rx = null;
        _this.r3 = new RadialSeriesRenderManager();
        _this.r4 = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(_this, _this.sr), runOn(_this, _this.su), runOn(_this, _this.cv), runOn(_this, _this.mu), runOn(_this, _this.sq), function (a) { return _this.ry.cs.e(_this.fv); });
        return _this;
    }
    RadialBase.prototype.l2 = function (a) {
        _super.prototype.l2.call(this, a);
        this.ry = a;
    };
    RadialBase.prototype.sq = function () {
        if (this.ce.g) {
            this.ce.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.rp;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.ar = function () {
        return this.rp;
    };
    RadialBase.prototype.rm = function (a, b) {
        return null;
    };
    RadialBase.prototype.c1 = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.rp;
        var f = new ScalerParams(1, this.cd.s9, this.p3, e.cg);
        f.c = this.getEffectiveViewport1(this.b0);
        var g = this.rw;
        var h = new ScalerParams(1, this.cd.s9, this.p3, g.cg);
        h.c = this.getEffectiveViewport1(this.b0);
        a.clear();
        this.qg.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.p3.left || k > _this.p3.right || l < _this.p3.top || l > _this.p3.bottom) {
                    return;
                }
                var m = void 0;
                var n = void 0;
                var o = _this.rx.g(k, l, _this.b0.bv, _this.b0.bu, m, n);
                m = o.p4;
                n = o.p5;
                j.b = m;
                j.c = n;
                if (b) {
                    if (c) {
                        j.d = _this.sl(j.c, d);
                    }
                    else {
                        var p = _this.gq(i);
                        if (!isNaN_(p)) {
                            j.d = _this.sl(p, d);
                        }
                        else {
                            j.d = _this.sl(j.c, d);
                        }
                    }
                }
                else {
                    j.d = e.gc(i.ak);
                }
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    RadialBase.prototype.sl = function (a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    };
    RadialBase.prototype.get_eb = function () {
        return true;
    };
    RadialBase.prototype.get_dy = function () {
        return true;
    };
    RadialBase.prototype.rr = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ck.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.rs = function (a, b, c) {
        var d = this.ry.cs.c;
        var e = this.ry.cs.d;
        var f = this.ry.cs.b;
        var g = this.r0();
        var h = this.ck.count;
        var i = this.rp;
        var j = -1;
        var k = -1;
        var l = this.hf(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.rt = function (a, b, c) {
        var d = this.ry.cs.c;
        var e = this.ry.cs.d;
        var f = this.ry.cs.b;
        var g = this.r0();
        var h = this.ck.count;
        var i = this.rp;
        var j = -1;
        var k = -1;
        var l = this.hf(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.e = true;
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.aw = function (a, b, c) {
        if (this.c2 && this.eg(this.bk) && !c) {
            var d = this.rs(a, b, this.ru);
            this.ru = d;
            return d;
        }
        else {
            var e = this.rr(a, b, this.ru);
            this.ru = e;
            return e;
        }
    };
    RadialBase.prototype.ax = function (a, b, c) {
        if (this.eg(this.bk) && !c) {
            var d = this.rt(a, b, this.rv);
            this.rv = d;
            return d;
        }
        else {
            var e = this.rr(a, b, this.rv);
            e.e = true;
            this.rv = e;
            return e;
        }
    };
    RadialBase.prototype.sf = function () {
        return (this.assigningRadialStyle != null && this.r6) || (this.bk != 1);
    };
    RadialBase.prototype.se = function () {
        return (this.assigningRadialMarkerStyle != null && this.r5) || (this.bk != 1);
    };
    RadialBase.prototype.st = function (a) {
        if (this.assigningRadialStyle != null && this.r6) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.ss = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.r5) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.sh = function (a) {
        return a.cs.b;
    };
    RadialBase.prototype.si = function (a) {
        return a.cs.c;
    };
    RadialBase.prototype.ag = function () {
        return [this.rp, this.rw];
    };
    RadialBase.prototype.m9 = function (a, b) {
        this.ry.cs.e(this.fv);
        this.ml(false);
    };
    RadialBase.prototype.m8 = function (a, b) {
        this.ry.cs.e(this.fv);
        this.ml(false);
    };
    RadialBase.prototype.l7 = function (a, b, c, d) {
        _super.prototype.l7.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.rp != null) {
                        this.rp.bz(this);
                    }
                    if (this.rw != null) {
                        this.rw.bz(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.rp != null) {
                        this.rp.cs(this);
                    }
                    if (this.rw != null) {
                        this.rw.cs(this);
                    }
                }
                this.ry.cs.e(this.fv);
                this.ml(false);
                break;
            case RadialBase.$$p[0]:
                if (this.rp != null && this.rw != null) {
                    this.rx = new RadialAxes(this.rw, this.rp);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                this.ry.cs.e(this.fv);
                this.ml(false);
                break;
            case RadialBase.$$p[4]:
                if (this.rp != null && this.rw != null) {
                    this.rx = new RadialAxes(this.rw, this.rp);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                this.ry.cs.e(this.fv);
                if (this.rw == null || !this.rw.c0()) {
                    this.ml(false);
                }
                break;
            case "SyncLink":
                if (this.b8 != null && this.cd != null) {
                    this.ry.cs.e(this.fv);
                    this.ml(false);
                }
                break;
            case "TransitionProgress":
                this.r2.c(this.g2, this.r1, this.rz);
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.g2 == 1) {
                    this.su(this.rz, this.ry);
                }
                else {
                    this.su(this.r2, this.ry);
                }
                if (this.cd != null) {
                    this.cd.oa(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.ml(false);
                this.ls();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.ry.cs.e(this.fv);
                }
                break;
            case RadialBase.$$p[3]:
                this.r6 = this.sd();
                this.ml(false);
                break;
            case RadialBase.$$p[2]:
                this.r5 = this.sc();
                this.ml(false);
                break;
        }
    };
    RadialBase.prototype.sd = function () {
        return this.sb;
    };
    RadialBase.prototype.sc = function () {
        return this.sa;
    };
    RadialBase.prototype.r8 = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.r7 = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.hv = function (a) {
        var b = this.hf(a);
        return b >= 0 && this.ck != null && b < this.ck.count ? this.ck.item(b) : null;
    };
    RadialBase.prototype.sg = function (a) {
        var b = this.b0.bv;
        var c = this.b0.bu;
        if (this.rp != null && !b.isEmpty && !c.isEmpty && this.rx != null) {
            var d = this.rx.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    };
    RadialBase.prototype.f7 = function (a) {
        var b = this.b0.bv;
        var c = this.b0.bu;
        var d = -1;
        if (this.rp != null && !b.isEmpty && !c.isEmpty && this.rx != null) {
            var e = this.rx.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            var f = this.rp.getUnscaledAngle(e);
            if (this.rp.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    };
    RadialBase.prototype.hf = function (a) {
        var b = truncate(Math.round(this.f7(a)));
        if (this.ck != null && b == this.ck.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.eo = function (a) {
        return false;
    };
    RadialBase.prototype.r0 = function () {
        var a = this.rz;
        if (this.cv()) {
            if (this.ce.g) {
                this.ce.t();
            }
            a = this.r2;
        }
        return a;
    };
    RadialBase.prototype.li = function () {
        _super.prototype.li.call(this);
        if (this.rp != null) {
            this.rp.h7(false);
        }
        if (this.rw != null) {
            this.rw.h7(false);
        }
    };
    RadialBase.prototype.fb = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.fb.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.rp == null || this.rp.itemsSource == null || this.rw == null || this.rx == null || this.ck == null || this.rp.bh == null || this.rw.bh == null || this.rw.lv == this.rw.lu) {
            e.cs.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.mm = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.fb(c, b, this.b0)) {
            this.k0(true, this.b0);
            return;
        }
        var e = new SeriesRenderingArguments(this, c, b, a, this.eu);
        var f = this.r4.g(e, this.r1, this.rz, this.r2, this.ry);
        this.r1 = f.p1;
        this.rz = f.p2;
        this.r2 = f.p3;
    };
    RadialBase.prototype.sj = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.cd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(RadialBase.$, b);
                if (c != null && c.rp == this.rp && c.preferredCategoryMode(c.rp) == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:rp:sv', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:r9:sw', [0, false], 'IsCustomRadialMarkerStyleAllowed:sa:sx', [0, false], 'IsCustomRadialStyleAllowed:sb:sy', [0, false], 'ValueAxis:rw:sz', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.cr = null;
        _this.ct = null;
        _this.cu = 0;
        _this.cv = null;
        _this.cr = a;
        _this.ct = new Pool$1(Marker.$);
        _this.ci(_this.ct);
        return _this;
    }
    RadialBaseView.prototype.cf = function (a) {
        this.ct.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
