import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private tp;
    get tq(): IAnchoredCategorySeriesInteractionManager;
    tl: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    i2(): string;
    protected bx(): SeriesView;
    l2(a: SeriesView): void;
    tt: boolean;
    constructor();
    t5: string;
    hy(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private tr;
    t1: string;
    t3: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get up(): Brush;
    set up(a: Brush);
    static readonly uc: DependencyProperty;
    trendLineThickness: number;
    ur: PenLineCap;
    uq: DoubleCollection;
    trendLinePeriod: number;
    tv: number;
    eo(a: any): boolean;
    protected ti(a: number, b: number, c: Axis): any[];
    protected l7(a: any, b: string, c: any, d: any): void;
    ap(a: Axis): AxisRange;
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected ss(): number;
    tu(a: CategorySeriesView): number;
    ua(a: PointCollection, b: number, c: CategorySeriesView): void;
    tj(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    tk(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    k0(a: boolean, b: SeriesView): void;
    s8(a: CategoryFrame, b: CategorySeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    tm: CategoryFrame;
    mk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    t7(a: CategoryFrame, b: CategorySeriesView): void;
    protected mz(): void;
    h1(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected tx: string;
    abstract t8(a: Axis): void;
    abstract t9(a: Axis): void;
    protected la(a: any): void;
    tn: CategorySeriesMarkerCollisionAvoidance;
    hv(a: Point): any;
    to: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    ge(): number;
    protected get_tw(): number;
    protected get tw(): number;
    aq(a: Rect): AxisRange;
    private ub;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c1;
    get c2(): ITrendLineManager;
    set c2(a: ITrendLineManager);
    get c3(): boolean;
    c7(): void;
    c5(): void;
    c4(): void;
    cs(): CategoryBucketCalculator;
    c6(): void;
    c8(): void;
    c9(a: number): Rect;
    protected a5(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
