import { Base, Type } from "igniteui-react-core";
import { AxisVisualDataList } from "./AxisVisualDataList";
import { SeriesVisualDataList } from "./SeriesVisualDataList";
import { ChartTitleVisualData } from "./ChartTitleVisualData";
import { RectData } from "igniteui-react-core";
import { GetPointsSettings } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ChartVisualData extends Base {
    static $t: Type;
    constructor();
    private _axes;
    get axes(): AxisVisualDataList;
    set axes(a: AxisVisualDataList);
    private _series;
    get series(): SeriesVisualDataList;
    set series(a: SeriesVisualDataList);
    private _title;
    get title(): ChartTitleVisualData;
    set title(a: ChartTitleVisualData);
    private _subtitle;
    get subtitle(): ChartTitleVisualData;
    set subtitle(a: ChartTitleVisualData);
    private _width;
    get width(): number;
    set width(a: number);
    private _height;
    get height(): number;
    set height(a: number);
    private _contentArea;
    get contentArea(): RectData;
    set contentArea(a: RectData);
    private _centralArea;
    get centralArea(): RectData;
    set centralArea(a: RectData);
    private _plotArea;
    get plotArea(): RectData;
    set plotArea(a: RectData);
    private _name;
    get name(): string;
    set name(a: string);
    private _isViewportScaled;
    get isViewportScaled(): boolean;
    set isViewportScaled(a: boolean);
    scaleByViewport(): void;
    getBounds(): RectData;
    serialize(): string;
    getSerializedSeriesPoints(a: string, b: string, c: GetPointsSettings): string;
    private _dipScalingRatio;
    get dipScalingRatio(): number;
    set dipScalingRatio(a: number);
}
