import { Type } from "igniteui-react-core";
/**
 * Describes available methods of collision avoidance of series' markers.
 */
export declare enum CollisionAvoidanceType {
    /**
     * Collision avoidance is disabled.
     */
    None = 0,
    /**
     * Items colliding with other items will be hidden from view.
     */
    Omit = 1,
    /**
     * Items colliding with other items will be partially hidden from view by reducing their opacity.
     */
    Fade = 2,
    /**
     * Items colliding with other items will be either hidden from view or moved to new positions.
     */
    OmitAndShift = 3,
    /**
     * Items colliding with other items will be either partially hidden from view by reducing their opacity, or moved to new positions, or a combination of both.
     */
    FadeAndShift = 4
}
/**
 * @hidden
 */
export declare let CollisionAvoidanceType_$type: Type;
