import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    l2(a: SeriesView): void;
    qx: FinancialSeriesView;
    protected get_dq(): boolean;
    ag(): Axis[];
    hy(a: any, b: string): any;
    protected sg(): number;
    private se;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    tm: Brush;
    pd(): Brush;
    pe(): Brush;
    kx(): void;
    protected get_c6(): boolean;
    protected get_ek(): boolean;
    qg: CategoryAxisBase;
    q2: NumericYAxis;
    sw: string;
    get rc(): IFastItemColumn$1<number>;
    set rc(a: IFastItemColumn$1<number>);
    private q7;
    sn: string;
    get ra(): IFastItemColumn$1<number>;
    set ra(a: IFastItemColumn$1<number>);
    private q5;
    ss: string;
    get rb(): IFastItemColumn$1<number>;
    set rb(a: IFastItemColumn$1<number>);
    private q6;
    sk: string;
    get q9(): IFastItemColumn$1<number>;
    set q9(a: IFastItemColumn$1<number>);
    private q4;
    s0: string;
    get re(): IFastItemColumn$1<number>;
    set re(a: IFastItemColumn$1<number>);
    private q8;
    rm: boolean;
    protected rh: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    ro(): boolean;
    protected s8(a: AssigningCategoryStyleEventArgs): void;
    protected qp: CategorySeriesRenderManager;
    protected s6(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    r6(a: Point): number;
    hl(a: Point, b: boolean): number;
    hj(a: Point, b: boolean): number;
    f5(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    pq(a: Point, b: boolean, c: boolean): Point;
    gl(a: Point, b: boolean, c: boolean): number;
    gh(a: Point, b: boolean, c: boolean): number;
    gj(a: Point, b: boolean, c: boolean): number;
    r8(a: Point, b: boolean, c: boolean): number;
    r9(a: Point, b: boolean, c: boolean): number;
    sa(a: Point, b: boolean, c: boolean): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    po(a: Point, b: boolean, c: boolean): Point;
    to(a: Point, b: boolean, c: boolean): Point;
    tn(a: Point, b: boolean, c: boolean): Point;
    tp(a: Point, b: boolean, c: boolean): Point;
    li(): void;
    protected m9(a: Rect, b: Rect): void;
    protected m8(a: Rect, b: Rect): void;
    protected rr: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected rs: Dictionary$2<string, string>;
    private rd;
    private s5;
    private rg;
    protected l7(a: any, b: string, c: any, d: any): void;
    rj(a: any): boolean;
    ri(a: any): boolean;
    protected p9(a: number, b: number, c: Axis): any[];
    protected sd(a: SeriesView): number;
    protected sf(a: SeriesView): number;
    p8(a: number, b: number): any[];
    private q0;
    protected get_dy(): boolean;
    ky(): void;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    sh(a: Point): number;
    protected qz(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected qy(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rk(): boolean;
    f7(a: Point): number;
    hf(a: Point): number;
    protected get_ea(): boolean;
    ar(): CategoryAxisBase;
    hh(a: Point): number;
    hv(a: Point): any;
    qk: CategoryFrame;
    qm: CategoryFrame;
    qi: CategoryFrame;
    qj(): CategoryFrame;
    protected r7(a: Rect, b: Rect, c: Rect): number;
    qr: CategoryTransitionInMode;
    rn: boolean;
    protected es(): boolean;
    protected qq(): CategoryTransitionInMode;
    protected b9(): TransitionInSpeedType;
    s9(a: CategoryFrame, b: FinancialSeriesView): void;
    s7(a: CategoryFrame, b: FinancialSeriesView): void;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    qs: CategoryTransitionSourceFramePreparer;
    sb(a: FinancialSeriesView): number;
    protected k1(): void;
    mm(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected rp(a: IList$1<string>): boolean;
    get rq(): boolean;
    protected rl(): boolean;
    protected s4(a: FinancialEventArgs): void;
    protected get ry(): IEnumerable$1<number>;
    private _rv;
    private rv;
    protected get rx(): IEnumerable$1<number>;
    private _ru;
    private ru;
    protected get rw(): IEnumerable$1<number>;
    private _rt;
    private rt;
    r0(a: IList$1<number>): IList$1<number>;
    private rf;
    protected rz(): IList$1<string>;
    private r4;
    getOpenColumnAsArray(): number[];
    private r2;
    getHighColumnAsArray(): number[];
    private r3;
    getLowColumnAsArray(): number[];
    private r1;
    getCloseColumnAsArray(): number[];
    private r5;
    getVolumeColumnAsArray(): number[];
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected qt(a: number, b: number): FinancialCalculationDataSource;
    sc(a: number): number;
    protected qu(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private ql;
    mn(a: Rect, b: RenderSurface): void;
    private qh;
    mk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    an(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private qn;
    get qo(): CategoryMode;
    set qo(a: CategoryMode);
    protected get_d4(): boolean;
    mq(a: Brush, b: Brush): void;
    private ta;
    private q1;
    private q3;
    hx(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bz: FinancialSeries;
    bx: FinancialBucketCalculator;
    b1: number;
    b0(a: CategoryFrame): boolean;
    b2(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract by(): FinancialBucketCalculator;
    as(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
