import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { GeometryGroup } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_dt(): boolean;
    protected gw(): number;
    protected bx(): SeriesView;
    l2(a: SeriesView): void;
    tr: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get uz(): Brush;
    set uz(a: Brush);
    static readonly uh: DependencyProperty;
    trendLineThickness: number;
    u2: PenLineCap;
    u1: DoubleCollection;
    trendLinePeriod: number;
    tv: number;
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ts: PriceDisplayType;
    protected bp(): SeriesHitTestMode;
    pz(a: Point): Rect;
    private tq;
    ak(a: Point): Rect[];
    ex(a: Point, b: boolean): boolean;
    protected e0(a: Point, b: boolean): boolean;
    protected l7(a: any, b: string, c: any, d: any): void;
    private ug;
    ap(a: Axis): AxisRange;
    aq(a: Rect): AxisRange;
    ge(): number;
    eo(a: any): boolean;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    s7(a: CategoryFrame, b: FinancialSeriesView): void;
    k0(a: boolean, b: SeriesView): void;
    protected m8(a: Rect, b: Rect): void;
    p5(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected get_c2(): boolean;
    s9(a: CategoryFrame, b: FinancialSeriesView): void;
    gc(): number;
    private uf;
    private tt;
    private ue;
    h1(a: any, b: Point): any;
    protected mz(): void;
    protected la(a: any): void;
    u0: Brush;
    pe(): Brush;
    mq(a: Brush, b: Brush): void;
    protected ba(a: LegendItemBadgeShape): LegendItemBadgeShape;
    t5: string;
    t1: string;
    tw: string;
    ua: string;
    t7: string;
    t3: string;
    ty: string;
    uc: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected b3: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b6: Pool$1<Path>;
    co(): Path;
    protected b9: List$1<Path>;
    ce(a: Path): void;
    cg(a: Path): void;
    cf(a: Path): void;
    protected by(): FinancialBucketCalculator;
    as(): void;
    private cn;
    private cm;
    private b4;
    get b5(): ITrendLineManager;
    set b5(a: ITrendLineManager);
    get b7(): boolean;
    ch(): void;
    cb(): void;
    ca(): void;
    ck(): GeometryGroup;
    cj(): GeometryGroup;
    ci(): void;
    protected bb(): void;
    protected bc(): void;
    protected ac(a: number): any;
    private cl;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    cc(): void;
    b8: boolean;
    cd(): void;
}
