import { Type } from "igniteui-react-core";
/**
 * Describes available modes of displaying elements in the chart grid, such as gridlines.
 */
export declare enum GridMode {
    /**
     * No chart grid.
     */
    None = 0,
    /**
     * Chart grid should be rendered before or in front of the data series.
     */
    BeforeSeries = 1,
    /**
     * Chart grid should be rendered behind or in back of the data series.
     */
    BehindSeries = 2
}
/**
 * @hidden
 */
export declare let GridMode_$type: Type;
