import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Type, Base, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-react-core";
import { ILegendOwner } from "igniteui-react-core";
import { IInternalLegendOwner } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { DoubleAnimator } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Brush } from "igniteui-react-core";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-react-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-react-core";
import { IOverviewPlusDetailPane } from "igniteui-react-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { ModifierKeys } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { CanvasRenderScheduler } from "igniteui-react-core";
import { SyncSettings } from "./SyncSettings";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolCommand } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { FrameworkElement } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { Key } from "igniteui-react-core";
import { RectChangedEventArgs } from "igniteui-react-core";
import { CultureInfo } from "igniteui-react-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-react-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-react-core";
import { IFastItemsSource } from "igniteui-react-core";
import { CoercionInfo } from "./CoercionInfo";
import { IDataLegendSeries } from "igniteui-react-core";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { IExecutionContext } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-react-core";
import { Geometry } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { ActualLegendItemBadgeShape } from "./ActualLegendItemBadgeShape";
import { StandardLegendItems } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-react-core";
import { Canvas } from "igniteui-react-core";
import { IFastItemsSourceProvider } from "igniteui-react-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-react-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-react-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-react-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-react-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { AutomaticSeriesPurpose } from "./AutomaticSeriesPurpose";
import { HighlightingState } from "./HighlightingState";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { ILegendSeries } from "igniteui-react-core";
import { ILegendSeriesInternal } from "igniteui-react-core";
import { ILegendTemplateProvider } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { ISortingAxis } from "./ISortingAxis";
import { DataLegendSeriesGroup } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner, IDataLegendTarget, IToolbarTarget {
    static $t: Type;
    private _widget;
    get widget(): ISeriesViewerWidget;
    set widget(a: ISeriesViewerWidget);
    cu: SeriesViewerView;
    static staticInit(): void;
    private c6;
    private get c7();
    private an;
    ao(a: SeriesViewer): AutomaticSeriesManager;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): void;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private a5;
    get a6(): IDataChartToolbarProvider;
    get eo(): boolean;
    private a8;
    get a9(): ISeriesViewerInteractionManager;
    get eh(): boolean;
    constructor();
    private cm;
    l2(): void;
    private n0;
    protected get_ez(): boolean;
    get ez(): boolean;
    protected get_ey(): boolean;
    get ey(): boolean;
    l3(): void;
    get series(): SeriesCollection;
    private bp;
    private ou;
    private bw;
    get bx(): SeriesPlotAreaMarginHorizontalMode;
    set bx(a: SeriesPlotAreaMarginHorizontalMode);
    private by;
    get bz(): SeriesPlotAreaMarginVerticalMode;
    set bz(a: SeriesPlotAreaMarginVerticalMode);
    l5(): void;
    protected mq(): void;
    private _skipDataCleanup;
    get skipDataCleanup(): boolean;
    set skipDataCleanup(a: boolean);
    protected oo(a: any): void;
    private ov;
    l8(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    d3(): boolean;
    get fb(): boolean;
    protected get ed(): boolean;
    protected get dw(): boolean;
    protected get dv(): boolean;
    get du(): boolean;
    get a7(): IHighlightingManager;
    get ba(): ISeriesViewerScrollbarManager;
    private lw;
    cv: DoubleAnimator;
    cw: DoubleAnimator;
    private l1;
    o8(a: number): void;
    l0(): void;
    sg(a: number): Brush;
    sm(a: number): Brush;
    sk(a: number): Brush;
    sl(a: number): Brush;
    private sf;
    ag: BrushCollection;
    aj: BrushCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    be: MarkerAutomaticBehavior;
    ar: ChartContentManager;
    get s0(): Point;
    set s0(a: Point);
    private sz;
    ok(): void;
    get eg(): boolean;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly qs: DependencyProperty;
    get ds(): boolean;
    set ds(a: boolean);
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    ng(a: Point, b: boolean): void;
    private bf;
    private bj;
    nh(a: Point, b: boolean, c: boolean): void;
    static readonly px: DependencyProperty;
    get ep(): boolean;
    set ep(a: boolean);
    static readonly qo: DependencyProperty;
    get fa(): boolean;
    set fa(a: boolean);
    static readonly rb: DependencyProperty;
    get bv(): SeriesHighlightingMode;
    set bv(a: SeriesHighlightingMode);
    static readonly p7: DependencyProperty;
    get b5(): SeriesViewerScrollbarMode;
    set b5(a: SeriesViewerScrollbarMode);
    protected b3: SeriesViewerScrollbarMode;
    static readonly qf: DependencyProperty;
    get b6(): SeriesViewerScrollbarMode;
    set b6(a: SeriesViewerScrollbarMode);
    protected b4: SeriesViewerScrollbarMode;
    static readonly rp: DependencyProperty;
    get b2(): SeriesViewerHorizontalScrollbarPosition;
    set b2(a: SeriesViewerHorizontalScrollbarPosition);
    static readonly qh: DependencyProperty;
    get b7(): SeriesViewerVerticalScrollbarPosition;
    set b7(a: SeriesViewerVerticalScrollbarPosition);
    static readonly rr: DependencyProperty;
    get so(): Brush;
    set so(a: Brush);
    static readonly qb: DependencyProperty;
    get sp(): Brush;
    set sp(a: Brush);
    static readonly qg: DependencyProperty;
    get gs(): number;
    set gs(a: number);
    static readonly qj: DependencyProperty;
    get gr(): number;
    set gr(a: number);
    static readonly qe: DependencyProperty;
    get go(): number;
    set go(a: number);
    static readonly qa: DependencyProperty;
    get gp(): number;
    set gp(a: number);
    static readonly qc: DependencyProperty;
    get gq(): number;
    set gq(a: number);
    static readonly qd: DependencyProperty;
    get gu(): number;
    set gu(a: number);
    static readonly ql: DependencyProperty;
    get gt(): number;
    set gt(a: number);
    static readonly qk: DependencyProperty;
    get d5(): boolean;
    set d5(a: boolean);
    static readonly i4: string;
    static readonly qi: DependencyProperty;
    get sx(): Brush;
    set sx(a: Brush);
    static readonly rm: DependencyProperty;
    get sy(): Brush;
    set sy(a: Brush);
    static readonly rq: DependencyProperty;
    get he(): number;
    set he(a: number);
    static readonly rt: DependencyProperty;
    get hd(): number;
    set hd(a: number);
    static readonly ro: DependencyProperty;
    get hb(): number;
    set hb(a: number);
    static readonly rl: DependencyProperty;
    get hh(): number;
    set hh(a: number);
    static readonly rw: DependencyProperty;
    get hc(): number;
    set hc(a: number);
    static readonly rn: DependencyProperty;
    get hg(): number;
    set hg(a: number);
    static readonly rv: DependencyProperty;
    get hf(): number;
    set hf(a: number);
    static readonly ru: DependencyProperty;
    get fj(): boolean;
    set fj(a: boolean);
    static readonly k1: string;
    static readonly rs: DependencyProperty;
    private bu;
    private br;
    get bs(): SeriesHighlightingBehavior;
    get bt(): SeriesHighlightingBehavior;
    set bt(a: SeriesHighlightingBehavior);
    static readonly p6: DependencyProperty;
    get bb(): LegendHighlightingMode;
    set bb(a: LegendHighlightingMode);
    static readonly qp: DependencyProperty;
    get bd(): LegendItemBadgeShape;
    set bd(a: LegendItemBadgeShape);
    static readonly qr: DependencyProperty;
    get bc(): LegendItemBadgeMode;
    set bc(a: LegendItemBadgeMode);
    static readonly qq: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected n8(a: string, b: any, c: any): void;
    m7(): void;
    m8(a: IEnumerable): void;
    nj(a: Series, b: any, c: any): void;
    nn(a: Series, b: any, c: any): void;
    nk(a: Series, b: any, c: any): void;
    nl(a: Series, b: any, c: any): void;
    nm(a: Series, b: any, c: any): void;
    lh(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    get ev(): boolean;
    private dg;
    mp(): void;
    no(a: Series, b: any, c: any): void;
    np(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    ob(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    of(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    og(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    oz(a: Point): void;
    o0(a: Point): void;
    oh(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    od(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    oe(a: Series, b: any, c: MouseEventArgs): void;
    private db;
    mo(): void;
    private s8;
    protected get_to(): Rect;
    get to(): Rect;
    private s6;
    get td(): Rect;
    set td(a: Rect);
    protected get_d4(): boolean;
    get d4(): boolean;
    ti(a: Rect, b: Rect, c: Rect): Rect;
    private c9;
    private s5;
    protected get_tc(): Rect;
    get tc(): Rect;
    tg(a: Rect, b: Rect, c: Rect): Rect;
    protected tb(a: Rect): Rect;
    th(): Rect;
    protected o4(a: Axis): void;
    tp: Rect;
    fi: boolean;
    dp: boolean;
    e5: boolean;
    hx: number;
    private hp;
    get hs(): number;
    set hs(a: number);
    hv: number;
    hw: number;
    protected ew: boolean;
    protected dr: boolean;
    n3(a: Rect, b: Rect): void;
    private b0;
    b1(): SeriesViewerComponentsForView;
    private de;
    ln(a: Point, b: boolean): void;
    ek: boolean;
    private at;
    get av(): ChartHitTestMode;
    set av(a: ChartHitTestMode);
    oj(): void;
    protected aw(): ChartHitTestMode;
    private as;
    get au(): ChartHitTestMode;
    set au(a: ChartHitTestMode);
    el: boolean;
    seriesAnimating: (series: Series) => void;
    oa(a: Series): void;
    abstract er(): boolean;
    abstract es(): boolean;
    eq(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    get cl(): InteractionState;
    set cl(a: InteractionState);
    private dc;
    private ch;
    na(a: Point): void;
    nb(a: Point, b: boolean): void;
    e3(a: Point, b: number): boolean;
    m0(a: Point): void;
    e2(a: Key): boolean;
    private di;
    dz: boolean;
    private da;
    get dt(): boolean;
    set dt(a: boolean);
    protected get_ei(): boolean;
    get ei(): boolean;
    m2(a: Point): void;
    get d2(): boolean;
    kq: string;
    nf(a: Point): void;
    m3(a: Point, b: boolean): void;
    m1(a: Point): void;
    get e4(): boolean;
    set e4(a: boolean);
    private ny;
    ne(a: Point): void;
    nz(a: Point, b: number, c: number, d: number): void;
    nd(a: number): void;
    nv(a: Point, b: number, c: number, d: number): void;
    m9(a: Point): void;
    nc(a: number): void;
    m4(a: Point): void;
    nu(a: Point, b: number, c: number, d: number): void;
    nr(): void;
    m6(a: Size): void;
    lz(): void;
    mt(a: Point, b: boolean): void;
    cj(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private dm;
    nx(): void;
    nw(): void;
    o1(): void;
    lu(): void;
    lp(): void;
    lo(): void;
    n1(): void;
    on(): void;
    ol(): void;
    ms(a: Point, b: boolean): void;
    e8(): boolean;
    private dj;
    get fd(): boolean;
    set fd(a: boolean);
    mr(a: Point, b: boolean, c: boolean): void;
    pe(a: any, b: PropertyUpdatedEventArgs): void;
    pd(a: SyncLink, b: SyncLink): void;
    lq(a: Point): void;
    ph(a: Rect, b: boolean): void;
    pi(a: Rect, b: boolean, c: boolean): void;
    n2(a: Rect, b: boolean): void;
    get em(): boolean;
    private _fm;
    fm(): IEnumerable$1<SeriesViewer>;
    s3(a: Point): Point;
    s1(a: Point): Point;
    tn(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private oi;
    nt(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    nq(a: Size, b: Size): void;
    d8: boolean;
    e6(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private n6;
    pj(a: number): void;
    pk(a: number): void;
    ot(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private n7;
    protected get_ej(): boolean;
    get ej(): boolean;
    ni(a: Rect, b: Rect): void;
    cb: WindowResponse;
    l7(): void;
    d1: boolean;
    hl: number;
    hk: number;
    private fu;
    get gg(): number;
    set gg(a: number);
    private ft;
    get gf(): number;
    set gf(a: number);
    hn: number;
    hm: number;
    private _syncChannel;
    get syncChannel(): string;
    set syncChannel(a: string);
    private b8;
    get actualSyncLink(): SyncLink;
    set actualSyncLink(a: SyncLink);
    fe: boolean;
    l6(): void;
    tu: Visibility;
    private dl;
    my(): void;
    mw(): void;
    mx(): void;
    get cn(): IOverviewPlusDetailPane;
    protected pa(a: boolean): void;
    tt: Visibility;
    d7: boolean;
    fh: boolean;
    sn: Brush;
    sw: Brush;
    private cc;
    get cd(): ZoomCoercionMode;
    set cd(a: ZoomCoercionMode);
    ce(): ZoomCoercionMode;
    cf: ZoomCoercionMode;
    sr: Brush;
    sd: Brush;
    sq: Brush;
    dy(): boolean;
    dq(): boolean;
    tq: Rect;
    lm(): void;
    private hr;
    private notifyCrosshairUpdate;
    pf(a: number, b: number): void;
    pg(a: number, b: number, c: number, d: number): void;
    gm(): number;
    gn(): number;
    private g0;
    private gz;
    protected n4(a: any, b: string, c: any, d: any): void;
    get ee(): boolean;
    protected get e1(): boolean;
    bo: Series;
    o9(a: Point): void;
    private lg;
    pc(): void;
    protected ml(): void;
    pb(): void;
    private dk;
    protected ff: boolean;
    ci: InteractionState;
    ck: InteractionState;
    r9: ModifierKeys;
    sa: ModifierKeys;
    private s7;
    get tj(): Rect;
    set tj(a: Rect);
    fo: Date;
    fk: boolean;
    protected o3(): void;
    li(a: Rect, b: Rect): void;
    protected mm(a: Rect, b: Rect): void;
    hi: number;
    hj: number;
    private tm;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    n9(): void;
    protected abstract ct(): SeriesViewerView;
    protected ns(a: SeriesViewerView): void;
    static tl: Rect;
    pl: DataTemplate;
    pu: DataTemplate;
    pr: DataTemplate;
    ps: DataTemplate;
    pm: DataTemplate;
    pp: DataTemplate;
    pn: DataTemplate;
    pt: DataTemplate;
    pq: DataTemplate;
    po: DataTemplate;
    kg: string;
    r8: HorizontalAlignment;
    r7: HorizontalAlignment;
    private h3;
    get kn(): string;
    set kn(a: string);
    private h2;
    get kb(): string;
    set kb(a: string);
    private sc;
    get sv(): Brush;
    set sv(a: Brush);
    private sb;
    get su(): Brush;
    set su(a: Brush);
    private f9;
    get g9(): number;
    set g9(a: number);
    private f7;
    get g7(): number;
    set g7(a: number);
    private f8;
    get g8(): number;
    set g8(a: number);
    private f6;
    get g6(): number;
    set g6(a: number);
    private f5;
    get g5(): number;
    set g5(a: number);
    private f3;
    get g3(): number;
    set g3(a: number);
    private f4;
    get g4(): number;
    set g4(a: number);
    private f2;
    get g2(): number;
    set g2(a: number);
    j4: string;
    tr(): Thickness;
    ts(): Thickness;
    ap(a: Axis): AxisTitlePosition;
    aq(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    protected get_e0(): boolean;
    get e0(): boolean;
    mv(): void;
    abstract getFontBrush(): Brush;
    abstract se(): Brush;
    h0: any;
    provideContainer(a: any): void;
    mu(a: number, b: number): void;
    notifyContainerResized(): void;
    te(): Rect;
    lv(): void;
    s2(): Point;
    cy(): FontInfo;
    cx(): FontInfo;
    sh(): Brush;
    si(): Brush;
    lk(a: Series): void;
    op(a: Series): void;
    al: CanvasRenderScheduler;
    am: CanvasRenderScheduler;
    ak: CanvasRenderScheduler;
    private dh;
    get ex(): boolean;
    set ex(a: boolean);
    private c8;
    get dn(): boolean;
    set dn(a: boolean);
    private _syncSettings;
    get syncSettings(): SyncSettings;
    set syncSettings(a: SyncSettings);
    lj(a: any): void;
    or(a: any): void;
    mi(source_: any, a: number, b: any, c: any): void;
    l9(source_: any): void;
    mg(source_: any, a: number, b: any): void;
    mh(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected hy: any;
    protected fl: Dictionary$2<string, any>;
    eu: boolean;
    destroy(): void;
    protected lt(): void;
    oy(source_: any): void;
    os(): void;
    ox(a: string, source_: any): void;
    oq(a: string, b: boolean): void;
    protected ow(a: Series, b: any): void;
    protected o6(a: any): void;
    protected o7(): void;
    private ga;
    get ha(): number;
    set ha(a: number);
    private fz;
    get gw(): number;
    set gw(a: number);
    private f1;
    get g1(): number;
    set g1(a: number);
    private fx;
    get gj(): number;
    set gj(a: number);
    private fw;
    get gi(): number;
    set gi(a: number);
    private fv;
    get gh(): number;
    set gh(a: number);
    e7(): boolean;
    private dd;
    get ea(): boolean;
    set ea(a: boolean);
    private f0;
    get gx(): number;
    set gx(a: number);
    private fy;
    get gv(): number;
    set gv(a: number);
    static cg(a: string, b: any): CoercionInfo;
    private h1;
    get jl(): string;
    set jl(a: string);
    private fq;
    get gc(): number;
    set gc(a: number);
    private fp;
    get gb(): number;
    set gb(a: number);
    e9: boolean;
    private s4;
    get s9(): Rect;
    set s9(a: Rect);
    tf(): Rect;
    d6: boolean;
    private l4;
    tk(): Rect;
    protected ta(): Rect;
    hz(a: number, b: number): any;
    private fr;
    get gd(): number;
    set gd(a: number);
    private fs;
    get ge(): number;
    set ge(a: number);
    mk(): void;
    mj(): void;
    flush(): void;
    ly(a: boolean, b: boolean, c: boolean): void;
    fg(): boolean;
    private pv;
    private ax;
    protected om(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected o2(a: DependencyObject): void;
    lr(): void;
    eb: boolean;
    ec: boolean;
    d9: boolean;
    m5(): void;
    private df;
    get en(): boolean;
    ll(): void;
    et(): boolean;
    private hq;
    hu(): number;
    c1(): FontInfo;
    c0(): FontInfo;
    o5(): void;
    protected dx: boolean;
    st: Brush;
    ss: Brush;
    gy: number;
    ef: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    oc(): void;
    md(): void;
    me(): void;
    private mf;
    mc(a: Point): void;
    private fn;
    attachDataLegend(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    l(): IExecutionContext;
    co(): void;
    p: SeriesViewer;
    c4(): void;
    e(): Series;
    private cn;
    a: CanvasRenderScheduler;
    n: IOverviewPlusDetailPane;
    private dn;
    private dm;
    em(): void;
    private ct;
    private cs;
    o: OverviewPlusDetailViewportHost;
    cb(a: number, b: number, c: RenderSurface): void;
    d5(): void;
    cd(): void;
    d7(): void;
    ck(): void;
    cc(): void;
    ce(): void;
    dy(a: Series): void;
    dc(): void;
    private er;
    aq(a: Series): boolean;
    protected g: SeriesCollection;
    protected b: AxisCollection;
    private ai;
    get au(): boolean;
    set au(a: boolean);
    bp(a: Series): void;
    dt(a: RenderingContext): void;
    bx(): void;
    bt(): void;
    cf(): void;
    ca(): void;
    dr(): void;
    protected fi: Rectangle;
    protected ff: Path;
    d8(): void;
    eg(a: Rect): void;
    bw(): void;
    df(): void;
    eo(a: number, b: number, c: number, d: number): void;
    protected fe: Line;
    protected fd: Line;
    ed(): void;
    cl(): void;
    eh(a: number, b: number, c: number, d: number): void;
    d9(): void;
    cg(): void;
    cj(): void;
    private e6;
    private e7;
    en(a: Rect, b: Rect): void;
    ec(): void;
    ep(a: Rect): void;
    dw(a: Axis): void;
    dx(a: Axis): void;
    bo(a: Axis): void;
    bl(a: Axis): void;
    private h;
    i(): SeriesViewerComponentsFromView;
    static aw(a: Series): List$1<Series>;
    d2(): void;
    j: SeriesViewerViewManager;
    protected w: RenderingContext;
    z: RenderingContext;
    y: RenderingContext;
    x: RenderingContext;
    an: boolean;
    ao: boolean;
    protected bi: any;
    c0(a: any): void;
    private al;
    protected cy(a: Point, b: boolean): void;
    protected cz(a: Point, b: boolean): void;
    protected c3(a: Point): void;
    protected cx(a: Point, b: boolean, c: boolean): void;
    du(a: RenderingContext): void;
    protected get_ap(): boolean;
    get ap(): boolean;
    k: EventProxy;
    ef(): void;
    a9: number;
    f(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bd(): number;
    bc(): number;
    a8: number;
    a7: number;
    private e9;
    private aj;
    cu(): void;
    c1(a: number, b: number): void;
    private fg;
    private fh;
    b6(a: Rectangle): void;
    b9(a: Rectangle): void;
    b8(): void;
    d3(): void;
    private a1;
    private az;
    private a0;
    private ay;
    private ak;
    private aa;
    private b2;
    private ek;
    v(): FontInfo;
    u(): FontInfo;
    private e5;
    private e4;
    private bf;
    private a2;
    private be;
    fm(): Thickness;
    fl(): Thickness;
    protected dv(a: Rect): void;
    cq(): void;
    private fa;
    protected d0(): void;
    isValid(): boolean;
    preRender(): void;
    protected ds(): void;
    protected ab: boolean;
    protected d1(): void;
    c2(): void;
    cw(): void;
    fb(): Rect;
    e8(): Point;
    private d6;
    ee(): void;
    dp(): void;
    protected as(a: Point): boolean;
    c8(a: Point, b: boolean, c: boolean): void;
    protected c7(a: Point): void;
    protected c6(a: Point): void;
    protected c9(a: Point): void;
    d4(): void;
    get ez(): ModifierKeys;
    eq(a: Rect): void;
    cr(a: boolean): void;
    bk(a: boolean): void;
    protected el(): void;
    private af;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    undirty(a: boolean): void;
    get index(): number;
    postRender(): void;
    b7(): void;
    protected ae: boolean;
    ch(): void;
    ea(): void;
    bv(a: boolean): void;
    bm(a: any): void;
    ei(a: number): void;
    ej(a: number): void;
    bn(a: any): void;
    dz(a: any): void;
    da(a: Brush): void;
    bu(a: Point): void;
    av: boolean;
    m(a: boolean): InteractionState;
    c5(): void;
    private et;
    private es;
    bb(a: TextBlock, b: FontInfo): number;
    ba(a: string, b: FontInfo): number;
    dj(): void;
    private eu;
    di(): void;
    de(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dk(): void;
    dl(): void;
    t(): FontInfo;
    e3(): Brush;
    q(): FontInfo;
    e0(): Brush;
    s(): FontInfo;
    r(): FontInfo;
    e2(): Brush;
    e1(): Brush;
    get a4(): number;
    get a5(): number;
    get a6(): number;
    get a3(): number;
    get ew(): TextBlock;
    get ev(): TextBlock;
    fc(): Rect;
    fk(): Thickness;
    fj(): Thickness;
    private ad;
    private ac;
    dd(a: any, b: any): void;
    dh(a: any, b: any): void;
    ey(): HorizontalAlignment;
    ex(): HorizontalAlignment;
    private ag;
    bq(): void;
    am(): boolean;
    b5(): void;
    cp(): void;
    at(a: Point): boolean;
    dq(): void;
    private ax;
    b3(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bh(a: Rect, b: ITileZoomTile, c: number): any;
    b0(): void;
    b1(a: ITileZoomTile): void;
    cm(): void;
    ar: boolean;
    private bg;
    by(): void;
    br(): void;
    bz(a: number): void;
    bs(): void;
    private ah;
    ci(): void;
    eb(): void;
    dg(): void;
    cv(): void;
    db(): void;
    b4(a: any): void;
    bj(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
}
/**
 * @hidden
 */
export declare class LegendTemplates extends Base {
    static $t: Type;
    private static readonly z;
    private static readonly ae;
    private static readonly ad;
    private static readonly ah;
    private static readonly ab;
    private static readonly y;
    private static readonly aa;
    private static readonly ac;
    static af(a: Series): DataTemplate;
    static a(a: DataTemplateRenderInfo): RenderingContext;
    static v(a: DataContext): void;
    private static b;
    private static c;
    static u(a: DataTemplateRenderInfo, b: number, c: Brush, d: Brush, e: number, f: number, g: number, h: number): void;
    static s(a: DataTemplateRenderInfo): void;
    static r(a: DataTemplateRenderInfo, b: number, c: number): void;
    static t(a: DataTemplateRenderInfo, b?: number): void;
    static j(a: DataTemplateRenderInfo): void;
    static n(a: DataTemplateRenderInfo): void;
    static o(a: DataTemplateRenderInfo): void;
    static q(a: DataTemplateRenderInfo): void;
    static p(a: DataTemplateRenderInfo): void;
    static i(a: DataTemplateRenderInfo): void;
    static l(a: DataTemplateRenderInfo): void;
    static m(a: DataTemplateRenderInfo): void;
    static k(a: DataTemplateRenderInfo): void;
    static g(a: DataTemplateRenderInfo): void;
    private static readonly w;
    private static readonly x;
    static resolveLegendItemTemplate(a: StandardLegendItems): DataTemplate;
    static e(a: DataTemplateRenderInfo): void;
    static f(a: DataTemplateMeasureInfo): void;
    static d(a: DataTemplateMeasureInfo): void;
    static h(a: DataTemplateMeasureInfo): void;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bi(): void;
    bf(a: any): void;
    static bx(a: DomRenderer, b: () => void): void;
    private bh;
    a9(): void;
    g(): IOverviewPlusDetailPane;
    bl(): void;
    bm(): void;
    b2(): Brush;
    private ab;
    private aa;
    private ac;
    ay(a: number, b: number, c: number): void;
    b7(): Point;
    y(): boolean;
    bb(a: boolean): void;
    a7(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a6(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ax(): void;
    bt(x_: number): void;
    private ad;
    bu(y_: number): void;
    at(a: any): void;
    a8(): void;
    bn(): void;
    au(a: any): void;
    bj(a: any): void;
    bc(): void;
    private l;
    p(): FontInfo;
    private b9;
    cd(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b8;
    cc(): Thickness;
    private bz;
    b4(): Brush;
    private by;
    b3(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b1;
    b6(): Brush;
    private m;
    q(): FontInfo;
    private b0;
    b5(): Brush;
    private ca;
    ce(): Thickness;
    private cb;
    cf(): Thickness;
    bo(): void;
    private bw;
    private bq;
    private bp;
    private br;
    private bs;
    a5(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    ba(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a2(a: ITileZoomTile): void;
    a1(): void;
    bk(a: List$1<ITileZoomTile>): void;
    private al;
    az(): void;
    av(): void;
    private am;
    a0(a: number): void;
    aw(): void;
    private s;
    bd(): void;
    bv(a: boolean): void;
    a3(): void;
    a4(): void;
    bg(): void;
    be(): void;
    ao(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private ab;
    get textStyle(): string;
    set textStyle(a: string);
    private ay;
    get textColor(): Brush;
    set textColor(a: Brush);
    get location(): AxisLabelsLocation;
    set location(a: AxisLabelsLocation);
    private b;
    get visibility(): Visibility;
    set visibility(a: Visibility);
    private a3;
    get showFirstLabel(): boolean;
    set showFirstLabel(a: boolean);
    private i;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    get angle(): number;
    set angle(a: number);
    private n;
    get extent(): number;
    set extent(a: number);
    private p;
    set margin(a: number);
    get leftMargin(): number;
    set leftMargin(a: number);
    private q;
    get rightMargin(): number;
    set rightMargin(a: number);
    private r;
    get topMargin(): number;
    set topMargin(a: number);
    private s;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private o;
    private av;
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(a: HorizontalAlignment);
    private a0;
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(a: VerticalAlignment);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    as(a: string, b: any, c: any): void;
    protected ar(a: any, b: string, c: any, d: any): void;
    k(): boolean;
    l(): boolean;
    static readonly extentPropertyDefault: number;
    get j(): boolean;
    private f;
    get g(): FontInfo;
    set g(a: FontInfo);
    h(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a5;
    get position(): AxisTitlePosition;
    set position(a: AxisTitlePosition);
    protected ar(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a3(): AxisView;
    a4: AxisView;
    hr(a: AxisView): void;
    he(): void;
    private bs;
    get bt(): SRProvider;
    private a8;
    get a9(): IAxisVisualDataManager;
    eh(): number;
    f1(): any;
    f0(): any;
    protected get_ca(): boolean;
    get ca(): boolean;
    protected get_ci(): boolean;
    get ci(): boolean;
    protected get_b8(): boolean;
    get b8(): boolean;
    protected get_cl(): boolean;
    get cl(): boolean;
    protected get_co(): boolean;
    get co(): boolean;
    protected get_cm(): boolean;
    get cm(): boolean;
    protected get_cd(): boolean;
    get cd(): boolean;
    protected get_cj(): boolean;
    get cj(): boolean;
    protected get_ck(): boolean;
    get ck(): boolean;
    protected get_cb(): boolean;
    get cb(): boolean;
    protected get_cc(): boolean;
    get cc(): boolean;
    aj(): Axis;
    constructor();
    private a6;
    get a7(): IAxisAnnotationManager;
    get b9(): boolean;
    private hc;
    private hd;
    private ha;
    private hb;
    provideRenderer(a: DomRenderer): void;
    at: (item: any) => string;
    ho(a: Rect, b: Rect): void;
    abstract au(): AxisLabelPanelBase;
    ac(): void;
    iq: Canvas;
    get bn(): IFastItemsSourceProvider;
    set bn(a: IFastItemsSourceProvider);
    private bm;
    get bh(): SeriesViewer;
    set bh(a: SeriesViewer);
    private bg;
    get bf(): XamDataChart;
    set bf(a: XamDataChart);
    readonly br: (sender: any, e: RectChangedEventArgs) => void;
    private bx;
    get c5(): boolean;
    set c5(a: boolean);
    private dk;
    get e5(): number;
    set e5(a: number);
    private de;
    get dw(): number;
    set dw(a: number);
    private dr;
    get fb(): number;
    set fb(a: number);
    private dn;
    get e8(): number;
    set e8(a: number);
    private ar;
    get as(): AxisExtentType;
    set as(a: AxisExtentType);
    private dj;
    get e4(): number;
    set e4(a: number);
    dv: number;
    private dq;
    get fa(): number;
    set fa(a: number);
    private dm;
    get e7(): number;
    set e7(a: number);
    private bj;
    private bi;
    get bl(): FontInfo;
    set bl(a: FontInfo);
    private f2;
    get gw(): string;
    set gw(a: string);
    private dl;
    get e6(): number;
    set e6(a: number);
    dx: number;
    private ds;
    get fc(): number;
    set fc(a: number);
    private dp;
    get e9(): number;
    set e9(a: number);
    private fn;
    get fs(): number;
    set fs(a: number);
    private fm;
    get fr(): number;
    set fr(a: number);
    private fl;
    get fq(): number;
    set fq(a: number);
    fo: number;
    private ki;
    get kl(): VerticalAlignment;
    set kl(a: VerticalAlignment);
    private du;
    get fe(): number;
    set fe(a: number);
    private dt;
    get fd(): number;
    set fd(a: number);
    ig(): void;
    private h4;
    private h5;
    ir: TextBlock;
    g5: string;
    jy: Brush;
    ju: Brush;
    ff: number;
    j2: DoubleCollection;
    jx: Brush;
    jv: Brush;
    js: Brush;
    eq: number;
    j0: DoubleCollection;
    jw: Brush;
    jt: Brush;
    et: number;
    j1: DoubleCollection;
    jz: Brush;
    fh: number;
    j3: DoubleCollection;
    fg: number;
    dy: number;
    private ij;
    ce: boolean;
    cg: boolean;
    ch: boolean;
    ct: boolean;
    private bv;
    private df;
    get b3(): boolean;
    get b6(): boolean;
    ie(a: number): void;
    h9(): void;
    ee(): number;
    ev(): number;
    cu: boolean;
    cv: boolean;
    cw: boolean;
    by: boolean;
    c4: boolean;
    get c3(): boolean;
    set c3(a: boolean);
    static readonly jo: DependencyProperty;
    fp: number;
    b0: boolean;
    ay: AxisLabelSettings;
    d4(): number;
    jq(): HorizontalAlignment;
    kj(): VerticalAlignment;
    jr(): HorizontalAlignment;
    kk(): VerticalAlignment;
    d6(): number;
    d8(): number;
    d7(): number;
    d5(): number;
    eb(): number;
    ed(): number;
    ec(): number;
    ea(): number;
    az(): AxisLabelsLocation;
    a0(): AxisLabelsLocation;
    ai: Axis;
    fu: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected h2(a: AxisRangeChangedEventArgs): void;
    be: TitleSettings;
    d9(): number;
    d3(): number;
    get am(): AxisAnnotationCollection;
    private ak;
    get an(): AxisAnnotationCollection;
    private al;
    private j5;
    get kc(): Rect;
    set kc(a: Rect);
    kb: Rect;
    ik(): void;
    c7(a: Rect, b: Rect, c: AxisView): boolean;
    cn(): boolean;
    db: List$1<any>;
    dc: List$1<LabelPosition>;
    av: AxisLabelPanelBase;
    protected io(a: Rect, b: Rect): void;
    private bw;
    get cp(): boolean;
    set cp(a: boolean);
    protected j9(): Rect;
    protected ip(a: Rect, b: Rect): void;
    h3(): void;
    a5: ContentInfo;
    fk: DomRenderer;
    ah: BindingFormatter;
    protected hv(a: any, b: string, c: any, d: any): void;
    ht(): void;
    hu(): void;
    private _coercionMethods;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private bu;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    cx: boolean;
    private ib;
    c6: boolean;
    protected hq(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hp(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected im(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected il(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private cf;
    protected id(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    dz(a: number, b: number, c: number, d: PathRenderingInfo): number;
    hh(a: GeometryCollection): void;
    protected hg(): void;
    h6(): void;
    h7(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bb: LabelFontHeuristics;
    static es: number;
    ey(): number;
    e2(): number;
    e0(): number;
    e1(): number;
    ez(): number;
    ew(): number;
    d1(a: number, b: boolean, c: Rect, d: Rect, e: Rect): number;
    private ep;
    private eg;
    cy(a: number, b: Rect, c: Rect, d: Rect): boolean;
    protected ef(a: number, b: Rect, c: Rect, d: Rect): number;
    ex(): number;
    protected get cz(): boolean;
    cq: boolean;
    hj(a: boolean): void;
    private dh;
    private b1;
    ia(): void;
    protected b5(): boolean;
    d0(a: number, b: ScalerParams): number;
    protected ic(): void;
    private di;
    ba(): LabelFontHeuristics;
    bk(): FontInfo;
    private hk;
    cr: boolean;
    c0(): boolean;
    c1(a: boolean): boolean;
    c2(): boolean;
    protected h8(a: boolean): void;
    ii(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected h1(a: string, b: any, c: any): void;
    dd: List$1<Series>;
    cs(a: Series): boolean;
    bz(a: Series): boolean;
    fz: any;
    gf: string;
    ag: any[];
    fw(a: any, b: string): any;
    private c9;
    protected gr(a: string): string;
    private c8;
    protected fx(a: any, b: string, c: string): any;
    fy(a: any): any;
    gc(a: number): string;
    eu(): number;
    ei(a: number, b: ScalerParams): number;
    ej(a: number, b: ScalerParams, c: CategoryMode): number;
    j8(a: Rect): Rect;
    j7(): Rect;
    j6(): Rect;
    protected ka(a: Rect, b: Rect): Rect;
    ek(a: number, b: Rect, c: Rect): number;
    hm(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    hl(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    el(a: number, b: ScalerParams): number;
    em(a: number, b: ScalerParams, c: CategoryMode): number;
    en(a: number, b: Rect, c: Rect): number;
    hn(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    e3(a: number): number;
    abstract get a1(): AxisOrientation;
    kh: Size;
    hs(a: Size): void;
    ih(): void;
    ao: AxisComponentsForView;
    ap(): AxisComponentsForView;
    d2: number;
    private dg;
    get er(): number;
    set er(a: number);
    b7(): boolean;
    eo(): number;
    protected hf(): void;
    hi(a: AxisRangeChangedEventArgs): void;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<TextBlock>;
    bo: Pool$1<Rectangle>;
    get kd(): Path;
    get ke(): Path;
    get kg(): Path;
    get kf(): Path;
    bd(): SyncSettings;
    aq(): AxisComponentsFromView;
    private aw;
    get ax(): AxisLabelSettings;
    hw(a: RenderingContext, b: RenderingContext): void;
    b4(): boolean;
    fv(): any;
    private _da;
    da(): IEnumerable$1<Series>;
    hx(a: string): void;
    h0(a: any): void;
    hz(a: any): void;
    fj: CultureInfo;
    j4(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    n(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    t(): void;
    static j(a: FrameworkElement, b: AxisLabelSettings): void;
    private static k;
    private static l;
    static m(a: FrameworkElement, b: TitleSettings): void;
    h(a: FrameworkElement): void;
    r(a: number): void;
    o(a: number): void;
    u(a: number): FrameworkElement;
    s(a: number): void;
    get d(): boolean;
    q(): void;
    p(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    af: AxisLabelPanelBaseView;
    cx: Rect;
    b8(): void;
    cp(): void;
    co(): void;
    constructor();
    bw: number;
    ad: Axis;
    private ak;
    get az(): boolean;
    set az(a: boolean);
    private a3;
    get a9(): List$1<any>;
    set a9(a: List$1<any>);
    ba: List$1<LabelPosition>;
    c4: Rect;
    private cw;
    get c5(): Rect;
    set c5(a: Rect);
    private cv;
    get c1(): Rect;
    set c1(a: Rect);
    c2: Rect;
    private bc;
    get bg(): number;
    set bg(a: number);
    bx: () => boolean;
    bb: List$1<FrameworkElement>;
    a8: List$1<Rect>;
    ag: AxisLabelSettings;
    bn(): number;
    ao: boolean;
    c3: Rect;
    cl(): void;
    ar: boolean;
    av: boolean;
    aw: boolean;
    ax: boolean;
    bz: any;
    al: boolean;
    protected an(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    a5(): List$1<Rect>;
    b6(): void;
    b2(a: Size): void;
    get ap(): boolean;
    bl(): number;
    bq(): number;
    at(a: number, b: Rect): boolean;
    bk(a: any): number;
    bv(a: any): number;
    bm(a: any): number;
    bj(a: any): number;
    aq(): boolean;
    protected ct(a: Rect, b: Rect): void;
    protected cd(a: Rect, b: Rect): void;
    a7(): List$1<Rect>;
    a6(a: List$1<Rect>): List$1<Rect>;
    protected cy(a: number, b: Rect, c: Thickness): Rect;
    protected as(a: List$1<Rect>, b: List$1<number>, c: Thickness): boolean;
    protected a4(a: List$1<Rect>): List$1<number>;
    bp(a: number, b: Size): number;
    bo(a: number, b: Size): number;
    bt(): number;
    br(): number;
    bs(): number;
    bu(): number;
    c6(a: Size): Size;
    protected get am(): boolean;
    c0(): Rect;
    protected b5(a: Size): void;
    protected b4(a: Size): void;
    protected b9(): void;
    protected a2(): IEnumerable$1<number>;
    get ah(): AxisLabelsLocation;
    cs(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cc(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cm(a: FrameworkElement, b: number): void;
    protected get_au(): boolean;
    get au(): boolean;
    ac(a: Rect, b: number): Point[];
    cz(a: Rect, b: number): Rect;
    cn(a: FrameworkElement): void;
    cb(a: FrameworkElement, b: number): void;
    c8(a: Size): Size;
    static readonly cu: DependencyProperty;
    get bh(): number;
    set bh(a: number);
    bd: number;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    private _a0;
    a0(): IEnumerable$1<any>;
    b1(a: number, b: TextBlock, c: number, d: number, e: number): string;
    b7(a: any): void;
    cg(a: FrameworkElement): void;
    private _a1;
    a1(): IEnumerable$1<any>;
    protected be: number;
    protected bf: number;
    ca(): void;
    cr(): void;
    ce(): void;
    bi(a: Rect): number;
    c7: Size;
    ci(): void;
    cq(): void;
    cf(): void;
    cj(a: RenderingContext): void;
    b3(): void;
    ck(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a3(): AxisView;
    protected get_cc(): boolean;
    hr(a: AxisView): void;
    km: CategoryAxisBaseView;
    protected ef(a: number, b: Rect, c: Rect, d: Rect): number;
    constructor();
    c7(a: Rect, b: Rect, c: AxisView): boolean;
    l0(): void;
    lz(): void;
    kx: List$1<number>;
    protected get_ca(): boolean;
    md(a: Point, b: boolean, c: number): Rect;
    me(a: Point, b: boolean, c: number, d: boolean): Rect;
    kq: IFastItemsSource;
    private kp;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly l8: DependencyProperty;
    private lc;
    le: number;
    get lf(): number;
    set lf(a: number);
    get categoryMode(): CategoryMode;
    set categoryMode(a: CategoryMode);
    private kn;
    k0: number;
    protected la(a: Rect, b: Rect, c: Rect): number;
    k7: number;
    kz: number;
    k8: number;
    k9: number;
    ku: boolean;
    get lg(): number;
    set lg(a: number);
    private ld;
    el(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    k3(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    lb(a: number): number;
    private _kw;
    private kw;
    private ks;
    kt(a: SeriesViewer): boolean;
    private _kv;
    private kv;
    private kr;
    l4(a: boolean): void;
    protected hv(a: any, b: string, c: any, d: any): void;
    protected ls(): void;
    lu(a: any, b: FastItemsSourceEventArgs): void;
    protected l1(a: FastItemsSourceEventArgs): void;
    private l5;
    cs(a: Series): boolean;
    bz(a: Series): boolean;
    private l2;
    lr(): void;
    l3(): void;
    lt(a: NotifyCollectionChangedEventArgs): void;
    ly(a: number, b: any, c: any): void;
    lv(): void;
    lw(a: number, b: any): void;
    lx(a: number, b: any): void;
    k4(a: Rect, b: Rect, c: Rect, d: number): number;
    k5(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: HorizontalAxisLabelPanelBaseView;
    dl: number;
    di: number;
    dk: number;
    dj: number;
    b6(): void;
    db(): boolean;
    dc(): boolean;
    aq(): boolean;
    a5(): List$1<Rect>;
    dn(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private dm;
    private dp;
    protected dq(a: List$1<Rect>, b: List$1<boolean>): void;
    protected dr(): void;
    protected get_au(): boolean;
    cm(a: FrameworkElement, b: number): void;
    protected dd(): boolean;
    protected da(): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    c0(): Rect;
    dh(): number;
    de(): number;
    dg(): number;
    df(): number;
    protected b9(): void;
    a6(a: List$1<Rect>): List$1<Rect>;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a3(): AxisView;
    hr(a: AxisView): void;
    d0(a: number, b: ScalerParams): number;
    kv: NumericAxisBaseView;
    protected get_ci(): boolean;
    constructor();
    get ks(): AxisRangeBufferMode;
    set ks(a: AxisRangeBufferMode);
    private kr;
    get kt(): AxisRangeBufferMode;
    set kt(a: AxisRangeBufferMode);
    static readonly nc: DependencyProperty;
    l3: number;
    get lv(): number;
    set lv(a: number);
    private ln;
    l1: number;
    f1(): any;
    get ly(): number;
    set ly(a: number);
    private lq;
    l2: number;
    get lu(): number;
    set lu(a: number);
    private lm;
    f0(): any;
    l0: number;
    private lp;
    get lx(): number;
    set lx(a: number);
    lz: number;
    private ll;
    get lt(): number;
    set lt(a: number);
    eu(): number;
    l4: number;
    private lo;
    get lw(): number;
    set lw(a: number);
    l5: number;
    lg: boolean;
    private k6;
    get k9(): boolean;
    set k9(a: boolean);
    lb: boolean;
    private k7;
    get la(): boolean;
    set la(a: boolean);
    get lh(): boolean;
    l7: number;
    l8: number;
    ky: NumericAxisRenderer;
    protected li: boolean;
    protected lj: boolean;
    protected h8(a: boolean): void;
    h0(a: any): void;
    hz(a: any): void;
    kn: BindingFormatter;
    protected hv(a: any, b: string, c: any, d: any): void;
    protected mz(): void;
    kp: AxisRange;
    kq(): AxisRange;
    ls: number;
    lr: number;
    private lk;
    private ku;
    mw(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    c2(): boolean;
    private mx;
    m0(a: AxisRangeChangedEventArgs): void;
    cs(a: Series): boolean;
    bz(a: Series): boolean;
    kx(a: AxisLabelManager): NumericAxisRenderer;
    kw(): NumericAxisRenderer;
    ko: (item: any) => string;
    l9: string;
    km: any[];
    lf: boolean;
    k0(): NumericAxisRenderingParameters;
    my(): void;
    k1(): NumericScaler;
    kz(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    l6(a: number): number;
    lc(): boolean;
    get le(): boolean;
    get ld(): boolean;
    private m1;
    static readonly ne: DependencyProperty;
    get k4(): TickmarkValues;
    set k4(a: TickmarkValues);
    private k2;
    get k3(): TickmarkValues;
    set k3(a: TickmarkValues);
    private k5;
    get k8(): boolean;
    set k8(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any, fromAbbreviator: boolean) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: VerticalAxisLabelPanelView;
    di: number;
    df: number;
    dh: number;
    dg: number;
    b6(): void;
    bq(): number;
    db(): number;
    dd(): number;
    de(): number;
    dc(): number;
    a5(): List$1<Rect>;
    private dj;
    private dk;
    cm(a: FrameworkElement, b: number): void;
    protected da(): boolean;
    c0(): Rect;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    protected b9(): void;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export declare class AutomaticSeriesManager extends Base {
    static $t: Type;
    private g;
    private c;
    e(a: AutomaticSeriesPurpose): boolean;
    constructor(a: SeriesViewer);
    private i;
    private n;
    private m;
    protected f: boolean;
    private j;
    private k;
    l(a: AutomaticSeriesPurpose): void;
    private h;
    private d;
    private a;
    get b(): AutomaticSeriesRequestCollection;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequest extends Base {
    static $t: Type;
    a: AutomaticSeriesPurpose;
    d: Series;
    b: Series;
    c: Series;
    e: boolean;
    f: boolean;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequestCollection extends ObservableCollection$1<AutomaticSeriesRequest> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export interface IDataChartToolbarProvider {
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: SeriesViewer, b: ToolCommand): void;
}
/**
 * @hidden
 */
export declare let IDataChartToolbarProvider_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerScrollbarManager {
    executionContext: IExecutionContext;
    animator: DoubleAnimator;
    owner: SeriesViewer;
    onHorizontalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    onVerticalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    updateScrollbars(a: SeriesViewer, b: Rect, c: Rect, d: Rect, e: Rect): void;
    updateBarDimensions(a: SeriesViewer, b: number, c: number, d: number, e: boolean, f: number, g: number, h: number, i: number, j: number, k: boolean, l: number, m: number): void;
    updateBarAppearance(a: SeriesViewer, b: Brush, c: Brush, d: Brush, e: Brush, f: number, g: number, h: number, i: number): void;
    onCrosshairMoved(a: Point): void;
    shouldHandleInteraction(a: Point, b: boolean): boolean;
    onScrollbarDrag(a: Point, b: boolean): void;
    onScrollbarDragComplete(a: Point, b: boolean): void;
    onScrollbarDragCancel(): void;
    updateVerticalScrollbarPosition(a: SeriesViewerVerticalScrollbarPosition): void;
    updateHorizontalScrollbarPosition(a: SeriesViewerHorizontalScrollbarPosition): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerScrollbarManager_$type: Type;
/**
 * @hidden
 */
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: number, d: number, e: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    totalHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
    readonly allDirty: boolean;
    isCrossSeriesHighlight(a: Series): boolean;
    executionContext: IExecutionContext;
    ensureAnimator: () => void;
    highlightingBehavior: SeriesHighlightingBehavior;
}
/**
 * @hidden
 */
export declare let IHighlightingManager_$type: Type;
/**
 * @hidden
 */
export declare class HighlightingInfo extends Base {
    static $t: Type;
    constructor();
    i: number;
    h: number;
    g: number;
    a: HighlightingState;
    f: number;
    e: boolean;
    d: boolean;
    c: boolean;
    b: Series;
}
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$j(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$m(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$l(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$o(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$k(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$al(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$v(a: Series, b: any, c: Point, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean): void;
    a$s(): void;
    a$ak(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$i(a: Series, b: HighlightingInfo, c: number, d: number, e: number, f: number, g: boolean): number;
    a$y(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ai(a: Series, b: Point): void;
    a$ab(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$z(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$w(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$ac(a: Series, b: Point, c: any, d: any): void;
    a$ad(a: Series, b: Point, c: any, d: any): void;
    a$q(a: Series): string;
    a$r(a: Series): string;
    readonly a$b: boolean;
    readonly a$p: any;
    a$aj(a: Series, b: any): void;
    a$ah(a: Series, b: Point, c: (arg1: any) => void): void;
    a$u(a: Series): void;
    a$ag(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$t(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ae(a: Series, b: SeriesViewer): void;
    a$af(a: Series, b: string, c: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ag(a: SeriesViewer): void;
    f$q(a: SeriesViewer, b: Point): void;
    f$ae(a: SeriesViewer, b: Point): void;
    f$r(a: SeriesViewer, b: Point, c: boolean): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer, b: Point): void;
    f$am(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$ac(a: SeriesViewer, b: number): void;
    f$ai(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$z(a: SeriesViewer, b: Point): void;
    f$ab(a: SeriesViewer, b: number): void;
    f$s(a: SeriesViewer, b: Point): void;
    f$y(a: SeriesViewer, b: Point): void;
    f$ah(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$n(a: SeriesViewer, b: Point, c: boolean): void;
    f$ak(a: SeriesViewer): void;
    f$aj(a: SeriesViewer): void;
    f$ap(a: SeriesViewer): void;
    f$k(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$l(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$an(a: SeriesViewer): void;
    f$af(a: SeriesViewer): void;
    f$e(a: SeriesViewer, b: Key): boolean;
    f$f(a: SeriesViewer, b: Point, c: number): boolean;
    f$o(a: SeriesViewer, b: Point): void;
    f$j(a: SeriesViewer): void;
    f$i(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    readonly f$c: ISeriesViewerScrollbarManager;
    f$ao(a: SeriesViewer, b: Point): void;
    f$d(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$g(a: SeriesViewer, b: Point): boolean;
    f$w(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$v(a: SeriesViewer, b: Point): void;
    f$u(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$x(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$t(a: SeriesViewer, b: Point, c: boolean): void;
    f$aa(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    addPointerTooltipWithDataLegend(a: any, b: any, c: number, d: number, e: any): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static vj: number;
    static vi: number;
    private _xsr;
    private get XSRP();
    private t1;
    get t2(): IDataChartVisualDataManager;
    static staticInit(): void;
    static vv(a: Series): number;
    constructor();
    protected n4(a: any, b: string, c: any, d: any): void;
    ok(): void;
    mv(): void;
    protected mm(a: Rect, b: Rect): void;
    protected mq(): void;
    w2(): void;
    private wx;
    private xx;
    private w4;
    private t7;
    private t6;
    private t4;
    private t3;
    private xy;
    private xz;
    protected get_d4(): boolean;
    um: boolean;
    gm(): number;
    gn(): number;
    protected o3(): void;
    vt: number;
    vu: number;
    private u2;
    get ve(): number;
    set ve(a: number);
    private u3;
    get vf(): number;
    set vf(a: number);
    er(): boolean;
    es(): boolean;
    uj: boolean;
    uw: boolean;
    uk: boolean;
    un: boolean;
    t0: GridMode;
    ug: boolean;
    ur: boolean;
    us: boolean;
    vl: number;
    vh: number;
    vg: number;
    get ue(): boolean;
    protected get_e0(): boolean;
    get uf(): boolean;
    uu: boolean;
    uq: boolean;
    ut: boolean;
    uv: boolean;
    tv: AutoMarginsAndAngleUpdateMode;
    ul: boolean;
    up: boolean;
    uo: boolean;
    private u4;
    private u5;
    private vm;
    private vn;
    protected get_ez(): boolean;
    protected get_ey(): boolean;
    w1(): void;
    w0(): void;
    wz(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    private vs;
    private vk;
    private ww;
    xw: Brush;
    xu: Brush;
    xv: Brush;
    get axes(): AxisCollection;
    private tw;
    private wt;
    private wu;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private wv;
    private static wy;
    pd(a: SyncLink, b: SyncLink): void;
    private ua;
    getFontInfo(): FontInfo;
    w3(): void;
    getFontBrush(): Brush;
    protected lt(): void;
    se(): Brush;
    e7(): boolean;
    protected o7(): void;
    d3(): boolean;
    private ui;
    protected ct(): SeriesViewerView;
    protected ns(a: SeriesViewerView): void;
    t9: XamDataChartView;
    ol(): void;
    private ud;
    static vy: string;
    private uz;
    get vb(): number;
    set vb(a: number);
    static v0: string;
    private u1;
    get vd(): number;
    set vd(a: number);
    static vz: string;
    private u0;
    get vc(): number;
    set vc(a: number);
    static vx: string;
    private uy;
    get va(): number;
    set va(a: number);
    ty: ComputedPlotAreaMarginMode;
    t5: SeriesPlotAreaMarginHorizontalMode;
    t8: SeriesPlotAreaMarginVerticalMode;
    private u7;
    get vp(): number;
    set vp(a: number);
    private u9;
    get vr(): number;
    set vr(a: number);
    private u8;
    get vq(): number;
    set vq(a: number);
    private u6;
    get vo(): number;
    set vo(a: number);
    protected tb(a: Rect): Rect;
    th(): Rect;
    vw(): any;
    wb(): string;
    n1(): void;
    on(): void;
    ux(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private r;
    private t;
    private get u();
    private set u(value);
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ad(a: ChartContentType, b: DependencyObject): void;
    private m;
    private v;
    aa(a: DomRenderer): void;
    z(): void;
    ac(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private q;
    private j;
    y(): void;
    private w;
    private _s;
    private s;
    x(a: Size): void;
    o: boolean;
    n: boolean;
    p: boolean;
    ae(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    ab(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    get d(): boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendSeriesInternal, ILegendOwner, ILegendTemplateProvider, IDataLegendSeries {
    static $t: Type;
    b0: SeriesView;
    private static hc;
    hq: number;
    pu: Rect;
    protected get_dataLegendKey(): string;
    get dataLegendKey(): string;
    df: boolean;
    private ha;
    get hb(): DomRenderer;
    set hb(a: DomRenderer);
    provideRenderer(a: DomRenderer): void;
    jt(): string;
    constructor();
    m3(a: MarkerOutlineMode): void;
    m2(a: MarkerFillMode): void;
    m4(a: number): void;
    private static readonly ox;
    protected ks(a: any, b: PropertyChangedEventArgs): void;
    private cm;
    get cn(): SRProvider;
    private a7;
    get a8(): ISeriesVisualDataManager;
    protected get fe(): Dictionary$2<string, SeriesView>;
    private a5;
    get a6(): ISeriesInteractionManager;
    get d0(): boolean;
    ce: DoubleAnimator;
    l2(a: SeriesView): void;
    l0(): void;
    l1(): void;
    by(): SeriesView;
    protected bx(): SeriesView;
    nd: Canvas;
    e8(): boolean;
    hy(a: any, b: string): any;
    onLegendItemOver(a: any): void;
    onLegendItemPointerUp(a: any): void;
    onLegendItemPointerDown(a: any): void;
    onLegendItemEnter(a: any): void;
    onLegendItemLeave(a: any): void;
    private fd;
    protected js(a: string): string;
    private fc;
    protected hz(a: any, b: string, c: string): any;
    f7(a: Point): number;
    hh(a: Point): number;
    protected get_ea(): boolean;
    get ea(): boolean;
    ar(): CategoryAxisBase;
    hf(a: Point): number;
    p4(): Thickness;
    p6(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    p5(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    bv(): SeriesPlotAreaMarginHorizontalMode;
    bw(): SeriesPlotAreaMarginVerticalMode;
    hv(a: Point): any;
    protected h0(a: Series, b: Point): any;
    protected ay(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    protected az(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    he(): number;
    hi(): number;
    hn(): number;
    get container(): ILegendOwner;
    get hasSubItems(): boolean;
    protected c3(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected lc(a: (arg1: any) => void): void;
    ld(a: (arg1: Series) => boolean): void;
    jr(): string;
    pd(): Brush;
    pe(): Brush;
    resolveLegendIndex(): number;
    bf(): Series;
    protected get_dc(): boolean;
    get dc(): boolean;
    protected get_c9(): boolean;
    get c9(): boolean;
    protected get_c8(): boolean;
    get c8(): boolean;
    protected get_db(): boolean;
    get db(): boolean;
    protected get_da(): boolean;
    get da(): boolean;
    protected get_isVertical(): boolean;
    get isVertical(): boolean;
    protected get_dv(): boolean;
    get dv(): boolean;
    protected get_de(): boolean;
    get de(): boolean;
    protected get_dd(): boolean;
    get dd(): boolean;
    protected get_c6(): boolean;
    get c6(): boolean;
    protected get_ek(): boolean;
    get ek(): boolean;
    protected get_d2(): boolean;
    get d2(): boolean;
    protected get_d1(): boolean;
    get d1(): boolean;
    protected get_eh(): boolean;
    get eh(): boolean;
    protected get_di(): boolean;
    get di(): boolean;
    protected get_dg(): boolean;
    get dg(): boolean;
    protected get_el(): boolean;
    get el(): boolean;
    protected get_d9(): boolean;
    get d9(): boolean;
    protected get_d8(): boolean;
    get d8(): boolean;
    protected get_d6(): boolean;
    get d6(): boolean;
    protected get_d5(): boolean;
    get d5(): boolean;
    protected get_ej(): boolean;
    get ej(): boolean;
    protected get_ei(): boolean;
    get ei(): boolean;
    protected get_ef(): boolean;
    get ef(): boolean;
    protected get_d7(): boolean;
    get d7(): boolean;
    protected get_ed(): boolean;
    get ed(): boolean;
    protected get_eb(): boolean;
    get eb(): boolean;
    protected get_isStacked(): boolean;
    get isStacked(): boolean;
    protected get_dq(): boolean;
    get dq(): boolean;
    protected get_ec(): boolean;
    get ec(): boolean;
    protected get_dh(): boolean;
    get dh(): boolean;
    protected get_dw(): boolean;
    get dw(): boolean;
    protected get_ee(): boolean;
    get ee(): boolean;
    protected get_isValueOverlay(): boolean;
    get isValueOverlay(): boolean;
    be(): Series;
    protected get_c4(): boolean;
    get c4(): boolean;
    protected get_dt(): boolean;
    get dt(): boolean;
    protected get_ds(): boolean;
    get ds(): boolean;
    protected get_dr(): boolean;
    get dr(): boolean;
    protected get_du(): boolean;
    get du(): boolean;
    protected get_dk(): boolean;
    get dk(): boolean;
    protected get_dl(): boolean;
    get dl(): boolean;
    f5(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected f6(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_fa(): boolean;
    get fa(): boolean;
    protected gn(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    gb(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    hm(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    ga(a: boolean): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected ew(a: Point, b: boolean): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected ey(a: Point, b: boolean, c: PathGeometry): boolean;
    protected ez(a: Point, b: PathGeometry): boolean;
    hk(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    f9(a: Point, b: Axis): number;
    hl(a: Point, b: boolean): number;
    hj(a: Point, b: boolean): number;
    gl(a: Point, b: boolean, c: boolean): number;
    pq(a: Point, b: boolean, c: boolean): Point;
    pz(a: Point): Rect;
    ak(a: Point): Rect[];
    p0(a: Point): Rect;
    al(a: Point): Rect[];
    p1(a: Point): Rect;
    p2(a: Point): Rect;
    protected e0(a: Point, b: boolean): boolean;
    protected ps(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    gh(a: Point, b: boolean, c: boolean): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    gj(a: Point, b: boolean, c: boolean): number;
    po(a: Point, b: boolean, c: boolean): Point;
    pr(a: Point, b: boolean, c: boolean): Point;
    gm(a: Point, b: boolean, c: boolean): number;
    pn(a: Point, b: boolean, c: boolean): Point;
    gi(a: Point, b: boolean, c: boolean): number;
    pp(a: Point, b: boolean, c: boolean): Point;
    gk(a: Point, b: boolean, c: boolean): number;
    hg(a: Point): number;
    gc(): number;
    f8(a: Point): number;
    hw(a: Point): any;
    c1(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    gq(a: Marker): number;
    i2(): string;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    get hasMarkers(): boolean;
    lg(): void;
    lh(): void;
    pa(): Brush;
    pb(): Brush;
    nh(): DataTemplate;
    f4(): number;
    pt(a: Point): Point;
    pl(a: Point): Point;
    h1(a: any, b: Point): any;
    eo(a: any): boolean;
    ap(a: Axis): AxisRange;
    aq(a: Rect): AxisRange;
    ao(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    protected k9(): void;
    ml(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private k6;
    mm(a: boolean): void;
    protected e2: boolean;
    protected kw(): void;
    protected k1(): void;
    bz: SeriesView;
    mn(a: Rect, b: RenderSurface): void;
    mk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    pv(a: SeriesView): Rect;
    py(a: Rect): Rect;
    px(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    mf(): void;
    protected get_c2(): boolean;
    get c2(): boolean;
    protected get_c5(): boolean;
    get c5(): boolean;
    private mg;
    mh(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    k0(a: boolean, b: SeriesView): void;
    protected cw(): boolean;
    cx(a: SeriesView): boolean;
    l3(a: Rect, b: Rect): void;
    protected m9(a: Rect, b: Rect): void;
    protected m8(a: Rect, b: Rect): void;
    as: ContentInfo;
    private cs;
    get e1(): boolean;
    set e1(a: boolean);
    protected lb(a: Series): void;
    protected lt(): void;
    ln(): void;
    ls(): void;
    protected get_dz(): boolean;
    get dz(): boolean;
    protected get_isUsableInLegend(): boolean;
    get isUsableInLegend(): boolean;
    protected ly(): void;
    lu(): void;
    protected l4(): void;
    l5(): void;
    protected eu: boolean;
    protected ev: boolean;
    protected en(): boolean;
    protected l6(a: boolean): void;
    private ct;
    protected get e3(): boolean;
    protected set e3(a: boolean);
    protected get e4(): boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected lx(): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    protected my(): void;
    m6(a: Point): void;
    k8(): void;
    protected get_dy(): boolean;
    protected get dy(): boolean;
    cy: boolean;
    protected k5(a: Series): void;
    get b8(): SyncLink;
    set b8(a: SyncLink);
    private b7;
    get cd(): SeriesViewer;
    set cd(a: SeriesViewer);
    private cc;
    get cb(): XamDataChart;
    set cb(a: XamDataChart);
    readonly fi: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly bd: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly cl: (sender: any, e: RectChangedEventArgs) => void;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly n3: DependencyProperty;
    ck: IFastItemsSource;
    g7: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly n9: DependencyProperty;
    get nc(): Control;
    set nc(a: Control);
    private na;
    h2(): any;
    protected nb(): Control;
    get a1(): IChartLegend;
    set a1(a: IChartLegend);
    private a0;
    p7: Visibility;
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    static readonly n6: DependencyProperty;
    ne: DataTemplate;
    private ng;
    o5: Brush;
    o4: Brush;
    b6: StandardLegendItems;
    b5: StandardLegendItems;
    legendItemBadgeShape: LegendItemBadgeShape;
    a9: LegendItemBadgeMode;
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    static readonly n7: DependencyProperty;
    get nf(): DataTemplate;
    set nf(a: DataTemplate);
    static readonly nu: DependencyProperty;
    get index(): number;
    set index(a: number);
    static readonly ny: DependencyProperty;
    m7(): void;
    k7(): void;
    protected mz(): void;
    cf: (time: number) => number;
    cg: (time: number) => number;
    c0: boolean;
    ho: number;
    g2: number;
    cv(): boolean;
    mu(): void;
    private cr;
    private fl;
    get fv(): number;
    set fv(a: number);
    protected gw(): number;
    gv: number;
    private fp;
    protected get f0(): number;
    protected set f0(a: number);
    g6: number;
    private fm;
    protected get fx(): number;
    protected set fx(a: number);
    g3: number;
    private fn;
    protected get fy(): number;
    protected set fy(a: number);
    g4: number;
    private fo;
    protected get fz(): number;
    protected set fz(a: number);
    g5: number;
    title: any;
    o7: Brush;
    o3: Brush;
    o8: Brush;
    o9: Brush;
    pc: Brush;
    o6: Brush;
    gt: number;
    g1: number;
    fw: number;
    f2: number;
    ph: PenLineCap;
    pg: DoubleCollection;
    toolTip: any;
    private bj;
    get bk(): SeriesHighlightingMode;
    set bk(a: SeriesHighlightingMode);
    protected bl(): SeriesHighlightingMode;
    protected eg(a: SeriesHighlightingMode): boolean;
    private fk;
    get ft(): number;
    set ft(a: number);
    gr: number;
    c7: boolean;
    dj: boolean;
    dx: boolean;
    er: boolean;
    dn: boolean;
    protected get_dp(): boolean;
    get dp(): boolean;
    gy: number;
    pf: Color;
    e9: boolean;
    gz: number;
    g0: number;
    f1: number;
    fs: number;
    mw(): void;
    gs: number;
    fu: number;
    mx(): void;
    protected gx(): number;
    private cq;
    get dm(): boolean;
    set dm(a: boolean);
    et: boolean;
    private b1;
    get b2(): SeriesVisibleRangeMode;
    set b2(a: SeriesVisibleRangeMode);
    b3(): SeriesVisibleRangeMode;
    b4: SeriesVisibleRangeMode;
    private br;
    get bs(): SeriesOutlineMode;
    set bs(a: SeriesOutlineMode);
    bu(): SeriesOutlineMode;
    bt: SeriesOutlineMode;
    au(a: any): DataContext;
    hp: number;
    ca: TransitionInSpeedType;
    protected b9(): TransitionInSpeedType;
    ht: any;
    mj(): void;
    mo(): void;
    mi(): void;
    kx(): void;
    li(): void;
    private static _fg;
    static fg(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static ff(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    pj: PenLineCap;
    pi: PenLineCap;
    private bg;
    bh(): SeriesComponentsForView;
    mp(a: Canvas): void;
    go(): number;
    gp(): number;
    private cu;
    protected get_e5(): boolean;
    protected set_e5(a: boolean): void;
    protected get e5(): boolean;
    protected set e5(a: boolean);
    get eq(): boolean;
    em: boolean;
    ky(): void;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    lz(a: Point, b: any, c: any, d: boolean): void;
    mt(a: Point): void;
    private ku;
    private kz;
    kt(a: IChartLegend, b: IChartLegend): void;
    private kv;
    me(a: IFastItemsSourceProvider): void;
    md(a: IFastItemsSourceProvider): void;
    protected a2(): IChartLegend;
    protected es(): boolean;
    ep(a: boolean): boolean;
    protected k4(a: Axis): void;
    protected mc(a: Axis): void;
    bi(): SeriesComponentsFromView;
    m1(a: Canvas): void;
    ms(a: Point, b: (arg1: any) => void): void;
    protected get_e7(): boolean;
    get e7(): boolean;
    l8(a: RenderingContext, b: RenderingContext): void;
    ma(a: Rect): void;
    lf(a: NotifyCollectionChangedEventArgs): void;
    lq(a: number, b: any, c: any): void;
    lm(): void;
    lo(a: number, b: any): void;
    lp(a: number, b: any): void;
    mv(): void;
    h4: any;
    g9: (arg1: any) => any;
    ex(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private cp;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    at(a: Point, b: boolean): DataContext;
    private bn;
    get bq(): SeriesHitTestMode;
    set bq(a: SeriesHitTestMode);
    protected bp(): SeriesHitTestMode;
    private bm;
    get bo(): SeriesHitTestMode;
    set bo(a: SeriesHitTestMode);
    protected ch(a: string): IFastItemColumn$1<number>;
    protected ci(a: string): IFastItemColumn$1<number>;
    protected cj(a: string): IFastItemColumn$1<any>;
    protected get p3(): Rect;
    protected get_d4(): boolean;
    get d4(): boolean;
    protected get_d3(): boolean;
    get d3(): boolean;
    mr(a: boolean): void;
    mq(a: Brush, b: Brush): void;
    co: (arg1: SeriesViewer) => void;
    protected k2(a: any, b: any): void;
    hu(): any;
    protected la(a: any): void;
    private pk;
    lk(a: Point): void;
    protected lw(a: Point): void;
    ll(): void;
    lr(): void;
    an(a: Axis): Axis;
    ag(): Axis[];
    ge(): number;
    static gf(a: IFastItemColumn$1<number>, b: ISortingAxis): number;
    static gg(a: IList$1<number>, b: ISortingAxis): number;
    lv(): void;
    private fq;
    get f3(): number;
    set f3(a: number);
    private fr;
    get gu(): number;
    set gu(a: number);
    protected m5(): void;
    hx(a: any): any;
    get ij(): string;
    get h7(): string;
    get h8(): string;
    get ih(): string;
    get iq(): string;
    get ip(): string;
    get il(): string;
    protected m0(): void;
    am(): ActualLegendItemBadgeShape;
    protected ba(a: LegendItemBadgeShape): LegendItemBadgeShape;
    private bb;
    getDataLegendBadge(): DataTemplate;
    private a4;
    getDataLegendBadgeContext(): any;
    getDataLegendBadgeShapeAndMarker(): string;
    i0(): string;
    i1(a: Series, b: DataTemplate): string;
    getDataLegendSeriesTitle(): string;
    gd(a: any, b: string): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    av(): DataLegendSeriesGroup;
    getDataLegendAxisLabelFromCursorPosition(a: number, b: number): any;
    private lj;
    private fj;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    qg: MarkerSeriesView;
    constructor();
    p5(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    l2(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    pa(): Brush;
    pb(): Brush;
    nh(): DataTemplate;
    i0(): string;
    qh: MarkerType;
    private qc;
    get qd(): MarkerOutlineMode;
    set qd(a: MarkerOutlineMode);
    qf(): MarkerOutlineMode;
    m3(a: MarkerOutlineMode): void;
    qe: MarkerOutlineMode;
    private p8;
    get p9(): MarkerFillMode;
    set p9(a: MarkerFillMode);
    qb(): MarkerFillMode;
    m2(a: MarkerFillMode): void;
    m4(a: number): void;
    qa: MarkerFillMode;
    q3: DataTemplate;
    qm: number;
    f4(): number;
    q1: DataTemplate;
    q2: DataTemplate;
    private static q0;
    static get q4(): DataTemplate;
    get rj(): Brush;
    set rj(a: Brush);
    static readonly q8: DependencyProperty;
    rh: Brush;
    rk: Brush;
    ri: Brush;
    rl: Style;
    ql: boolean;
    qj(): boolean;
    protected lx(): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    static qq(a: MarkerType): string;
    static qi(a: Series, b: MarkerType): MarkerType;
    protected mz(): void;
    protected la(a: any): void;
    protected qk(a: Point, b: boolean): boolean;
    at(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ak: string;
    protected aq(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static aj: (arg1: IEnumerable) => IFastItemsSource;
    private static af;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ag(a: IEnumerable): IFastItemsSource;
    private ah;
    av: Rect;
    private aw;
    private ax;
    private ab;
    private ac;
    get ai(): IList$1<SeriesViewer>;
    private ad;
    al(a: SeriesViewer): void;
    as(a: SeriesViewer): void;
    private ao;
    private am;
    an(a: SeriesViewer, b: Point): void;
    ap(a: SeriesViewer, b: Rect): void;
    at(a: SeriesViewer, b: Rect): void;
    au(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    get e(): number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _isDuringManipulation;
    get isDuringManipulation(): boolean;
    set isDuringManipulation(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _manipulationOccurred;
    get manipulationOccurred(): boolean;
    set manipulationOccurred(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _seriesViewer;
    get seriesViewer(): SeriesViewer;
    set seriesViewer(a: SeriesViewer);
    get chart(): XamDataChart;
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    get handled(): boolean;
    set handled(a: boolean);
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    aw: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ae(a: FrameworkElement): void;
    ah(a: any): void;
    ai(a: any, b: Size): void;
    aj(a: FrameworkElement, b: number): void;
    ar(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    ad(a: Rectangle): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    af(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    an(): void;
    m(a: any): number;
    w(a: any): number;
    ax(a: any): Size;
    ac(): void;
    ak(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    al(a: RenderingContext): void;
    y(): void;
    protected am(): void;
    private av;
    protected ap(a: TextBlock): void;
    ao(): void;
    d(): FontInfo;
    at(): Brush;
    private c;
    ag(): void;
    private h;
    private as;
    private i;
    j(): number;
    k(): number;
    protected aq(): void;
    ab(a: Size): void;
    protected ay(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    au(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    aj(): void;
    al(a: any): void;
    ba: Path;
    bb: Path;
    bd: Path;
    bc: Path;
    a0(): TextBlock;
    at(a: TextBlock): void;
    av(a: TextBlock): void;
    au(a: TextBlock): void;
    bf(): Rectangle;
    s(a: Rectangle): void;
    u(a: Rectangle): void;
    t(a: Rectangle): void;
    am(): void;
    o(): boolean;
    get index(): number;
    ag(): void;
    ae(): void;
    aa(): void;
    ay(a: Visibility): void;
    aq(): void;
    z(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    ac(a: GeometryCollection): void;
    a1(): GeometryCollection;
    e(): PathRenderingInfo;
    a4(): GeometryCollection;
    a2(): GeometryCollection;
    f(): PathRenderingInfo;
    a3(): GeometryCollection;
    g(): PathRenderingInfo;
    protected get d(): AxisLabelPanelBase;
    aw(a: Axis, b: Rect, c: Rect): void;
    ab(): void;
    as(a: number): void;
    ax(a: List$1<any>, b: List$1<LabelPosition>): void;
    ar(a: number): void;
    y(): void;
    private h;
    r(a: number): string;
    protected n(): boolean;
    l(): boolean;
    protected q(dataItem_: any): string;
    p(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    ai(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected ah(): void;
    undirty(a: boolean): void;
    private be;
    protected ao(a: boolean): void;
    postRender(): void;
    private a8;
    protected ap(): void;
    af(): void;
    ad(a: SeriesViewer): void;
    x(a: SeriesViewer): void;
    i(): FontInfo;
    m(): boolean;
    an(): void;
    w(): void;
    az(): void;
    v(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a5(a: TextBlock): Point;
    a6(): Point;
    a9(): Rect;
    a7(a: TextBlock): Point;
    bg(a: TextBlock): Thickness;
    ak(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected bh: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    r(a: number): string;
    bi(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    a1(): void;
    a0(): boolean;
    a2(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected bh: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bi(): void;
    protected n(): boolean;
    l(): boolean;
    protected q(dataItem_: any): string;
    r(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    a0(): void;
    d(): FontInfo;
    protected ay(): Thickness;
    at(): Brush;
    a1(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fn: XamDataChart;
    fr(a: any): void;
    protected ds(): void;
    d4(): void;
    fw: Brush;
    fs: Brush;
    ft: Brush;
    fv: Brush;
    fu: Brush;
    fp: number;
    fq: number;
    protected d1(): void;
    fo: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    s: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    ap(): void;
    j(): IExecutionContext;
    private h;
    protected get i(): IExecutionContext;
    d: DataContext;
    as(): void;
    getEffectiveViewport(): Rect;
    az(): void;
    aj(): void;
    get w(): DomRenderer;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected get_index(): number;
    get index(): number;
    protected aq(): void;
    undirty(a: boolean): void;
    private bw;
    au(): void;
    private bn;
    bq(): Brush;
    v: number;
    private u;
    protected a4(a: boolean): void;
    private br;
    protected bd(a: any, b: number, c: boolean): void;
    protected bg(a: any, b: number, c: boolean): void;
    protected aa(a: number, b: boolean): any;
    protected ab(a: number): any;
    protected ac(a: number): any;
    protected be(a: any, b: number): void;
    protected bh(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected bi(a: any, b: number): void;
    protected ba(a: boolean): void;
    protected bb(): void;
    protected bc(): void;
    private bm;
    protected bp(a: number): Brush;
    protected bo(): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    ax(): void;
    am(): void;
    an(): void;
    private f;
    g(): SeriesComponentsFromView;
    a9(a: Canvas): void;
    t(): boolean;
    aw(): void;
    av(): void;
    a7(): void;
    ah(): void;
    a8(): void;
    ai(): void;
    c(a: any): DataContext;
    protected k: RenderingContext;
    protected l: RenderingContext;
    ar(a: RenderingContext, b: RenderingContext): void;
    private bs;
    get bu(): Rect;
    set bu(a: Rect);
    bt: Rect;
    protected get_bv(): Rect;
    get bv(): Rect;
    private m;
    get q(): boolean;
    set q(a: boolean);
    ak(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ag(a: SeriesViewer): void;
    postRender(): void;
    protected a0(): void;
    b(a: number): DataContext;
    a2(a: RenderSurface): void;
    al(a: any): void;
    bj(): void;
    at(): void;
    ay(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    o(): boolean;
    protected r: boolean;
    bk(): void;
    a3(): void;
    protected af(): void;
    ao(): void;
    preRender(): void;
    isValid(): boolean;
    n: boolean;
    p: boolean;
    a1(a: RenderSurface): void;
    ad: string;
    bl(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected b1: MarkerSeries;
    private b5;
    private b7;
    private b6;
    constructor(a: MarkerSeries);
    as(): void;
    cg(): void;
    cq(): Size;
    cn(a: boolean): void;
    protected b4: List$1<Marker>;
    b0(): Marker;
    abstract cf(a: (arg1: Marker) => void): void;
    cj(a: Marker): void;
    cl(a: Marker): void;
    ck(a: Marker): void;
    b2(): boolean;
    ce(): void;
    b8(): void;
    cp(a: Marker): Rect;
    cb(a: string): void;
    cc(): void;
    b9(): void;
    cd(): void;
    ca(): void;
    cm(): void;
    b3: boolean;
    protected bh(a: any, b: number): void;
    private bx;
    protected bi(a: any, b: number): void;
    b(a: number): DataContext;
    private co;
    protected a5(a: RenderingContext, b: boolean): void;
    ch(a: HashPool$2<any, Marker>): void;
    ci(a: Pool$1<Marker>): void;
    by(a: Point): Marker;
    private bz;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
    private _axis;
    get axis(): Axis;
    set axis(a: Axis);
    private _oldMinimumValue;
    get oldMinimumValue(): number;
    set oldMinimumValue(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _oldMaximumValue;
    get oldMaximumValue(): number;
    set oldMaximumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
}
