import { EventArgs, Base, Type, Point, IList$1, IEnumerable, IEnumerator$1, IEnumerator, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeries } from "./CategorySeries";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { NumericAxisBase } from "./NumericAxisBase";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Rect } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { SeriesViewer } from "./SeriesViewer";
import { PointCollection } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IChartLegend } from "igniteui-react-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { RenderSurface } from "./RenderSurface";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Path } from "igniteui-react-core";
import { CategoryMode } from "./CategoryMode";
import { DependencyObject } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { IScaler } from "./IScaler";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { AnchoredCategoryBucketCalculator } from "./AnchoredCategoryBucketCalculator";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { ICategoryScaler } from "./ICategoryScaler";
import { IBucketizer } from "./IBucketizer";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { IBarSeries } from "./IBarSeries";
import { Color } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { DomRenderer } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ValuesHolder } from "./ValuesHolder";
import { PreparationParams } from "./PreparationParams";
import { RenderingContext } from "igniteui-react-core";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Canvas } from "igniteui-react-core";
import { Panel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class StackedSeriesCreatedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: StackedFragmentSeries);
    c: StackedFragmentSeries;
    get brush(): Brush;
    set brush(a: Brush);
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(a: Visibility);
    get outline(): Brush;
    set outline(a: Brush);
    get dashArray(): DoubleCollection;
    set dashArray(a: DoubleCollection);
    get dashCap(): PenLineCap;
    set dashCap(a: PenLineCap);
    get index(): number;
    get thickness(): number;
    set thickness(a: number);
    get title(): any;
    set title(a: any);
    get transitionDuration(): number;
    set transitionDuration(a: number);
    get transitionEasingFunction(): (time: number) => number;
    set transitionEasingFunction(a: (time: number) => number);
    get markerBrush(): Brush;
    set markerBrush(a: Brush);
    get markerOutline(): Brush;
    set markerOutline(a: Brush);
    get markerStyle(): Style;
    set markerStyle(a: Style);
    get markerTemplate(): DataTemplate;
    set markerTemplate(a: DataTemplate);
    get markerType(): MarkerType;
    set markerType(a: MarkerType);
    get markerThickness(): number;
    set markerThickness(a: number);
    get startCap(): PenLineCap;
    set startCap(a: PenLineCap);
    get endCap(): PenLineCap;
    set endCap(a: PenLineCap);
}
/**
 * @hidden
 */
export declare abstract class FragmentBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    constructor();
    vc: CategoryLineRasterizer;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    private ve;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dp(): boolean;
    protected get_dv(): boolean;
    jr(): string;
    he(): number;
    hi(): number;
    resolveLegendIndex(): number;
    bf(): Series;
    rs(): CategoryAxisBase;
    vb(): CategoryFramePreparer;
    sd(): NumericAxisBase;
    vg(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    s8(a: CategoryFrame, b: CategorySeriesView): void;
    pq(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private vh;
    vj(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    tu(a: CategorySeriesView): number;
    ap(a: Axis): AxisRange;
    vi(): number;
    vk(a: IChartLegend): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    mn(a: Rect, b: RenderSurface): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragment extends FragmentBase {
    static $t: Type;
    constructor();
    protected bx(): SeriesView;
    vl: AreaFragmentView;
    l2(a: SeriesView): void;
    protected get_de(): boolean;
    protected get_dd(): boolean;
    protected r3(): CategoryTransitionInMode;
    protected vn(a: Point, b: boolean): boolean;
    ex(a: Point, b: boolean): boolean;
    private vm;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k0(a: boolean, b: SeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    mw(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class ColumnFragment extends FragmentBase {
    static $t: Type;
    protected get_di(): boolean;
    protected get_d3(): boolean;
    protected gw(): number;
    protected r3(): CategoryTransitionInMode;
    constructor();
    protected bx(): SeriesView;
    vm: ColumnFragmentView;
    l2(a: SeriesView): void;
    vp: number;
    vq: number;
    get fragmentXAxis(): CategoryAxisBase;
    get fragmentYAxis(): NumericAxisBase;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    rs(): CategoryAxisBase;
    sd(): NumericAxisBase;
    protected get_c2(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    k0(a: boolean, b: SeriesView): void;
    ap(a: Axis): AxisRange;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    e8(): boolean;
    st(a: SeriesView): number;
    su(a: SeriesView): number;
    sv(a: SeriesView): number;
    pz(a: Point): Rect;
    ex(a: Point, b: boolean): boolean;
    protected e0(a: Point, b: boolean): boolean;
    protected vv(a: Rect, b: number): Rect;
    h1(a: any, b: Point): any;
    hv(a: Point): any;
    hh(a: Point): number;
    hf(a: Point): number;
    vg(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    private vo;
    mk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    s8(a: CategoryFrame, b: CategorySeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarFragment extends ColumnFragment {
    static $t: Type;
    constructor();
    protected get_dg(): boolean;
    protected get_d3(): boolean;
    protected get_di(): boolean;
    protected r3(): CategoryTransitionInMode;
    get barFragmentXAxis(): NumericXAxis;
    get barFragmentYAxis(): CategoryYAxis;
    rs(): CategoryAxisBase;
    protected get_isVertical(): boolean;
    f7(a: Point): number;
    sd(): NumericAxisBase;
    protected vv(a: Rect, b: number): Rect;
    pz(a: Point): Rect;
    ex(a: Point, b: boolean): boolean;
    vg(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    hv(a: Point): any;
    hh(a: Point): number;
    tu(a: CategorySeriesView): number;
    protected l7(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class StackedBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedBarBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    g(a: number): void;
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedColumnBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class FragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: FragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare class LineFragment extends FragmentBase {
    static $t: Type;
    protected get_d2(): boolean;
    constructor();
    protected bx(): SeriesView;
    vl: LineFragmentView;
    l2(a: SeriesView): void;
    protected vn(a: Point, b: boolean): boolean;
    protected get_de(): boolean;
    ex(a: Point, b: boolean): boolean;
    private vm;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k0(a: boolean, b: SeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class SplineFragmentBase extends SplineSeriesBase {
    static $t: Type;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    vv: CategoryLineRasterizer;
    constructor();
    private vx;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dp(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_dv(): boolean;
    jr(): string;
    pq(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private vz;
    he(): number;
    resolveLegendIndex(): number;
    hi(): number;
    bf(): Series;
    vh(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    ap(a: Axis): AxisRange;
    v0(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericYAxis, f: CategorySeriesView): void;
    s8(a: CategoryFrame, b: CategorySeriesView): void;
    vb(a: CategorySeriesView): number[][];
    vc(a: CategorySeriesView): number[][];
    vq(a: CategorySeriesView): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaFragment extends SplineFragmentBase {
    static $t: Type;
    constructor();
    protected bx(): SeriesView;
    l2(a: SeriesView): void;
    private v1;
    ac(): void;
    protected get_de(): boolean;
    protected get_dd(): boolean;
    protected get_eh(): boolean;
    protected r3(): CategoryTransitionInMode;
    protected v3(a: Point, b: boolean): boolean;
    ex(a: Point, b: boolean): boolean;
    private v2;
    v5: PointCollection;
    k0(a: boolean, b: SeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    mn(a: Rect, b: RenderSurface): void;
    v4(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    tu(a: CategorySeriesView): number;
    mw(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragment extends SplineFragmentBase {
    static $t: Type;
    protected get_eh(): boolean;
    constructor();
    protected bx(): SeriesView;
    v1: SplineFragmentView;
    l2(a: SeriesView): void;
    protected v3(a: Point, b: boolean): boolean;
    protected get_de(): boolean;
    ex(a: Point, b: boolean): boolean;
    private v2;
    k0(a: boolean, b: SeriesView): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: SplineFragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare abstract class StackedSeriesBase extends CategorySeries implements IIsCategoryBased {
    static $t: Type;
    constructor();
    ln(): void;
    protected get_dy(): boolean;
    getHostReferenceValue(): number;
    protected bx(): SeriesView;
    tr: StackedSeriesView;
    l2(a: SeriesView): void;
    l3(a: Rect, b: Rect): void;
    private _series;
    get series(): StackedSeriesCollection;
    set series(a: StackedSeriesCollection);
    hn(): number;
    ld(a: (arg1: Series) => boolean): void;
    ts: boolean;
    tu: boolean;
    protected get_isStacked(): boolean;
    seriesCreated: (sender: any, e: StackedSeriesCreatedEventArgs) => void;
    uh: Visibility;
    t0: number;
    tz: number;
    ti: number[];
    tj: number[];
    tq: StackedSeriesManager;
    tn: StackedSeriesCollection;
    get tm(): StackedSeriesCollection;
    private t6;
    private uc;
    private ub;
    mt(a: Point): void;
    rz(a: CategorySeriesView): CategoryFramePreparer;
    s8(a: CategoryFrame, b: CategorySeriesView): void;
    mm(a: boolean): void;
    k0(a: boolean, b: SeriesView): void;
    t7(): void;
    ud(): void;
    protected get_tt(): boolean;
    get tt(): boolean;
    eo(a: any): boolean;
    ap(a: Axis): AxisRange;
    qj(): boolean;
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tl(): CategorySeriesView;
    tx(): number;
    ty(): number;
    t2(a: StackedFragmentSeries): number;
    t1(a: Point): number;
    tv(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    private tw;
    t8(): void;
    tb(a: CategoryFrame, b: CategorySeriesView): void;
    ua(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    aq(a: Rect): AxisRange;
    mo(): void;
    protected t9(): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    protected es(): boolean;
    protected get_dp(): boolean;
    mn(a: Rect, b: RenderSurface): void;
    tk: CategoryFrame;
    mk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    hu(): any;
    get mayContainUnknowns(): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: CategoryAxisBase;
    protected get_c6(): boolean;
    protected get_ek(): boolean;
    bv(): SeriesPlotAreaMarginHorizontalMode;
    bw(): SeriesPlotAreaMarginVerticalMode;
    yAxis: NumericYAxis;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ag(): Axis[];
    sn(): boolean;
    mw(): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    ul(a: any): boolean;
    uk(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_dd(): boolean;
    constructor();
    ac(): void;
    protected bx(): SeriesView;
    uq: StackedAreaSeriesView;
    l2(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class VerticalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    rs(): CategoryAxisBase;
    sd(): NumericAxisBase;
    bv(): SeriesPlotAreaMarginHorizontalMode;
    bw(): SeriesPlotAreaMarginVerticalMode;
    aq(a: Rect): AxisRange;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_isVertical(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    sn(): boolean;
    protected l7(a: any, b: string, c: any, d: any): void;
    ul(a: any): boolean;
    uk(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedBarSeries extends VerticalStackedSeriesBase implements IBarSeries {
    static $t: Type;
    protected get_dg(): boolean;
    protected get_d3(): boolean;
    protected gw(): number;
    constructor();
    ac(): void;
    protected bx(): SeriesView;
    uq: StackedBarSeriesView;
    l2(a: SeriesView): void;
    ur: number;
    us: number;
    tl(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    sw(): number;
    tx(): number;
    ty(): number;
    ap(a: Axis): AxisRange;
    eo(a: any): boolean;
    fb(a: Rect, b: Rect, c: SeriesView): boolean;
    protected k3(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    hf(a: Point): number;
    hv(a: Point): any;
    ud(): void;
    t1(a: Point): number;
    tv(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    gc(): number;
    ua(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedColumnSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_di(): boolean;
    protected get_d3(): boolean;
    protected gw(): number;
    constructor();
    protected bx(): SeriesView;
    uq: StackedColumnSeriesView;
    l2(a: SeriesView): void;
    ur: number;
    us: number;
    tl(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ap(a: Axis): AxisRange;
    gc(): number;
    ua(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected l7(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    ur: boolean;
    protected gw(): number;
    protected get_dd(): boolean;
    protected get_eh(): boolean;
    constructor();
    ac(): void;
    protected bx(): SeriesView;
    uq: StackedSplineAreaSeriesView;
    l2(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected l7(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    ur: boolean;
    protected get_eh(): boolean;
    protected gw(): number;
    constructor();
    ac(): void;
    protected bx(): SeriesView;
    uq: StackedSplineSeriesView;
    l2(a: SeriesView): void;
    ap(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedFragmentSeries extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    itemsSource: IEnumerable;
    kg: Brush;
    kb: Brush;
    kp: DoubleCollection;
    ko: DoubleCollection;
    kt: PenLineCap;
    kq: PenLineCap;
    at: boolean;
    ak: boolean;
    bz: number;
    bg: number;
    kn: Color;
    km: Color;
    a3: boolean;
    aq: boolean;
    b0: number;
    bh: number;
    b1: number;
    bi: number;
    ku: PenLineCap;
    kr: PenLineCap;
    au: boolean;
    al: boolean;
    hb: DataTemplate;
    g8: DataTemplate;
    hc: DataTemplate;
    g9: DataTemplate;
    ld: Visibility;
    lb: Visibility;
    r: LegendItemBadgeShape;
    p: LegendItemBadgeMode;
    q: LegendItemBadgeShape;
    o: LegendItemBadgeMode;
    kh: Brush;
    kc: Brush;
    ki: Brush;
    kd: Brush;
    la: Style;
    k9: Style;
    hd: DataTemplate;
    ha: DataTemplate;
    x: MarkerType;
    w: MarkerType;
    t: MarkerFillMode;
    s: MarkerFillMode;
    v: MarkerOutlineMode;
    u: MarkerOutlineMode;
    eo: string;
    bw: number;
    bd: number;
    kj: Brush;
    ke: Brush;
    kk: Brush;
    kf: Brush;
    bk: number;
    a9: number;
    bu: number;
    bb: number;
    aa: SeriesOutlineMode;
    z: SeriesOutlineMode;
    bt: number;
    ba: number;
    bx: number;
    be: number;
    am: boolean;
    av: boolean;
    by: number;
    bf: number;
    kv: PenLineCap;
    ks: PenLineCap;
    b2: number;
    bj: number;
    bv: number;
    bc: number;
    ch: any;
    ci: any;
    cd: any;
    ah: (time: number) => number;
    cb: number;
    cc: number;
    ai: (time: number) => number;
    n: CategoryTransitionInMode;
    aw: boolean;
    ad: TransitionInSpeedType;
    an: boolean;
    b5: number;
    m: CategoryTransitionInMode;
    ac: TransitionInSpeedType;
    ag: (time: number) => number;
    af: (time: number) => number;
    b4: number;
    a2: boolean;
    ap: boolean;
    a1: boolean;
    ao: boolean;
    fi: string;
    fe: string;
    fg: string;
    du: string;
    dw: string;
    ce(a: number, b: number): any;
    le: Visibility;
    lc: Visibility;
    private _parentSeries;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    ca: number;
    ae: SeriesViewer;
    aj: IFastItemColumn$1<number>;
    private _visualSeriesLink;
    get visualSeriesLink(): AnchoredCategorySeries;
    set visualSeriesLink(a: AnchoredCategorySeries);
    a6: List$1<number>;
    a7: List$1<number>;
    a5: List$1<number[]>;
    ay: boolean;
    b6(a: Point): number;
    cf(a: Point): any;
    b9(a: Point, b: boolean): number;
    b8(a: Point, b: boolean): number;
    br(a: Point, b: boolean, c: boolean): number;
    k1(a: Point, b: boolean, c: boolean): Point;
    k5(a: Point): Rect;
    j(a: Point): Rect[];
    k6(a: Point): Rect;
    k(a: Point): Rect[];
    k7(a: Point): Rect;
    k8(a: Point): Rect;
    bn(a: Point, b: boolean, c: boolean): number;
    kx(a: Point, b: boolean, c: boolean): Point;
    bp(a: Point, b: boolean, c: boolean): number;
    kz(a: Point, b: boolean, c: boolean): Point;
    k2(a: Point, b: boolean, c: boolean): Point;
    bs(a: Point, b: boolean, c: boolean): number;
    ky(a: Point, b: boolean, c: boolean): Point;
    bo(a: Point, b: boolean, c: boolean): number;
    k0(a: Point, b: boolean, c: boolean): Point;
    bq(a: Point, b: boolean, c: boolean): number;
    b7(a: Point): number;
    bm(): number;
    bl(a: Point): number;
    cg(a: Point): any;
    ar(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    k3(a: Point): Point;
    kw(a: Point): Point;
    az(a: any): boolean;
    k4(): Rect;
    fm(): void;
    fr(a: Point): void;
    a0(a: Point, b: boolean): boolean;
    fl(a: Point): void;
    b3: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    kl: Brush;
    g7(): void;
    ge(): void;
    gg(): void;
    ft(): void;
    fu(): void;
    fx(): void;
    gk(): void;
    ga(): void;
    fv(): void;
    fy(): void;
    gn(): void;
    go(): void;
    g3(): void;
    gp(): void;
    gq(): void;
    fw(): void;
    fz(): void;
    f5(): void;
    f6(): void;
    f7(): void;
    f4(): void;
    f3(): void;
    f8(): void;
    gb(): void;
    gd(): void;
    gh(): void;
    gi(): void;
    gj(): void;
    f2(): void;
    fs(): void;
    f0(): void;
    gl(): void;
    gm(): void;
    gr(): void;
    gs(): void;
    gf(): void;
    gu(): void;
    gw(): void;
    gv(): void;
    gy(): void;
    gz(): void;
    g0(): void;
    f1(): void;
    gx(): void;
    g2(): void;
    gt(): void;
    f9(): void;
    gc(): void;
    g1(): void;
    g5(): void;
    g4(): void;
    g6(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected fp(a: string, b: any, c: any): void;
    private a4;
    private as;
    private ax;
    protected fn(a: any, b: string, c: any, d: any): void;
    fq(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSeriesCollection extends ObservableCollection$1<StackedFragmentSeries> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesFramePreparer extends CategoryFramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected j(a: PreparationParams): ValuesHolder;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: AreaFragment;
    as(): void;
    constructor(a: AreaFragment);
    dg: Path;
    di: Path;
    dh: Path;
    dj: Path;
    dc: Path;
    de: Path;
    dd: Path;
    df: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class ColumnFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: ColumnFragment;
    as(): void;
    constructor(a: ColumnFragment);
    protected de: List$1<Rectangle>;
    db: Pool$1<Rectangle>;
    dc: List$1<number>;
    dd: List$1<number>;
    private dk;
    private df;
    private dh;
    private dg;
    protected be(a: any, b: number): void;
    di(a: Rectangle, b: number, c: number): void;
    protected bf(a: any, b: number): void;
    protected ac(a: number): any;
    private dj;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
}
/**
 * @hidden
 */
export declare class LineFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: LineFragment;
    constructor(a: LineFragment);
    dg: Path;
    df: Path;
    dh: Path;
    dd: Path;
    dc: Path;
    de: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineAreaFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    private dc;
    as(): void;
    constructor(a: SplineAreaFragment);
    di: Path;
    dk: Path;
    dj: Path;
    dl: Path;
    de: Path;
    dg: Path;
    df: Path;
    dh: Path;
    dd(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    dc: SplineFragment;
    constructor(a: SplineFragment);
    cs(): CategoryBucketCalculator;
    di: Path;
    dh: Path;
    dj: Path;
    df: Path;
    de: Path;
    dg: Path;
    dd(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesView extends CategorySeriesView {
    static $t: Type;
    c0: StackedSeriesBase;
    private readonly c1;
    get c2(): Canvas;
    private readonly c3;
    get c4(): Panel;
    constructor(a: StackedSeriesBase);
    cs(): CategoryBucketCalculator;
    ap(): void;
    ar(a: RenderingContext, b: RenderingContext): void;
    protected af(): void;
}
/**
 * @hidden
 */
export declare class StackedBarSeriesView extends StackedSeriesView {
    static $t: Type;
    c5: StackedBarSeries;
    constructor(a: StackedBarSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedColumnSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedColumnSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedAreaSeries);
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineAreaSeries);
    as(): void;
    c5(): number;
}
/**
 * @hidden
 */
export declare class StackedSplineSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineSeries);
    as(): void;
    c5(): number;
}
/**
 * @hidden
 */
export declare class StackedSeriesManager extends Base {
    static $t: Type;
    constructor(a: StackedSeriesBase);
    b: StackedSeriesBase;
    f: ObservableCollection$1<AnchoredCategorySeries>;
    c: StackedSeriesCollection;
    e: ObservableCollection$1<AnchoredCategorySeries>;
    d: ObservableCollection$1<AnchoredCategorySeries>;
    j: Canvas;
    k: Panel;
    a(a: StackedFragmentSeries): AnchoredCategorySeries;
    private i;
    h(a: boolean): void;
    private g;
}
