import { DataSourceSummaryOperand } from "igniteui-react-core";
import { IgrProvideCalculatorEventArgs } from "igniteui-react-core";
import { ChartSummaryDescription as ChartSummaryDescription_internal } from "./ChartSummaryDescription";
/**
 * Represents a summary that is applied to a datasource. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgrChartSummaryDescription {
    protected createImplementation(): ChartSummaryDescription_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ChartSummaryDescription_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get field(): string;
    set field(v: string);
    get operand(): DataSourceSummaryOperand;
    set operand(v: DataSourceSummaryOperand);
    /**
     * Gets or sets an alias for the summary. Currently only used in aggregated data situations.
    */
    get alias(): string;
    set alias(v: string);
    /**
     * Gets or sets the name to use when displaying the calculator name.
    */
    get calculatorDisplayName(): string;
    set calculatorDisplayName(v: string);
    findByName(name: string): any;
    equals(other: any): boolean;
    private _provideCalculator;
    private _provideCalculator_wrapped;
    /**
     * Called when the summary calculator is required.
    */
    get provideCalculator(): (s: IgrChartSummaryDescription, e: IgrProvideCalculatorEventArgs) => void;
    set provideCalculator(ev: (s: IgrChartSummaryDescription, e: IgrProvideCalculatorEventArgs) => void);
}
