import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { IgrItemwiseStrategyBasedIndicator, IIgrItemwiseStrategyBasedIndicatorProps } from "./igr-itemwise-strategy-based-indicator";
import { MarketFacilitationIndexIndicator } from "./MarketFacilitationIndexIndicator";
/**
 * Represents a IgxDataChartComponent Market Facilitation Index indicator series.
 * The Market Facilitation Index (MFI) indicator is represented by
 * the difference of the high and the low for a bar divided by the volume.
 * Default required members: High, Low, Volume
*
* The Market Facilitation Index (MFI) indicator is represented by the difference of the high and the low for a bar divided by the volume.
*
* Example:
*/
export declare class IgrMarketFacilitationIndexIndicator extends IgrItemwiseStrategyBasedIndicator<IIgrMarketFacilitationIndexIndicatorProps> {
    protected createImplementation(): MarketFacilitationIndexIndicator;
    /**
                                 * @hidden
                                 */
    get i(): MarketFacilitationIndexIndicator;
    constructor(props: IIgrMarketFacilitationIndexIndicatorProps);
    /**
     * Gets default display type for the current Financial Indicator
    */
    get defaultDisplayType(): IndicatorDisplayType;
}
export interface IIgrMarketFacilitationIndexIndicatorProps extends IIgrItemwiseStrategyBasedIndicatorProps {
}
