import { IgrPolarLineSeriesBase, IIgrPolarLineSeriesBaseProps } from "./igr-polar-line-series-base";
import { PolarSplineAreaSeries } from "./PolarSplineAreaSeries";
/**
 * Represents a IgxDataChartComponent polar spline area series.
*/
export declare class IgrPolarSplineAreaSeries extends IgrPolarLineSeriesBase<IIgrPolarSplineAreaSeriesProps> {
    protected createImplementation(): PolarSplineAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): PolarSplineAreaSeries;
    constructor(props: IIgrPolarSplineAreaSeriesProps);
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline(): boolean;
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness(): number;
    set stiffness(v: number);
}
export interface IIgrPolarSplineAreaSeriesProps extends IIgrPolarLineSeriesBaseProps {
    /**
     * Gets or sets the Stiffness property.
    */
    stiffness?: number | string;
}
