import { UnknownValuePlotting } from "igniteui-react-core";
import { IgrAnchoredRadialSeries, IIgrAnchoredRadialSeriesProps } from "./igr-anchored-radial-series";
import { RadialAreaSeries } from "./RadialAreaSeries";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export declare class IgrRadialAreaSeries extends IgrAnchoredRadialSeries<IIgrRadialAreaSeriesProps> {
    protected createImplementation(): RadialAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): RadialAreaSeries;
    constructor(props: IIgrRadialAreaSeriesProps);
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting(): UnknownValuePlotting;
    set unknownValuePlotting(v: UnknownValuePlotting);
}
export interface IIgrRadialAreaSeriesProps extends IIgrAnchoredRadialSeriesProps {
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting?: UnknownValuePlotting | string;
}
