import { IgSize } from "igniteui-react-core";
import { IgPoint } from "igniteui-react-core";
import { IgrRingSeriesBase } from "./igr-ring-series-base";
import { Ring as Ring_internal } from "./Ring";
/**
 * Represents data for
 * Ring.RingControl element.
*/
export declare class IgrRing {
    protected createImplementation(): Ring_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Ring_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the index of ring in the chart.
    */
    get index(): number;
    set index(v: number);
    /**
     * Gets the inner extend of the ring in percentage.
    */
    get innerExtend(): number;
    set innerExtend(v: number);
    /**
     * Gets the size of the ring.
    */
    get controlSize(): IgSize;
    set controlSize(v: IgSize);
    /**
     * Gets the center point of the ring.
    */
    get center(): IgPoint;
    set center(v: IgPoint);
    /**
     * Gets reference to ring series.
    */
    get ringSeries(): IgrRingSeriesBase;
    set ringSeries(v: IgrRingSeriesBase);
    /**
     * Gets the ring breadth.
    */
    get ringBreadth(): number;
    set ringBreadth(v: number);
    findByName(name: string): any;
    /**
     * Renders the arcs.
    
    */
    renderArcs(): boolean;
    /**
     * Prepares data needed to create
     * Arcs.
    
    */
    prepareArcs(): void;
}
