import { IgrHorizontalStackedSeriesBase, IIgrHorizontalStackedSeriesBaseProps } from "./igr-horizontal-stacked-series-base";
import { StackedSplineSeries } from "./StackedSplineSeries";
/**
 * Represents a IgxDataChartComponent stacked spline series.
*/
export declare class IgrStackedSplineSeries<P extends IIgrStackedSplineSeriesProps = IIgrStackedSplineSeriesProps> extends IgrHorizontalStackedSeriesBase<P> {
    protected createImplementation(): StackedSplineSeries;
    /**
                                 * @hidden
                                 */
    get i(): StackedSplineSeries;
    constructor(props: P);
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    get isSplineShapePartOfRange(): boolean;
    set isSplineShapePartOfRange(v: boolean);
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline(): boolean;
}
export interface IIgrStackedSplineSeriesProps extends IIgrHorizontalStackedSeriesBaseProps {
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    isSplineShapePartOfRange?: boolean | string;
}
